unit AcqSADlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, spin, ExtCtrls, sysutils, Grids, Dialogs, ComCtrls,
  maths, gtiutil, uniteker, gtidef, graphe, gtimain, tradFormU, constgti;

type
  TAcqSortieAnaDlg = class(TtradForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    SortieRG: TRadioGroup;
    DebutGB: TGroupBox;
    DebutSAScroll: TScrollBar;
    EditDebutSA: TEdit;
    FinGB: TGroupBox;
    FinSAScroll: TScrollBar;
    EditFinSA: TEdit;
    GroupBox1: TGroupBox;
    EditNomSA: TEdit;
    Oscillo: TPaintBox;
    HelpBtn: TBitBtn;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    NrampeSE: TSpinEdit;
    Label2: TLabel;
    rampeSE: TSpinEdit;
    ContinuCB: TCheckBox;
    procedure DebutSAScrollChange(Sender: TObject);
    procedure FinSAScrollChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SortieRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure NrampeSEChange(Sender: TObject);
    procedure rampeSEChange(Sender: TObject);
    procedure ContinuCBClick(Sender: TObject);
  private
    grapheImpulsion : Tgraphe;
    paintActif,activation : boolean;
  public
  end;

var
  AcqSortieAnaDlg: TAcqSortieAnaDlg;

implementation

{$R *.DFM}

procedure TAcqSortieAnaDlg.DebutSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     DebutSortie[rampeSE.value] := DebutSAScroll.position;
     EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
     if (rampeSE.value>1) and continuCB.Checked then
          FinSortie[rampeSE.value-1] := DebutSortie[rampeSE.value];
     oscillo.refresh;
end end;

procedure TAcqSortieAnaDlg.FinSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     FinSortie[rampeSE.value] := FinSAScroll.position;
     EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
     if (rampeSE.value<rampeSE.MaxValue) and continuCB.Checked then
          DebutSortie[rampeSE.value+1] := FinSortie[rampeSE.value];
     oscillo.refresh;
end end;

procedure TAcqSortieAnaDlg.OKBtnClick(Sender: TObject);
begin
     with sortieAnalogique do begin
        Active := true;
        expression := '';
        NbreRampes := NrampeSE.value;
        Mini := ValeurVolt(0);
        Maxi := ValeurVolt(MaxiHardSA);
        Nom := EditNomSA.text;
        Sai := ansiChar(ord('0')+sortieRG.itemIndex);
        if nom='' then nom := 'SA'+SAi;
        if SAi='0' then tension := positive else tension := NegAndPos;
        PasSortie := 1;
        ModeSA := SArampe;
        if expression=''
           then etalonnage := eNone
           else etalonnage := eNonLin;
        calcVecteur;
     end;
end;

procedure TAcqSortieAnaDlg.FormActivate(Sender: TObject);
begin
     activation := true;
     with sortieAnalogique do begin
        NrampeSE.value := NbreRampes;
        rampeSE.MaxValue := NbreRampes;        
        rampeSE.value := 1;
        FinSAScroll.position := FinSortie[1];
        EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
        DebutSAScroll.position := DebutSortie[1];
        EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
        EditNomSA.text := nom;
        SortieRG.itemIndex := ord(SAi)-ord('0');
     end;
     activation := false;
     oscillo.refresh;
end;

procedure TAcqSortieAnaDlg.OscilloPaint(Sender: TObject);
var i : integer;
begin
if activation then exit;
with grapheImpulsion,sortieAnalogique do begin
     PaintActif := true;
     case sortieRG.itemIndex of
          0 : begin
              miniY := 0;
              maxiY := +5;
          end;
          1 :  begin
              miniY := -5;
              maxiY := +5;
          end;
          2 : begin
              miniY := -30;
              maxiY := +30;
          end;
     end;
     limiteFenetre := rect(0,0,oscillo.width-1,oscillo.height-1);
     calcVecteur;
     NbrePoints := NbreInterSA;
     for i := 0 to pred(NbrePoints) do
         vecteurY[i] := vecteurAff[i];
     grapheImpulsion.draw(Utemps.formatUnite(NbreInterSA*baseDeTemps.deltat));
     PaintActif := false;
end end;

procedure TAcqSortieAnaDlg.FormCreate(Sender: TObject);
var i : integer;
begin
     GrapheImpulsion := Tgraphe.create;
     rampeSE.maxValue := NbreRampeMax;
     with GrapheImpulsion do begin
         for i := 0 to NbreMaxSA do vecteurX[i] := i;
         y0 := 0;
         canvas := oscillo.canvas;
     end;
end;

procedure TAcqSortieAnaDlg.SortieRGClick(Sender: TObject);
begin
    if not activation then with sortieAnalogique do begin
       Sai := ansiChar(ord('0')+SortieRG.itemIndex);
       EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
       EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
       oscillo.refresh
    end;
end;

procedure TAcqSortieAnaDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(16)
end;

procedure TAcqSortieAnaDlg.NrampeSEChange(Sender: TObject);
begin
  rampeSE.Visible := nRampeSE.value>1;
  rampeSE.maxValue := nRampeSE.value;
  if rampeSE.value>rampeSE.maxValue then rampeSE.value := rampeSE.maxValue;   
  sortieAnalogique.NbreRampes := NrampeSE.value;
  oscillo.refresh;
end;

procedure TAcqSortieAnaDlg.rampeSEChange(Sender: TObject);
begin with sortieAnalogique do begin
  if (RampeSE.value>1) and continuCB.checked
      then debutSortie[RampeSE.value] := finSortie[RampeSE.value-1];
  debutSAscroll.Position := debutSortie[RampeSE.value];
  finSAscroll.Position := finSortie[RampeSE.value];
  oscillo.Refresh;
end end;

procedure TAcqSortieAnaDlg.ContinuCBClick(Sender: TObject);
var i : integer;
begin with sortieAnalogique do begin
     if continuCB.Checked then
        for i := 2 to NrampeSE.value do
            DebutSortie[i] := FinSortie[i-1];
     oscillo.Refresh;       
end end;

end.
