procedure TgtiMainForm.RegleTimer;
var CodeDeltat : shortString;
    CodeMoyenne : shortString;
    NbreMesure,NbreMesureMax : integer;

Procedure AffecteDeltatSA;
const mmax = 32767;
      emax = 4;  
var m : longInt;
    e : byte;
begin
// base de temps 10 s
// deltat en 10s = m*dix(e) + nombreVoie+1
// +1 = sortie analogique
     m := round(BaseDeTemps.deltat*1.0E5-NbreVoie-1);
     if m<0 then m := 0;
// m de 0  mmax et e de 0  4
     e := 0;
     while (m>mmax) and (e<emax) do begin
          inc(e);
          m := m div 10;
     end;
     if m>mmax then m := mmax;
     codeDeltat := ' '+intToStr(m)+' '+IntToStr(e)+' 10';
     with BaseDeTemps do begin
         deltat := m*dix(e)+nbreVoie+1;
         grapheGTI.CoeffInterp := 1/deltat;
         deltat := deltat*1.0E-5;
     end;
end;

Procedure AffecteCodeDeltat;
const mmax = 65535;
      emax = 4;
      tmax = 655;
      tmin = 1;
var m,t,e : longInt;
    a : integer;
begin
// deltat = (m*dix(e)+nombreVoie)*t*10s
     BaseDeTemps.deltat := BaseDeTemps.deltat*1E5;
     m := 0;
     e := 0;
     t := trunc(BaseDeTemps.deltat/NbreVoie);
     if t<tmin then t := tmin;
     if t>tmax then begin
         if t>10*tmax
            then t := 500 // 5 ms
            else t := 100; // 1 ms  
         m := round((BaseDeTemps.deltat/t-NbreVoie));
         if m<0 then m := 0;
    { m de 0  mmax=65535 et e de 0  emax=4 }
         e := 0;
         while (m>mmax) and (e<emax) do begin
            inc(e);
            m := m div 10;
         end;
         if m>mmax then m := mmax;
     end;
     codeDeltat := ' '+intToStr(m)+' '+intToStr(e)+' '+IntToStr(t*10);
     with BaseDeTemps do begin
        deltat := (m*dix(e)+NbreVoie)*t;
        grapheGTI.CoeffInterp := t/deltat;
        deltat := deltat*1.0E-5;
     end;
     a := trunc(ln(t)/ln(2))-1-NbreVoie;
// Moyenne sur t/2*NbreVoie : t en 10 s, moyenne en 5 s;
// maxi a=7 soit moyenne sur 128 valeurs }
     if a>7 then a := 7;
     if a>2 then CodeMoyenne := ' M '+intToStr(a);
end;

Procedure AffecteDeltatPreAcq;
const tmax = 6553;
      tmin = 10;
var t : longInt;
begin
// base de temps 1 s ; deltat en s = t*nombreVoie 
     t := round(BaseDeTemps.deltat*1.0E6/NbreVoie);
     if t>tmax then t := tmax;
     if t<tmin then t := tmin;
     codeDeltat := ' 0 0 '+IntToStr(t);
     BaseDeTemps.deltat := t*1e-6*NbreVoie;
     grapheGTI.CoeffInterp := 1/NbreVoie;
     with BaseDeTemps do begin
          PreAcqExact := ((NbreInter*PreAcq10 div 10) div NbreVoie)*NbreVoie;
          ordreProgramme := 'YPE '+intToStr(NbreMesure-PreAcqExact)+codeDeltat;
     end;     
end;

var voie : indiceVoie;
    NmaxGTI : integer;
begin with grapheGti do begin
   if (modeAcq=AcqSA) then begin
       timer.interval := round(baseDeTemps.deltat*1000);
       Gauge.Max := pred(NbreInter);
       exit;
   end;
   if NbreInter>NbreInterMax then NbreInter := NbreInterMax;
   NmaxGTI := MaxResulGTI div nbreVoie;
   if NbreInter>NmaxGTI then NbreInter := NmaxGTI;
   NbreMesure := NbreInter*NbreVoie;
   NbreMesureMax := NbreMesure;
   NbreInterPlus := NbreInter;
   CodeMoyenne := '';
   BaseDeTemps.PreAcqExact := 0;
   case modeTemporel of
      mRapide : begin
         for voie := voieA to VoieAnaMax do if voieOrphy[voie].active then begin
            ordreProgramme := 'YEARAP '+voieOrphy[voie].codeVoie+' '+IntToStr(NbreMesure);
            break;
         end
      end;
      mNormal : begin
         if baseDeTemps.preAcq10>0
            then AffecteDeltatPreAcq
            else begin
               if SortieAnalogique.active or SortieBinaire.active
                  then AffecteDeltatSA
                  else begin
                     AffecteCodeDeltat;
                     if monocoup then begin
                         NbreMesureMax := MaxResulGTI;
                         NbreInterPlus := MaxResulGTI div NbreVoie;
                     end;
                  end;
                  ordreProgramme := 'YPE '+intToStr(NbreMesureMax)+codeDeltat;
            end;
         for voie := voieA to VoieAnaMax do with voieOrphy[voie] do
             if active then ordreProgramme := ordreProgramme + ' A'+codeVoie;
         with SortieAnalogique do if active then
              ordreProgramme := ordreProgramme+' S '+SAi+' 0 '+intToStr(pred(NbreInterSA));
         with SortieBinaire do if active then begin
             ordreProgramme := ordreProgramme+' O 0 ';
             if ModeSB=sbRampe
                then ordreProgramme := ordreProgramme+intToStr(masque)
                else ordreProgramme := ordreProgramme+intToStr(pred(NbreInterSB));
         end;
         if EntreeBinaire.active then
             ordreProgramme := ordreProgramme+' I';
         OrdreProgramme := OrdreProgramme+codeMoyenne;
      end;
      mLent : begin
      end;
   end;   
   case modeSynchro of
       s_front : ordreLance := 'YGO F '+char(front+ord('0'));
       s_seuil : ordreLance := 'YGO A '+voieOrphy[voieSynchro].codeVoie+' '+
                     codeMontant[montant]+' '+intToStr(seuilSynchro)+
                     ' 256 0';
       else ordreLance := 'YGO I';
   end;
   OrdreResul := 'YRESUL! 0 '+IntToStr(pred(NbreMesure));
   BaseDeTemps.DureeBalayage := BaseDeTemps.deltat*NbreInter;
   Gauge.Max := pred(NbreInter);
end end; // regleTimer

Procedure TgtiMainForm.LanceAcqSA;
begin
    etatAcq := eaTemporelLent;
    EcritOrphy(sortieAnalogique.CodeSortie(0));
    grapheGTI.NbreAff := 0;
    grapheGTI.NbreCourant := 0;
    gauge.position := 0;
    setBoutons;
    EnregistreBtn.enabled := false;
    stopBtn.enabled := true;
end;

Procedure TgtiMainForm.LanceAcqTemps;

Procedure YteleSA;

Procedure Envoie(debut,fin : integer);
var i : integer;
begin with sortieAnalogique do begin
     if fin<debut+128
        then begin
           VoieSerie.OutPut := 'YTELE '+SAi+' '+intToStr(debut);
           for i := debut to fin do
               VoieSerie.OutPut := ' '+IntToStr(vecteurCourant[i]);
           VoieSerie.OutPut := crCR;
           repeat until voieSerie.outBuffUsed=0;
        end
        else begin
            envoie(debut,debut+127);
            envoie(debut+128,fin);
        end
end end;

begin with sortieAnalogique do begin
     WaitPanel.visible := true;
     WaitPanel.UpDate;
     envoie(0,pred(NbreInterSA));
     modif := false;
     ecritOrphy(CodeSortie(0));
     WaitPanel.visible := false;
end end;

Procedure YteleSB;

Procedure Envoie(debut,fin : integer);
var i : integer;
begin with sortieBinaire do begin
     if fin<debut+128
        then begin
           VoieSerie.OutPut := 'YTELE 5 '+intToStr(debut);
           for i := debut to fin do
               VoieSerie.OutPut := ' '+IntToStr(round(vecteurCourant[i]));
           VoieSerie.OutPut := crCR;
           repeat until voieSerie.outBuffUsed=0;
        end
        else begin
            envoie(debut,debut+127);
            envoie(debut+128,fin);
        end
end end;

begin with sortieBinaire do begin
     WaitPanel.visible := true;
     WaitPanel.UpDate;
     envoie(0,pred(NbreInterSB));
     modif := false;
     ValeurCourante := vecteurCourant[0];
     WaitPanel.visible := false;
end end;

Procedure setParametreTriggerAvail;
var voie : indiceVoie;
begin
    if preAcqEnCours
       then setYasc(true)
       else setYbin;
    etatAcq := eaAttenteResul;
    GrapheGti.NbreCourant := 0;
    Gauge.position := 0;
    ChaineLue := '';
    voieDebut := voieA;
    while (voieDebut<=voieEB) and not(grapheGti.VoieOrphy[VoieDebut].active)
          do inc(VoieDebut);
    voieCourante := voieDebut;
    for voie := voieEB downto voieA do begin
        VoieSuivante[voie] := voieCourante;
        if grapheGti.VoieOrphy[voie].active then
           voieCourante := voie;
    end;
    EnregistreBtn.enabled := false;
    stopBtn.enabled := true;
end;

const
    codeSens : array[boolean] of char = ('1','0');
    OrdrePreAcq1 = 'YUTIL 5 I 39824';
    OrdrePreAcq2 = 'YUTIL 6 I 40448';
    OrdreLancePreAcq = 'YUTIL 7 C 40960 D 1';
begin // LanceAcqTemps
    if not modeDeconnecte then debutAcquisition := now;
         // test ncessaire ?
    grapheGTI.ListeRepere.Clear;
    timer.enabled := false;
    if PreAcqEnCours
       then HaltPreAcquisition
       else voieSerie.flushInBuffer;
    preAcqEnCours := baseDeTemps.preAcq10>0;
    if preAcqEnCours
       then begin
          if not UtilSeuilCharge then chargeUtil(true,false)
       end
       else begin
          with sortieAnalogique do
               if active and
                  modif and
                  (grapheGTI.modeAcq<>AcqSA) then YteleSA;
          with sortieBinaire do if active and modif then YteleSB;
       end;
    setParametreTriggerAvail;
    regleTimer;
    if preAcqEnCours
       then begin
            with grapheGTI do OrdreParamPreAcq := 'YTELE G 0 '+codeSens[montant]+' '+
              intToStr(seuilSynchro)+' '+
              intToStr(BaseDeTemps.PreAcqExact);
            ecritOrphy(ordreParamPreAcq);
            ecritOrphy(ordreProgramme);
            ecritOrphy(ordrePreAcq1);
            sleep(50);
            ecritOrphy(ordrePreAcq2);
            sleep(50);
            ecritOrphy(ordreLancePreAcq);
       end
       else if modeTemporel=mLent
           then begin
               etatAcq := eaTemporelLent;
               NbreAffNul;
               YpeActif := false;
           end
           else begin
               YpeActif := true;
               ecritOrphy(ordreProgramme);
               if modeTemporel=mNormal then ecritOrphy(ordreLance);
               ecritOrphy(ordreResul);
           end;
    timer.enabled := true;
    YPEtime := time;
end; // LanceAcqTemps 

Procedure TgtiMainForm.LanceAcqMagnum;
begin
    grapheGTI.ListeRepere.Clear;
    with grapheGTI.voieOrphy[voieMagnum] do begin
        maxi := +64*PeriodeMagnumE;
        mini := -maxi;
    end;
    timer.enabled := false;
    setYbin;
    etatAcq := eaAttenteStopMag;
    Gauge.position := 0;
    ChaineLue := '';
    if MagnumAutoCB.checked
       then BaseDeTemps.dureeBalayage := MagnumSE.value
       else BaseDeTemps.dureeBalayage := 2;
    magnum.attente := MagnumSE.value;
    EnregistreBtn.enabled := false;
    stopBtn.enabled := false;
    if ChuteMagnum
       then ecritOrphy('YCHUTE '+magnum.EFi)
       else ecritOrphy('YMAG '+magnum.EFi);
    timer.enabled := true;
    if magnumStopDlg=nil then
       Application.createForm(TmagnumStopDlg,magnumStopDlg);
    MagnumStopDlg.show;
end; // LanceAcqMagnum 

Function TgtiMainForm.litFrequence : double;
var Fgti : word;

Procedure MajEF0;
var changement : boolean;
begin with frequence do begin
     changement := false;
     if modeEF0='H'
        then begin
           if Fgti<1024 then begin
              diviseur := diviseur div ((1024 div Fgti)+1);
              if diviseur<1 then begin
                 dureeComptage := 32;
                 ModeEF0 := 'F';
              end;
              changement := true;
           end;
           if (Fgti>32000) and (diviseur<=128) then begin
               changement := true;
               diviseur := diviseur*2;
           end;
           if EFi='1' then diviseur := 1;
        end
        else begin { mode 'F' }
             if Fgti<1024 then begin
                dureeComptage := (dureeComptage*1024) div Fgti;
                if dureeComptage>32 then begin
                      ModeEF0 := 'H';
                      diviseur := 1;
                end;
                changement := true;
             end;
             if (Fgti>32000) and (dureeComptage>1) then begin
                 dureeComptage := dureeComptage div 2;
                 changement := true;
             end;
        end;
     if changement then begin
         if ModeEF0='H'
            then dureeComptage := 1
            else diviseur := 1;
         voieSerie.output := 'YCONFEF '+EFi+' '+ModeEF0+' '+IntToStr(dureeComptage)+' '+IntToStr(diviseur)+crCR;
         sleep(50);
         Fgti := getValeurAsc('YCPT '+EFi);
// pour rien car premire valeur fausse
     end;
end end; // MajEF0

begin with frequence do begin
     try
     Fgti := getValeurAsc('YCPT '+frequence.EFi);
     except
     { lecture en cours ou Pb => priode trop longue }
     Fgti := 0;
     end;
     if ModeEF0='M'
        then if decrementer
             then result := valeurCourante-Fgti*increment
             else result := valeurCourante+Fgti*increment
        else if Fgti<>0
          then begin
             if ModeEF0='H'
                then result := 1/(Fgti*DeltaHorloge*diviseur)
                else result := Fgti*100.0/dureeComptage;
// acquisition sur EF0 pendant dureeComptage en unit 10 ms
             MAJEF0;
          end
          else result := sansSignif;
end end; { LitFrequence }

procedure TgtiMainForm.LitPointAttente;

Procedure LitMinMax;
var valeurMin,valeurMax : array[indiceVoie] of integer;

procedure GetValeur(commande : shortString);
var position,voie,nbreVirgule : integer;
    Timer : EventTimer;
    chaineLoc : shortString;
    valeur : integer;
begin
    lectureMinMaxTerminee := false;
    chaineLue := '';
    videBuffers;
    VoieSerie.output := commande+crCR;
    newTimer(timer,6);
    repeat
        application.processMessages
    until lectureMinMaxTerminee or timerExpired(timer);
    position := 1;
    chaineLoc := '';
    nbreVirgule := 1;
    voie := 0;
    while (position<=length(chaineLue)) do begin
       if chaineLue[position] in ['0'..'9'] then
           chaineLoc := chaineLoc+chaineLue[position];
       if (chaineLue[position]=',') then begin
          inc(NbreVirgule);
          if (NbreVirgule mod 3)=0 then begin
             try
             valeur := strToInt(chaineLoc);
             except
             valeur := 0;
             end;
             if commande='YMAX'
                then valeurMax[voie] := valeur
                else valeurMin[voie] := valeur;
             inc(voie);
          end;
          chaineLoc := '';
       end;
       inc(position);
     end;
end;

var voie : indiceVoie;
    v : integer;
begin // LitMinMax 
    for voie := 0 to pred(NbreVoie) do begin
        valeurMax[voie] := 0;
        valeurMin[voie] := 0;
    end;
    setYasc(false);
    VoieSerie.onTriggerAvail := TriggerAvailMinMax;
    getValeur('YMIN');
    getValeur('YMAX');
    v := 0;
    for voie := voieA to voieAnaMax do
        with TentreeAna(grapheGti.voieOrphy[voie]) do
             if active and (modeEA<>eaDirect) then begin
                 case modeEA of
                    eaMini : valeurCourante := valeurReal(valeurMin[v]);
                    eaMaxi : valeurCourante := valeurReal(valeurMax[v]);
                    eaCreteCrete : valeurCourante := valeurReal(valeurMax[v])-
                                          valeurReal(valeurMin[v]);
                 end;
             inc(v);
    end;
end; // LitMinMax 

var voie : indiceVoie;
    sauveTimer : boolean;
    periode,somme : double;
    i : integer;
begin
   SauveTimer := Timer.enabled;
   Timer.enabled := false;
   Application.ProcessMessages;
   VideBuffers;
   effacePointCourant;
   if grapheGTI.avecMinMax then litMinMax;
   setYasc(false);
   for voie := voieF to voieEB do if grapheGti.voieOrphy[voie].active then begin
       case voie of
            voieF : begin
               frequence.valeurCourante := litFrequence;
               if grapheGTI.avecMinMax then begin
                  try
                  periode := 1/frequence.valeurCourante;
                  if (periode<2) and
                     (baseDeTemps.dureeMinMax<periode) then
                     baseDeTemps.dureeMinMax := periode;
                  except
                  end;   
               end;
            end;
            voieEB : with entreeBinaire do
                   valeurCourante := valeurReal(GetValeurAsc('YEBLOC'));
            voieA..voieAnaMax : with TentreeAna(grapheGti.voieOrphy[voie]) do
                 if modeEA=eaDirect
                    then begin
                         valeurCourante := valeurReal(GetValeurAsc('YEA '+codeVoie));
                         if NbreMoyenne>1 then begin
                            oldValeurs[indexDernier] := valeurCourante;
                            indexDernier := (indexDernier+1) mod NbreMoyenne;
                            somme := 0;
                            for i := 0 to pred(NbreMoyenne) do
                               if oldValeurs[i]<>sansSignif
                                  then somme := somme+oldValeurs[i]
                                  else somme := somme+valeurCourante;
                             valeurCourante := somme/NbreMoyenne;
                      end;
              end; // voie Ana
       end; // case
       Application.ProcessMessages;
       if etatAcq=eaAttenteResul then break;
   end;
   with Numero do valeurCourante := grapheGTI.NbreAff;
   with BaseDeTemps do valeurCourante := (now-debutAcquisition)*24*3600;
   for voie := succ(voieT) to voieMax do
       with grapheGti.voieOrphy[voie] do
            valeurAff := valeurCourante;
   if etatAcq=eaTemporelLent then
      with grapheGti.voieOrphy[voieT] do
           valeurAff := valeurCourante;
   marquePointCourant; 
   if grapheGTI.avecMinMax then envoieOrdreMinMax;
   Timer.enabled := sauveTimer;
end; // litPointAttente

Procedure TgtiMainForm.AjusteDeltat;
var deltatMin : double;
    MR : boolean;
    voie : indiceVoie;
begin
    NbreVoie := 0;
    for voie := voieA to voieEB do
       if grapheGti.voieOrphy[voie].active then inc(NbreVoie);
    if (BaseDeTemps.DureeBalayage>3600) and not(sortieAnalogique.active)
       then begin
           NbreInter := trunc(BaseDeTemps.DureeBalayage/BaseDeTemps.Deltat);
           if NbreInter>NbreInterMax then begin
              NbreInter := NbreInterMax;
              BaseDeTemps.Deltat := BaseDeTemps.DureeBalayage/NbreInter;
           end;
           if NbreInter<16 then begin
              NbreInter := 16;
              BaseDeTemps.Deltat := BaseDeTemps.DureeBalayage/NbreInter;
           end;
       end
       else begin
           BaseDeTemps.Deltat := BaseDeTemps.DureeBalayage/NbreInter;
           if BaseDeTemps.Deltat>deltatMax then BaseDeTemps.deltat := DeltatMax;
           MR := (NbreVoie=1) and (BaseDeTemps.deltat<deltatOrphy*0.7);
           if (modeTemporel<>mRapide) and
              MR and
              not(OKReg(testModeRapide)) then MR := false;
           if MR
               then BaseDeTemps.deltat := deltatOrphyRap
               else begin
                    DeltatMin := deltatOrphy*NbreVoie;
                    if BaseDeTemps.deltat<deltatMin then BaseDeTemps.deltat := deltatMin;
                    BaseDeTemps.deltat := 1e-5*round(BaseDeTemps.deltat/1e-5);
               end;
       end;
       setModeTemporel
end;

Procedure TgtiMainForm.ChargeUtil(chargeSeuil,chargeAuto : boolean);
type
    str80 = string[80];
const
Yseuil5L : array[0..9] of str80 = (
'YUTIL 5 L',
':209B9000008900257580060D0101000A01000B89FF0A0C010A0B0C010B99A10000040000DD',
':179BB00089A6A0C7000005000000011003017D750404FD040C0026C1',
':209BC7008087800D80990126800E800726260C60610062636465897525010107680700A0B3',
':209BE700A08025782501462572708048013178804A72708048014678000000805572708052',
':209C070048014E78804A030002000700806172708048014678000067737401676D74017303',
':209C270071695380670080680067A072677453807D7125017D75011003807D6E670665643F',
':209C4700636261600D00260C6061006263896CA07653809600126C80800C60610064657CAE',
':079C670005207C656480828A',
':00000001FF');
Yseuil5H : array[0..9] of str80 = (
'YUTIL 5 H',
':209B9000C855D1032060C8CECED0FF60D0FE6055C12058CC602059CC60FB9B5555CED10243',
':179BB00055CBFC9B5555CE5555C8D02760D0FF6020D0FF60CECECEBE',
':209BC700FFFFFFFFFFFFCECEFFFFFFFFCECECE7879C8707160685520CE3070CE31CB5520FE',
':209BE700EFF6FF20CED0FFCE2010F3FFD0FF60FFFF2010F1FFD0FF60555555FFFF2010F133',
':209C0700FFD0FF60FFFFCB55CB55CB55FFFF2010F3FFD0FF605555206020CC602060D0FF9D',
':209C27006030CEF9FFD10371203160607130CEF9FF20CED0FF60D02760FFFF2060CE40000A',
':209C470031305150CECECECE7879C8707155318D30CEF9FFD13371FFFFCE7879C86068203E',
':079C6700D000604000FFFF88',
':00000001FF');
Yseuil6L : array[0..6] of str80 = (
'YUTIL 6 L',
':209E00000680AEA0A0A0A080A000801301287801008018013D7801FF72A070806F06290447',
':209E20007F2980288A0080008000A0A9030101AAA9AAA0A0A06950805AA0A900AAA9AAA0A4',
':209E4000A0A050805AA0A900AAA9AAA0A0A0508045008000A0A0A0A00180690617003574AD',
':209E6000746F14063F00747D068C00820068690650807800800068060080A0A03F12130070',
':1B9E80006E677400BE806D746E009050808A8001F40201197500017B710626E8',
':00000001FF');
Yseuil6H : array[0..6] of str80 = (
'YUTIL 6 H',
':209E0000C8FE7E555555553120C8F69ED0FF60D080FF9ED0FF60D07F6020602060C820D04B',
':209E2000FF60FE7E55D103D203C8552060CECA60206055555530CEF99E5555CA60206055F7',
':209E40005555CEF99E5555CA602060555555CEF89ED203CA60555555CA6071C820C8CE60C5',
':209E60003C38CEC800C86060C855D403C87430C8CEF89ED403C874C8D40355EF206060C826',
':1B9E8000606020D40800603430CA60CEF89E60D00160D0FF60CED0FF60C8CE66',
':00000001FF');
Yseuil7L : array[0..4] of str80 = (
'YUTIL 7 L',
':20A00000000173718044017D758044897390887D8900806E6E6E5080288B7DA07EACAB5037',
':20A02000801D999B7E898013017B716EA0802C90061300676E6D063F8900C180290580293D',
':06A0400001A226270626FE',
':00000001FF');
Yseuil7H : array[0..4] of str80 = (
'YUTIL 7 H',
':20A00000C8D0FF10F5A0D0FF10F5A0553155203060CA60303334CEF9A0553020602060CE8A',
':20A02000F8A055552060FFA0D0FF603120F6A055C871C8206020C81055D1086020D00060FD',
':06A04000D0046060C8CEF0',
':00000001FF');
Yseuil8L : array[0..3] of str80 = (
'YUTIL 8 L',
':20A08000890069018080AE80050880000110030601000004000089FEA000000005000000C7',
':10A0A00000050105040508048900258075000626C1',
':00000001FF');
Yseuil8H : array[0..3] of str80 = (
'YUTIL 8 H',
':20A0800055D10ACA60FE7E20D00060C8D02760C8CE5555CED10255CBFCFE5555CE5555C896',
':10A0A000CAD000D000D0006055D1032060CEC8CE09',
':00000001FF');

Yreco9L : array[0..8] of str80 = (
'yutil 9 L',
':20A100000680AEA0A0A0A0808AA0802701803901804B0180AC800B400C017F0D01BF0E5FF6',
':20A12000043F05805F805B020B010C01FD0D01FE0E5F04FC05025F805B080B040C01F70D23',
':20A1400001FB0E5F04F305085F805B200B100C01DF0D01EF0E5F04CF05205F5F800407186E',
':20A16000055018018BA0A0800AA01801A00A0580181818181818181818A00A04FF1801A0F6',
':20A180006A5FA00DA00CAA5F80ADA080ADA080ADA080AD8B5F0BA00CA00DA00EA00BA0A019',
':20A1A0000DAC5F6B6B6A80CFA05080A626070A0A5F8B80BD0BA00CA00DA0AA80C40BA00ECF',
':14A1C000A00DA0AA5F0A0F80CE0A010A80AF260A0180D026E3',
':00000001FF');
Yreco9H : array[0..8] of str80 = (
'yutil 9 H',
':20A10000C8FE7E55555555333220F6A1CDF6A1CDF6A1CDF5A1CA60CA60D0FF60D0FF60208E',
':20A12000D0FFD00060FFA1CA60CA60D0FF60D0FF6020D0FFD00060FFA1CA60CA60D0FF608C',
':20A14000D0FF6020D0FFD00060FFA1CA60CA60D0FF60D0FF6020D0FFD00060E820D000CE9A',
':20A16000D000CECC6020202060CACECC6020D000CECECECECECECECECE6820D000CECC6011',
':20A180007320604E604D6060FEA120FEA120FEA120FEA155204D604D604E604E604D6060FD',
':20A1A0004E6060733034FEA1E8CEF8A1CECA603C2057F9A14D604D604E6060FFA14D604E84',
':14A1C000604E60606020CDF6A120CC60FFA1CECACDF1A1CE88',
':00000001FF');
Yreco10L : array[0..7] of str80 = (
'yutil 10 L',
':20A200000680AEA0A0A0A0808AA0802701803901804B018091800B400C017F0D01BF0E5F10',
':20A22000043F05805F805B020B010C01FD0D01FE0E5F04FC05025F805B080B040C01F70D22',
':20A2400001FB0E5F04F305085F805B200B100C01DF0D01EF0E5F04CF05205F5F800407186D',
':20A26000055018018BA0A0E01801A06A5FA00DA00CAA5F8092A080928B5F0BA00CA00DA02F',
':20A280000EA00BA0A00DAC5F6B6B6A80B4A050808B26070A0A5F8B80A20BA00CA00DA0AA43',
':19A2A00080A90BA00EA00DA0AA5F0A0F80B30A010A8094260A0180B5266C',
':00000001FF');
Yreco10H : array[0..7] of str80 = (
'yutil 10 H',
':20A20000C8FE7E55555555333220F6A2CDF6A2CDF6A2CDF5A2CA60CA60D0FF60D0FF602089',
':20A22000D0FFD00060FFA2CA60CA60D0FF60D0FF6020D0FFD00060FFA2CA60CA60D0FF6089',
':20A24000D0FF6020D0FFD00060FFA2CA60CA60D0FF60D0FF6020D0FFD00060E820D000CE98',
':20A26000D000CECC602020CACECC607320604E604D6060FEA220FEA255204D604D604E6085',
':20A280004E604D60604E6060733034FEA2E8CEF8A2CECA603C2057F9A24D604D604E606080',
':19A2A000FFA24D604E604E60606020CDF6A220CC60FFA2CECACDF1A2CE03',
':00000001FF');
Yreco11L : array[0..8] of str80 = (
'yutil 11 L',
':20A300000680AEA0A0A0A08A006CA06D802901803B01804D01809A800B400C017F0D01BF14',
':20A320000E5F043F05805F805D020B010C01FD0D01FE0E5F04FC05025F805D080B040C01B4',
':20A34000F70D01FB0E5F04F305085F805D200B100C01DF0D01EF0E5F04CF05205F5F6D6D2F',
':20A360006C1801055018018BA0C01801A06A5FA00DA00CAA5F809BA0809B8B5F0BA00CA004',
':20A380000DA00EA00BA0A00DAC5F6B6B6A80BDA050808D8A6C016C08805E26070A0A5F8B11',
':20A3A00080AB0BA00CA00DA0AA80B20BA00EA00DA0AA5F0A0F80BC0A010A809D260A01804B',
':02A3C000BE26B7',
':00000001FF');
Yreco11H : array[0..8] of str80 = (
'yutil 11 H',
':20A30000C8FE7E5555555532CA602072F6A3CDF6A3CDF6A3CDF5A3CA60CA60D0FF60D0FF9B',
':20A320006020D0FFD00060FFA3CA60CA60D0FF60D0FF6020D0FFD00060FFA3CA60CA60D065',
':20A34000FF60D0FF6020D0FFD00060FFA3CA60CA60D0FF60D0FF6020D0FFD00060E8333290',
':20A3600020CECCD000CECC6020CACECC607320604E604D6060FEA320FEA355204D604D6096',
':20A380004E604E604D60604E6060733034FEA3E8CEF8A35520CC60CDF5A3CECA603C2057CC',
':20A3A000F9A34D604D604E6060FFA34D604E604E60606020CDF6A320CC60FFA3CECACDF164',
':02A3C000A3CE2A',
':00000001FF');
Yreco12L : array[0..7] of str80 = (
'yutil 12 L',
':20A400000680AEA0A0A0A0806A086B0C0F0B6B08180A0B0A0A0A000C80896A6C8A6B005E09',
':20A42000E0806D01005B806B005A808052896B000D01007EE080C800010164000006896C53',
':20A4400080000B0B80804C010CA08053150CA00D01FF0D0A01900D01920B0E0E0D0A80695D',
':20A460000E0D0A806D0C80807B0080807B0C010C0B010B0E01B80E805B80696C6B005A804E',
':20A480006D005B808052896C8080686B016B0C800B26A49E5006E23C040E08DA2EDEDE62BB',
':06A4A00020FE6442C2B878',
':00000001FF');
Yreco12H : array[0..7] of str80 = (
'yutil 12 H',
':20A40000C8FE7E555555553171CA6089CA6020CDCE602010603CCA57F9A431715530D2087F',
':20A42000552060CAD2086020D20860FE7E5530C8CECED10855EFCB553070CB5520C8553119',
':20A4400060CA603C57F9A4CA6020FFA4CA602060D0FF1060D00160D0A46058201010F4A437',
':20A46000200010F2A42060FFA4CA60FFA420CC6020CC6058D08810F5A4FFA47120D10860C8',
':20A4800020D10860FE7E553120FE7E20CC60CDF5A4CE060C131A1F272D333A3F464B5359AA',
':06A4A00060666C73798810',
':00000001FF');

Procedure Envoie(const st1,st2 : array of str80);
var i : integer;
begin
    for i := low(st1) to high(st1) do begin
        voieSerie.outPut := st1[i]+crCR;
        repeat until voieSerie.outBuffUsed=0;
    end;
    for i := low(st2) to high(st2) do begin
        voieSerie.outPut := st2[i]+crCR;
        repeat until voieSerie.outBuffUsed=0;
    end;
    sleep(100); { GTI digre }
end;

begin // ChargeUtil
        LabelUtilitaire.caption := 'Chargement des utilitaires en cours';
        WaitPanel.visible := true;
        Application.processMessages;{ mise  jour waitPanel }
        if chargeSeuil and not utilSeuilCharge then begin
           envoie(Yseuil5L,Yseuil5H);
           envoie(Yseuil6L,Yseuil6H);
           envoie(Yseuil7L,Yseuil7H);
           envoie(Yseuil8L,Yseuil8H);
           UtilSeuilCharge := true;
        end;
        if chargeAuto and not utilRecoCharge then begin
           envoie(Yreco9L,Yreco9H);
           envoie(Yreco10L,Yreco10H);
           envoie(Yreco11L,Yreco11H);
           envoie(Yreco12L,Yreco12H);
           UtilRecoCharge := true;
        end;
        WaitPanel.visible := false;
end; // ChargeUtil 

procedure TgtiMainForm.SetYasc(complet : boolean);
begin
     if YbinActif then begin
         ecritOrphy('YASC');
         YbinActif := false;
     end;
     if complet
        then voieSerie.OnTriggerAvail := TriggerAvailAsc
        else voieSerie.OnTriggerAvail := nil
end;

procedure TgtiMainForm.SetYbin;
begin
    if not YbinActif then begin
        ecritOrphy('YBIN');
        YbinActif := true;
    end;
    premierOctet := true;
    voieSerie.OnTriggerAvail := TriggerAvailBin;
end;

Procedure TgtiMainForm.envoieOrdreMinMax;
begin
     ecritOrphy(ordreYPEminmax);
     ecritOrphy('YGO I');
end;

Procedure TgtiMainForm.setModeTemporel;
begin
       modeTemporel := mNormal;
       if (baseDeTemps.DureeBalayage>=1) and
          (baseDeTemps.Deltat>=DeltatLent) and
           grapheGTI.avecMinMax then modeTemporel := mLent;
       if (NbreVoie=1) and
          (BaseDeTemps.deltat<deltatOrphy/2) then modeTemporel := mRapide;
end;

Procedure TgtiMainForm.WEpotar(voie,adrP,valeurP : integer);
begin
   ecritOrphy('YTELE J 0 '+intToStr(voie-12)+' '+intToStr(adrP)+' '+intToStr(valeurP));
   sleep(10);
   ecritOrphy(ordreWEpotar);
   sleep(10);   
end;

Procedure TgtiMainForm.WMpotar(voie,adrP : integer);
begin
   ecritOrphy('YTELE K 0 '+intToStr(voie-12)+' '+intToStr(adrP));
   sleep(10);
   ecritOrphy(ordreWMpotar);
   sleep(10);
end;

Procedure TgtiMainForm.WRpotar(voie : integer);
begin
   ecritOrphy('YTELE L 0 '+intToStr(voie-12));
   sleep(10);
   ecritOrphy(ordreWRpotar);
   sleep(10);
end;


