unit Capcfg;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Grids, sysutils,
  constgti, gtidef, gtiutil, tradFormU, ComCtrls;

type
  TCapteurCfgDlg = class(TtradForm)
    ButtonPanel: TPanel;
    Notebook: TPageControl;
    OptionsTS: TTabSheet;
    EAiTS: TTabSheet;
    GrandeurTS: TTabSheet;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    EntreeCB: TComboBox;
    CalibreCB: TComboBox;
    GrandeurGB: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    EditNom: TEdit;
    EditUnite: TEdit;
    SigneTensionRG: TRadioGroup;
    Label3: TLabel;
    EditSignif: TEdit;
    EtalonnageCB: TCheckBox;
    ManuelGrid: TStringGrid;
    AmpliCB: TCheckBox;
    AlimCB: TCheckBox;
    linearCB: TCheckBox;
    ExpressionEdit: TEdit;
    Label4: TLabel;
    ExpressionLabel: TLabel;
    EditAide: TEdit;
    Label6: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure linearCBClick(Sender: TObject);
  private
  public
    CapteurCourant : TCapteur;
  end;

var
  CapteurCfgDlg: TCapteurCfgDlg;

implementation

{$R *.DFM}

procedure TCapteurCfgDlg.FormActivate(Sender: TObject);
begin with capteurCourant do begin
     EditSignif.text := signifC;
     EditNom.text := nomC;
     EditAide.text := aideC;
     EditUnite.text := nomUniteC;
     EtalonnageCB.checked := AvecPotarC;
     calibreCB.itemIndex := ord(calibreC);
     entreeCB.itemIndex := numeroC;
     ampliCB.checked := AmpliPhysiqueC;
     alimCB.checked := AlimentationC;
     signeTensionRG.itemIndex := ord(tensionC);
     linearCB.checked := LinearC;
     expressionEdit.text := expressionC;
     with manuelGrid do begin
         cells[1,1] := '0';
         cells[1,2] := '5';
         cells[2,1] := FormatGti(val0VC);
         cells[2,2] := FormatGti(val5VC);
     end;
     ManuelGrid.visible := linearC;
end end;

procedure TCapteurCfgDlg.FormCreate(Sender: TObject);
begin with ManuelGrid do begin
     cells[0,1] := '1';
     cells[0,2] := '2';
     cells[2,0] := '';
     cells[1,0] := 'Tension/V';
     colWidths[0] := 50;
     colWidths[1] := 100;
     colWidths[2] := 100;
end end;

procedure TCapteurCfgDlg.EditNomChange(Sender: TObject);
begin
     ManuelGrid.cells[2,0] := EditNom.text+'/'+EditUnite.text;
     ExpressionLabel.caption := EditNom.text+'=';
end;

procedure TCapteurCfgDlg.OKBtnClick(Sender: TObject);

Procedure CalculEtalon;
var valeurL : array[1..2,1..2] of double;
    i,j : integer;
    penteLoc : double;
begin with capteurCourant do begin
      try
         for i := 1 to 2 do
             for j := 1 to 2 do
                 valeurL[i,j] := GetFloat(manuelGrid.cells[i,j]);
      if (abs(valeurL[1,1]-valeurL[1,2]) < 0.01 ) or
         (abs(valeurL[2,1]-valeurL[2,2]) <
         (abs(valeurL[2,1])+abs(valeurL[2,2]))/100 )
            then afficheErreur(erEtalon3,0)
            else begin
               penteLoc := (valeurL[2,1]-valeurL[2,2])/(valeurL[1,1]-valeurL[1,2]);
               val0VC := valeurL[2,1]-penteLoc*valeurL[1,1];
               val5VC := penteLoc*5+val0VC;
            end;
     except
         afficheErreur(erNombre,0);
     end;
end end;

begin with capteurCourant do begin
     signifC := EditSignif.text;
     nomC := EditNom.text;
     aideC := EditAide.text;
     nomUniteC := EditUnite.text;
     AvecPotarC := EtalonnageCB.checked;
     calibreC := TcalibreGTI(calibreCB.itemIndex);
     numeroC := entreeCB.itemIndex;
     if nomC='' then nomC := 'V'+intToStr(NumeroC);     
     AmpliPhysiqueC := ampliCB.checked;
     AlimentationC := alimCB.checked;
     tensionC := Ttension(signeTensionRG.itemIndex);
     linearC := linearCB.checked;
     if linearC
        then expressionC := ''
        else expressionC := expressionEdit.text;
     CalculEtalon;
     if linearC and
        (nomUniteC='T') and
        (numeroC<12) then begin
             afficheErreur(erTesla,0);
             modalResult := mrNone;
     end;
end end;

procedure TCapteurCfgDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(10)
end;

procedure TCapteurCfgDlg.linearCBClick(Sender: TObject);
begin
     manuelGrid.visible := LinearCB.checked
end;

end.

