unit Etalon;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils,
  maths, gtiutil, gtidef, gtimain, tradFormU, constgti, graphe, ComCtrls;

type
  TEtalonneInterDlg = class(TtradForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    EditInteractif1: TEdit;
    EditInteractif2: TEdit;
    Label4: TLabel;
    Bevel3: TBevel;
    Timer: TTimer;
    Point1: TSpeedButton;
    Point2: TSpeedButton;
    Point2Manuel: TSpeedButton;
    EditManuel: TEdit;
    EditManuelVolt: TEdit;
    GaugeInter2: TProgressBar;
    GaugeInter1: TProgressBar;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure Point1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure Point2Click(Sender: TObject);
    procedure Point2ManuelClick(Sender: TObject);
  private
    point1Actif : boolean;
    procedure finOK(Manuel : boolean);
  public
    voie : indiceVoie;
  end;

var
  EtalonneInterDlg: TEtalonneInterDlg;

implementation

{$R *.DFM}

procedure TEtalonneInterDlg.TimerTimer(Sender: TObject);
var zw : word;
    zi : integer;
begin
     zw := GtiMainForm.getValeurAsc('YEA '+voieEA[voie].codeVoie);
     zi := wordToInt(zw);
     if point1Actif
        then GaugeInter1.position := zi
        else GaugeInter2.position := zi
end;

procedure TEtalonneInterDlg.FormActivate(Sender: TObject);
begin with voieEA[voie] do begin
     gtiMainForm.setYasc(false);
     timer.interval := gtiMainForm.majTimer;
     EditInteractif1.text := FormatGti(valeur0V);
     EditInteractif2.text := FormatGti(valeur5V);
     GaugeInter1.position := 0;
     GaugeInter2.position := 1024;
     LabelInteractif.caption := Nom+'/'+NomUnite;
     Point1.down := false;
     Point2.down := false;
     Point1Actif := true;
     timer.enabled := true;
     Point1.visible := true;
     Point2.visible := false;
     Point2Manuel.visible := false;
     EditInteractif1.setFocus;
end end;

procedure TEtalonneInterDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TEtalonneInterDlg.finOK(Manuel : boolean);
var valeurReel,valeurCan : array[1..2] of double;
    valeurOK : boolean;
    penteLoc : double;
begin
     try
     valeurReel[1] := GetFloat(EditInteractif1.text);
     valeurCan[1] := voieEA[voie].ValeurVolt(intToWord(GaugeInter1.position));
     if manuel
        then begin
             valeurReel[2] := GetFloat(EditManuel.text);
             valeurCan[2] := GetFloat(EditManuelVolt.text);
        end
        else begin
             valeurReel[2] := StrToFloatWin(EditInteractif2.text);
             valeurCan[2] := voieEA[voie].ValeurVolt(intToWord(GaugeInter2.position));
        end;
     ValeurOK := (valeurCan[1]<>sansSignif) and
                 (valeurCan[2]<>sansSignif) and
                 (valeurReel[1]<>sansSignif) and
                 (valeurReel[2]<>sansSignif) and
                 (valeurReel[1]<>valeurReel[2]);
     if valeurOK
        then modalResult := mrOK
        else begin
           afficheErreur(erEtalon,0);
           modalResult := mrNone;
        end;
     valeurOK := abs(valeurCan[2]-valeurCan[1]) > 5/GainCalibre[voieEA[voie].calibre]/64;
     if valeurOK
        then with voieEA[voie] do begin
            penteLoc := (valeurReel[2]-valeurReel[1])/(valeurCan[2]-valeurCan[1]);
            valeur0V := valeurReel[2]-penteLoc*valeurCan[2];
            valeur5V := valeur0V+penteLoc*5;
            calculPente;
        end
        else begin
           afficheErreur(erEtalon2,0);
           modalResult := mrNone;
        end;
     except
        modalResult := mrNone;
     end;
end;

procedure TEtalonneInterDlg.Point1Click(Sender: TObject);
begin
   point1Actif := false;
   EditInteractif2.setFocus;
   Point1.visible := false;
   Point2.visible := true;
   Point2Manuel.visible := true;
end;

procedure TEtalonneInterDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TEtalonneInterDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(11)
end;

procedure TEtalonneInterDlg.Point2Click(Sender: TObject);
begin
     finOK(false)
end;

procedure TEtalonneInterDlg.Point2ManuelClick(Sender: TObject);
begin
     finOK(true)
end;

end.
