unit ETALONAuto;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils, ooMisc,
  maths, gtiUtil, gtiDef, gtiMain, tradformU, constgti, ComCtrls;

type
  TEtalonneAutoDlg = class(TtradForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    PotarTab: TTabControl;
    Memo: TMemo;
    EtalonBtn: TSpeedButton;
    EtalonLabel: TLabel;
    OKbtn: TBitBtn;
    Gauge: TProgressBar;
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure PotarTabChange(Sender: TObject);
    procedure EtalonBtnClick(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
  private
    Pcourant : integer;
    indexCapteur : integer;
  public
    voieCourante : Tvoie;
  end;

var
  EtalonneAutoDlg: TEtalonneAutoDlg;

implementation

{$R *.DFM}


procedure TEtalonneAutoDlg.FormActivate(Sender: TObject);
var i : integer;
begin
     indexCapteur := voieCourante.indexCapteurAuto;
with listeCapteursAuto[indexCapteur] do begin
     PotarTab.tabs.clear;
     for i := 0 to maxPotarAuto do
         if potarActif[i] then PotarTab.tabs.add(nomPotar[i]);
     PotarTab.TabIndex := 0;
     PotarTabChange(nil);
     gauge.position := 0;
end end;

procedure TEtalonneAutoDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(11)
end;

procedure TEtalonneAutoDlg.PotarTabChange(Sender: TObject);
var N,i : integer;
begin
    N := 0;
    for i := 0 to maxPotarAuto do
        if ListeCapteursAuto[indexCapteur].potarActif[i] then begin
           if PotarTab.tabIndex=N then Pcourant := i;
           inc(N);
        end;
    memo.text := ListeCapteursAuto[indexCapteur].aidePotar[Pcourant];
    EtalonLabel.Visible := false;
    EtalonBtn.Enabled := true;
    EtalonBtn.visible := true;
    gauge.position := 0;
end;

procedure TEtalonneAutoDlg.EtalonBtnClick(Sender: TObject);
const attenteMax = 20; { 2 secondes }

function IsGreater(P : integer) : boolean;
const
    attenteMin = 5; { 0,5 seconde }
var oldzi,i,zi : integer;
    wi,oldwi : word;
    stable : boolean;
begin with listeCapteursAuto[indexCapteur] do begin
     GtiMainForm.WEPOTAR(voieCourante.numeroOrphy,Pcourant,P);
     zi := 1000;
     wi := 32000;
     i := 0;
     repeat
        oldzi := zi;
        oldwi := wi;
        sleep(100);
        wi := GtiMainForm.getValeurAsc('YEA '+voieCourante.codeVoie);
        if wi=0
           then begin
              wi := oldwi;
              stable := false;
           end
           else begin
              zi := wordToInt(zi);
              stable := abs(zi-oldzi)<32;
           end;
        inc(i);
        application.processMessages;
        gauge.position := gauge.position+1; 
     until (stable and (i>attenteMin)) or (i>attenteMax);
     result := valeurReal(wi)>valeurAttendue[Pcourant];
end end;

var mini,maxi,test,i : integer;
//    valeurCAN : double;
begin with ListeCapteursAuto[indexCapteur] do begin
      EtalonBtn.Enabled := false;
      test := valeurPotar[Pcourant];
      if isGreater(test)
         then begin
            maxi := test;
            mini := 0;
         end
         else begin
            mini := test;
            maxi := 1024;
         end;
      i := 0;
      gauge.position := 0;
      repeat
           test := (mini+maxi) div 2;
           if isGreater(test)
              then maxi := test
              else mini := test;
           inc(i);
           gauge.position := i*attenteMax;
           application.processMessages;
      until (maxi-mini)<2;
      if (test>1020) or (test<4)
          then GtiMainForm.WEPOTAR(voieCourante.numeroOrphy,Pcourant,valeurPotar[Pcourant])
          // retour au rglage usine
          else valeurPotar[Pcourant] := test; // on sauve
      GtiMainForm.WMPOTAR(voieCourante.numeroOrphy,Pcourant);
{
      if PCourant in [2,3] then begin
           sleep(100);
           test := GtiMainForm.getValeurAsc('YEA '+voieCourante.codeVoie);
           valeurCAN := voieCourante.ValeurVolt(test);
           if PCourant=3 then
              voieCourante.pente := (valeurAttendue[3]-offsetC)/valeurCan;
           if PCourant=2 then
              voieCourante.offset := valeurAttendue[3]-UnVoltC*valeurCan;
      end;
}
      EtalonBtn.visible := false;
      EtalonLabel.Visible := true;
      gauge.position := gauge.max;
end end;

procedure TEtalonneAutoDlg.OKbtnClick(Sender: TObject);
begin
     SauveListeCapteurs
end;

end.
