unit Gbf;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, spin, StdCtrls, Buttons,
  tradFormU, maths, gtidef, gtiUtil, uniteker, ExtCtrls,graphe,constgti;

type
  TGBFForm = class(TTradForm)
    SignalGB: TGroupBox;
    TriangleBtn: TSpeedButton;
    CarreBtn: TSpeedButton;
    SinusBtn: TSpeedButton;
    DCBtn: TSpeedButton;
    OffsetGB: TGroupBox;
    OffsetEdit: TEdit;
    OffsetScroll: TScrollBar;
    AmplitudeGB: TGroupBox;
    AmplitudeEdit: TEdit;
    AmplitudeScroll: TScrollBar;
    DutyGB: TGroupBox;
    DutyEdit: TEdit;
    DutyScroll: TScrollBar;
    FrequenceGB: TGroupBox;
    FrequenceSpin: TSpinButton;
    FrequenceEdit: TEdit;
    AideBtn: TSpeedButton;
    ArbitrairePanel: TPanel;
    Oscillo: TPaintBox;
    FichierBtn: TBitBtn;
    OpenDialog: TOpenDialog;
    ArbitraireBtn: TSpeedButton;
    MajBtn: TSpeedButton;
    MajTimer: TTimer;
    procedure OffsetScrollChange(Sender: TObject);
    procedure AmplitudeScrollChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure DutySpinChange(Sender: TObject);
    procedure SignalBtnClick(Sender: TObject);
    procedure FrequenceEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure FrequenceSpinDownClick(Sender: TObject);
    procedure FrequenceSpinUpClick(Sender: TObject);
    procedure AideBtnClick(Sender: TObject);
    procedure FrequenceEditExit(Sender: TObject);
    procedure FichierBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure MajTimerTimer(Sender: TObject);
    procedure MajBtnClick(Sender: TObject);
  private
    Nbre : integer;
    Periode : integer;
    ModifSignal : boolean;
    UniteVolt : Tunite;
    grapheSA : Tgraphe;
    Procedure VerifAmplOffset(ModifAmpl : boolean);
    procedure ModifFrequence(down : boolean);
    Procedure MajSA;
    Procedure FaireMaj;
    Procedure DesactiveBtn;
    Procedure ActiveBtn;
    Procedure MajFrequence(Freq : double);
  public
  end;

var
  GBFForm: TGBFForm;

implementation

uses GtiMain, modeDlg;

Const PeriodeGTI = 69.4e-6;

{$R *.DFM}

procedure TGBFForm.MajSA;
var frequence : double;
begin
     AmplitudeGB.visible := not DCbtn.down and not ArbitraireBtn.down;
     DutyGB.visible := not DCbtn.down and not ArbitraireBtn.down;
     FrequenceGB.visible := not DCbtn.down;
     if DCBtn.down
        then OffsetGB.caption := trValeur
        else OffsetGB.caption := trOffset;
     frequence := 1/(periode*periodeGTI*Nbre);
     frequenceEdit.text := formatGTI(frequence);
     OffsetEdit.text := uniteVolt.formatUniteBrute(OffsetScroll.position*5/127);
     DutyEdit.text := IntToStr(DutyScroll.position)+'%';
     AmplitudeEdit.text := uniteVolt.formatUniteBrute(AmplitudeScroll.position*5/127);
     ArbitrairePanel.visible := ArbitraireBtn.down;
     if arbitrairePanel.visible
        then Height := 215
        else Height := 215-ArbitrairePanel.Height;
     MajBtn.Enabled := true;
     MajTimer.Enabled := true;   
end;

procedure TGBFForm.FaireMaj;
var posDuty : integer;

Function ValeurSA(i : integer) : word;
var valeurReal : double;
begin
     valeurReal := 0;
     if sinusBtn.down then valeurReal := round(AmplitudeScroll.position*sin(2*pi*i/Nbre));
     if carreBtn.down then if i>PosDuty
        then valeurReal := -AmplitudeScroll.position
        else valeurReal := AmplitudeScroll.position;
     if triangleBtn.down then if i>PosDuty
        then valeurReal := AmplitudeScroll.position-round((i-posDuty)*AmplitudeScroll.position*2.0/(Nbre-posDuty))
        else valeurReal := -AmplitudeScroll.position+round(i*AmplitudeScroll.position*2.0/posDuty);
     if ArbitraireBtn.down
        then with sortieAnalogique do
            result := valeurYtele(vecteurUtilisateur[trunc(i*sortieAnalogique.NbreInterSA/Nbre)])
        else begin
           valeurReal := (valeurReal+OffsetScroll.position)/127;
            { entre -1 et +1 }
           if valeurReal<0
              then result := 65535+round(valeurReal*Hard5V)
              else result := round(valeurReal*Hard5V)
        end;
end;

var i : integer;
begin
     enabled := false;
     GtiMainForm.SetLectureParametres;
     if DCBtn.down
        then begin
             GtiMainForm.ecritOrphy('YSYNTOF 1');
             GtiMainForm.ecritOrphy('YSA 1 '+intToStr(127+OffsetScroll.position));
        end
        else begin
             if ModifSignal then begin
                DesactiveBtn;
                PosDuty := round(Nbre*DutyScroll.position/100);
                if posDuty<2 then posDuty := 2;
                if posDuty>(Nbre-2) then posDuty := Nbre-2;
                GtiMainForm.VoieSerie.OutPut := 'YTELE 1 0';
                for i := 0 to pred(Nbre) do
                    GtiMainForm.VoieSerie.OutPut := ' '+IntToStr(valeurSA(i));
                GtiMainForm.VoieSerie.OutPut := crCR;
                repeat until GtiMainForm.voieSerie.outBuffUsed=0;
                ModifSignal := false;
                ActiveBtn;
             end;
             GtiMainForm.ecritOrphy('YSYNTON 1 0 '+IntToStr(pred(Nbre))+' '+intToStr(periode));
        end;
     enabled := true;
     GtiMainForm.FinLectureParametres;
end;

Procedure TGBFForm.VerifAmplOffset(ModifAmpl : boolean);
var mini, maxi : integer;
begin
    if modifAmpl
       then begin
          maxi := 127-AmplitudeScroll.position;
          mini := -127+AmplitudeScroll.position;
          if OffsetScroll.position<mini then OffsetScroll.position := mini;
          if OffsetScroll.position>maxi then OffsetScroll.position := maxi;
       end
       else begin
          maxi := abs(127-OffsetScroll.position);
          mini := abs(-127+OffsetScroll.position);
          if mini<maxi then maxi := mini;
          if AmplitudeScroll.position>maxi then AmplitudeScroll.position := maxi;
       end;
    ModifSignal := true;
    majSA;
end;

procedure TGBFForm.OffsetScrollChange(Sender: TObject);
begin
     VerifAmplOffset(false)
end;

procedure TGBFForm.AmplitudeScrollChange(Sender: TObject);
begin
     VerifAmplOffset(true)
end;

procedure TGBFForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     GtiMainForm.ecritOrphy('YSYNTOF 1');
     GtiMainForm.ecritOrphy('YSA 1 127');
     GtiMainForm.GTBFItem.checked := false;
     Hide;
end;

procedure TGBFForm.FormCreate(Sender: TObject);
var i : indiceVecteur;
begin
     UniteVolt := Tunite.create;
     UniteVolt.NomUnite := 'V';
     ModifSignal := true;
     Nbre := 256;
     Periode := 1;
     GrapheSA := Tgraphe.create;
     with GrapheSA do begin
         for i := 0 to MaxVecteur do vecteurX[i] := i;
         NbrePoints := 255;
         MaxiY := maxiHardSA;
         MiniY := 0;
         canvas := oscillo.canvas;
     end;
end;

procedure TGBFForm.DutySpinChange(Sender: TObject);
begin
     modifSignal := true;
     majSA;
end;

procedure TGBFForm.SignalBtnClick(Sender: TObject);
begin
    ModifSignal := true;
    MajSA
end;

procedure TGBFForm.FrequenceEditKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then begin
        try
        MajFrequence(StrToFloatWin(FrequenceEdit.text));
        except
        end;
     end;
end;

procedure TGBFForm.FormActivate(Sender: TObject);
begin
     MajSA
end;

procedure TGBFForm.FrequenceSpinDownClick(Sender: TObject);
begin
     ModifFrequence(true)
end;

procedure TGBFForm.ModifFrequence(down : boolean);
var N,dN : integer;
begin
     N := periode*Nbre;
     if Periode=1
        then dN := 1
        else dN := succ(periode);
     if down
        then inc(N,dN)
        else dec(N,dN);
     MajFrequence(1/(N*periodeGTI));
end;

procedure TGBFForm.FrequenceSpinUpClick(Sender: TObject);
begin
     ModifFrequence(false)
end;

procedure TGBFForm.DesactiveBtn;
begin
    DutyScroll.enabled := false;
    OffsetScroll.enabled := false;
    AmplitudeScroll.enabled := false;
    FrequenceEdit.enabled := false;
    FrequenceSpin.enabled := false;
    Screen.cursor := crHourGlass;
end;

procedure TGBFForm.ActiveBtn;
begin
    DutyScroll.enabled := true;
    OffsetScroll.enabled := true;
    AmplitudeScroll.enabled := true;
    FrequenceEdit.enabled := true;
    FrequenceSpin.enabled := true;
    Screen.cursor := crDefault;
end;

procedure TGBFForm.AideBtnClick(Sender: TObject);
begin
   Application.HelpContext(15)
end;

procedure TGBFForm.FrequenceEditExit(Sender: TObject);
begin
        try
        MajFrequence(StrToFloatWin(FrequenceEdit.text));
        except
        end;
end;

procedure TGBFForm.OscilloPaint(Sender: TObject);
var i : integer;
begin with grapheSA,sortieAnalogique do begin
     y0 := 127;
     limiteFenetre := rect(0,0,oscillo.width-1,oscillo.height-1);
     NbrePoints := pred(NbreInterSA);
     for i := 0 to NbrePoints do
         vecteurY[i] := valeurYsa(vecteurUtilisateur[i]);
     grapheSA.draw(Utemps.formatUnite(NbrePoints*baseDeTemps.deltat));
end end;

procedure TGBFForm.FichierBtnClick(Sender: TObject);
var fichier : textFile;
    s : string;

Procedure ExtraitValeur;
var ligneWin : string;
    posV,i,j,longueur : integer;
begin with SortieAnalogique do begin
    NbreInterSA := 0;
    try
    while not eof(fichier) and (NbreInterSA<maxVecteur) do begin
       readln(fichier,LigneWin);
       i := 1;
       Longueur := length(LigneWin);
       While (i<longueur) and not charinset(LigneWin[i],[crTab,' ']) do inc(i);
       { fin du premier nombre : t }
       While (i<longueur) and
             not charinset(LigneWin[i],ChiffreWin) do inc(i);
       { i=dbut du deuxime nombre : SA }
       j := succ(i);
       While (j<=longueur) and
             charinset(LigneWin[j],ChiffreWin) do inc(j);
       { j=succ(fin du deuxime nombre) : SA }
       ligneWin := copy(ligneWin,i,j-i);
       posV := pos(',',ligneWin);
       if posV>0 then ligneWin[posV] := '.';
       vecteurUtilisateur[NbreInterSA] := StrToFloat(ligneWin);
       inc(NbreInterSA);
    end;
    except
        afficheErreur(erValeur,0);
    end;
end end; {extraitValeur}

Function LigneDeChiffres : boolean;
var j : integer;
    AvecChiffres : boolean;
begin
    Result := false;
    AvecChiffres := false;
    for j := 1 to length(s) do
        if charinset(s[j],chiffreWin)
           then avecChiffres := true
           else if (s[j]<>crTab) and (s[j]<>' ') then exit;
    result := avecChiffres;
end;

var i,k : integer;
begin
     if openDialog.execute then begin
        assignFile(fichier,openDialog.fileName);
        Reset(fichier);
        screen.cursor := crHourGlass;
        k := 0;
        repeat
          Readln(fichier,s);
          inc(k);
        until LigneDeChiffres;
        Reset(fichier);
        for i := 1 to pred(k) do readln(fichier);
        extraitValeur;
        closeFile(fichier);
        screen.cursor := crDefault;
        oscillo.refresh;
        MajSA;
     end;
end; { FichierBtnClick }

procedure TGBFForm.MajTimerTimer(Sender: TObject);
begin
    if MajBtn.enabled
       then if MajBtn.layout=blGlyphRight
          then MajBtn.layout := blGlyphLeft
          else MajBtn.layout := blGlyphRight
       else MajTimer.enabled := false;
end;

procedure TGBFForm.MajBtnClick(Sender: TObject);
begin
  FaireMaj;
  MajBtn.Enabled := false;
end;

Procedure TGBFForm.MajFrequence(Freq : double);
var oldNbre,N : integer;
begin
        oldNbre := Nbre;
        N := trunc(1/(periodeGTI*freq));
        if N<64 then N := 64;
        if N<256
          then begin
              Nbre := N;
              Periode := 1;
          end
          else begin
              Periode := succ(N div 256);
              Nbre := N div periode;
          end;
        ModifSignal := ModifSignal or (Nbre<>oldNbre);
        MajSA;
        FrequenceEdit.text := formatGTI(freq);
end;

end.
