unit Graphe;

interface

uses windows, sysUtils, graphics, classes,
     Forms, Controls, Buttons, StdCtrls, ExtCtrls, Dialogs, inifiles,
     maths, gtiUtil, uniteKer, gtidef, constgti, math, magnumU;

const
        IntSansSignif = -1;
        dimPoint : integer = 5;
        scaleCurseur = 10;
        LongNombreAxe = 4;
        NbreGraduations = 10;
        NbreGradMin = 5;
{ voieT = 1 voieMagnum = 3 voieSA = 4 voieClavier = 5 voieF = 6
  voieA = 7 voieEB = 12 voieSB = 13 voieNum = 14}
        CouleurRepere : Tcolor = clBlue;
        NbreRampeMax = 6;

type
        TmodeSA = (saRampe,saImpulsion,saUtilisateur);
        TmodeEA = (eaDirect,eaMini,eaMaxi,eaCreteCrete,eaMoyenne);
        TmodeSB = (sbRampe,sbEchelon,sbUtilisateur);
        Tcurseur =(curNone,curSynchro,curPreAcq,curSynchroPreAcq);
        Trepere = class
            Valeur : double;
            Text   : string;
        end;

        TgrapheGTI = class;

        TCourbe = class(Tvoie)
                 public
                 a,b : double; { entier affichage = rel*a+b }
                 deltaAxe,exposant,pointDebut : double;
                 axeLog,axeDateTime : boolean;
                 { deltaAxe = cart entre graduations sur les axes }
                 NbreChiffre : integer;
                 courbeBottom,courbeTop : integer;
                 IndexDernier : integer;
                 constructor create(Anom : string;Aunite: string;
                    Asignif : string;Anumero : integer);
                 destructor Destroy; override;
                 procedure Assign(source : Tpersistent);override;
                 procedure setDelta(grandAxe : boolean);
                 Function FormatAxe(x : double) : string;
                 Function XWindow(r : double) : integer;
                 Function XMonde(xi : integer) : double;
        end;

        TsortieAnalogique = class(Tcourbe)
            public
            DebutSortie,FinSortie : array[1..NbreRampeMax] of integer;
            PasSortie : integer;
            NbreInterSA : integer;
            SAi : ansiChar;
            Modif : boolean;
            ModeSA : TmodeSA;
            NbrePulse,LargeurPulse,DeltaPulse,DebutPulse : integer;
            NbreRampes : integer;
            vecteurUtilisateur : vecteur;
            vecteurYSA : vecteurInt;
            constructor create;
            Function ValeurVolt(V : integer) : double;override;
            Function CalibreVoie : string;override;
            Function ValeurReal(V : integer) : double;override;
            Function ValeurYtele(V : double) : word;
            Function ValeurYsa(V : double) : word;
            Function NomVoieOrphy : string;
            Function CodeSortie(i : integer) : shortString;
            procedure LitFichier(nomFichier : string);
            procedure load(Avoie : string;Fichier : tMemIniFile);override;
            procedure store(Avoie : string;Fichier : tMemIniFile);override;
            procedure calcVecteur;
        end;

        TsortieBinaire = class(Tcourbe)
            private
               FnbreSB : integer;
               Fmasque : integer;
               procedure setNbreSB(value : integer);
            public
            Modif : boolean;
            ModeSB : TmodeSB;
            NbreInterSB : integer;
            FinEchelon,DebutEchelon : integer;
            vecteurUtilisateur : vecteurInt;
            property NbreSB : integer read FnbreSB write setNbreSB;
            property masque : integer read Fmasque;
            constructor create;
            Function CalibreVoie : string;override;
            Function ValeurReal(V : integer) : double;override;
            procedure load(Avoie : string;Fichier : tMemIniFile);override;
            procedure store(Avoie : string;Fichier : tMemIniFile);override;
            procedure calcVecteur;
        end;

        TentreeBinaire = class(Tcourbe)
            private
               FnbreEB : integer;
               Masque : word;
               procedure setNbreEB(value : integer);
            public
            constructor create;
            Function CalibreVoie : string;override;
            property NbreEB : integer read FnbreEB write setNbreEB;
            Function ValeurReal(V : integer) : double;override;
            procedure load(Avoie : string;Fichier : tMemIniFile);override;
            procedure store(Avoie : string;Fichier : tMemIniFile);override;
            function NomValeurUnite(nombre : double) : string;override;
        end;

        TentreeAna = class(Tcourbe)
            public
            modeEA : TmodeEA;
            signifTension,signifCapteur : string;
            nomTension,nomCapteur : string;
            constructor create(voie : indiceVoie);
            procedure load(Avoie : string;Fichier : tMemIniFile);override;
            procedure store(Avoie : string;Fichier : tMemIniFile);override;
            procedure Assign(source : Tpersistent);override;
        end;

        TbaseDeTemps = class(Tcourbe)
            private
            FDureeMinMax : double;
            Fgraphe : TgrapheGTI;
            FDureeBalayage : double;
            procedure setDureeMinMax(Avalue : double);
            procedure setDureeBalayage(Avalue : double);            
            function getOrdreMinMax : shortString;
            public
            Deltat : double;
            PreAcq10,preAcqExact : integer;
            ModifDuree : boolean;
            property DureeBalayage : double read FdureeBalayage write setDureeBalayage;
            property DureeMinMax : double read FdureeMinMax write setDureeMinMax;
            property ordreMinMax : shortString read getOrdreMinMax;
            constructor create(Graphe : TgrapheGTI);
            procedure load(Avoie : string;Fichier : tMemIniFile);override;
            procedure store(Avoie : string;Fichier : tMemIniFile);override;
        end;

        Tfrequence = class(Tcourbe)
            public
            EFi : ansiChar;
            modeEF0 : ansiChar;
          { H priode F frquence M compteur montant }
            DureeComptage,Diviseur : word;
            maxiF,miniF,debutCompteur : double;
            Increment : double;
            Decrementer : boolean; { sinon incrmenter }
            constructor create;
            Function CalibreVoie : string;override;
            procedure load(Avoie : string;Fichier : tMemIniFile);override;
            procedure store(Avoie : string;Fichier : tMemIniFile);override;
            Function NomVoieOrphy : string;
            Function AffVoltmetre : string;override;
        end;

       Tmagnum = class(Tcourbe)
            private
               FmodeAngulaire,FmodeRadian : boolean;
               procedure setModeAngulaire(value : boolean);
               procedure setModeRadian(value : boolean);
            public
            EFi : ansiChar;
            dateDebut : double;
            attente : integer;
            oldPos : integer; { pour avoir le sens }
            property modeAngulaire : boolean read FmodeAngulaire write setModeAngulaire;
            property modeRadian : boolean read FmodeRadian write setModeRadian;
            constructor create;
            Function ValeurReal(V : integer) : double;override;
            procedure load(Avoie : string;Fichier : tMemIniFile);override;
            procedure store(Avoie : string;Fichier : tMemIniFile);override;
        end;

    TgrapheGTI = class
           Canvas : Tcanvas;
           oTraceLigne : boolean;
           oTracePoints : boolean;
           oTraceFFT : boolean;
           NbreCourbe,NbreVoieAna : integer;
           preAcqOK : boolean;
           MagnumPermis : boolean;
           codeErreur : integer;
           avecAxeX,avecAxeY,avecUnAxe : boolean;
           grandAxeX,grandAxeY : boolean;
           voieOrphy : array[indiceVoie] of Tcourbe;
           LimiteCourbe,LimiteFenetre : Trect;
           LargCarac,HautCarac,Marge : integer;
           NbreAff,NbreCourant,NbreFFT : indiceVecteur;
           voieAbscisse : indiceVoie;
           quadrillage,AnalyseurLogique : boolean;
           seuilSynchro : word;
           monocoup : boolean;
           voieSynchro : indiceVoie;
           ModeSynchro : TModeSynchro;
           ModeAcq : TModeAcq;
           montant : boolean;
           Front : integer;
           ListeRepere : Tlist;
           CoeffInterp : double; { interpolation lie  T de YPE }
           TrierAbscisse,avecMinMax : boolean;
           ReticuleTrace : boolean;
           Constructor Create;
           Procedure Draw;
           Procedure TraceCourbes;
           Procedure TracePoint(voie : integer);
           Procedure TraceReticule(voie : integer);
           Procedure SetHauteurFonte(H : integer);
           Procedure tri;
           Procedure CourantVersAff;
           Procedure TraceRepere(repere : Trepere);
           Procedure AjouteRepere(V : double;const T : String);
           destructor Destroy; override;
           procedure TraceMotif(xi,yi : integer;motif : Tmotif);
           procedure ajusteOrigineTemps;
  end;

  Tgraphe = class
        Canvas : Tcanvas;
        vecteurX,vecteurY : vecteur;
        Ax,Bx,Ay,By,maxiY,miniY : double;
        LimiteFenetre : Trect;
        NbrePoints : indiceVecteur;
        y0 : double;
        Procedure Draw(TexteAbscisse : string);
  end;

var  grapheGti : TgrapheGTI;
     sortieAnalogique : TsortieAnalogique;
     entreeBinaire : TentreeBinaire;
     sortieBinaire : TsortieBinaire;
     frequence : Tfrequence;
     frequenceU : Tunite;
     numero : Tcourbe;
     magnum : Tmagnum;
     BaseDeTemps : TbaseDeTemps;
     EntreeClavier : Tcourbe;
     voieEA : array[voieA..voieAnaMax] of TentreeAna;


IMPLEMENTATION

var MaxGr,MinGr : integer;

Function Tcourbe.XMonde(xi : integer) : double;
begin
	result := (xi-B)/A
end;

Function Tcourbe.XWindow(r : double) : integer;
begin
      if r=sansSignif
         then result := IntSansSignif
         else try
            if AxeLog then
               r := Log10(r);
            result := round(A*r+B)
            except
               result := IntSansSignif
            end
end;

procedure TgrapheGTI.TraceRepere(repere : Trepere);
var x : integer;
begin with Canvas,repere do begin
      Pen.color := couleurRepere;
      Pen.Style := psDash;
      x := BaseDeTemps.Xwindow(valeur);
      MoveTo(x,LimiteCourbe.top);
      LineTo(x,LimiteCourbe.bottom);
      Pen.Style := psSolid;
end end;{ TraceRepere }

procedure TgrapheGTI.AjouteRepere(V : double;const T : string);
var repere : Trepere;
begin
     repere := Trepere.Create;
     repere.valeur := V;
     repere.text := T;
     ListeRepere.Add(repere);
     TraceRepere(repere);
end;

procedure TgrapheGTI.TraceMotif(xi,yi : integer;motif : Tmotif);

Procedure Segment(x1,y1,x2,y2 : integer);
begin
     Canvas.moveTo(x1,y1);
     Canvas.lineTo(x2,y2);
end;

var PolyLigne : array[1..5] of Tpoint;
begin
     case motif of
             mCroix : begin
                 Segment(xi-dimPoint,yi,xi+dimPoint,yi);
                 Segment(xi,yi-dimPoint,xi,yi+dimPoint);
             end;
             mCroixDiag : begin
                 segment(xi-dimPoint,yi-dimPoint,xi+dimPoint,yi+dimPoint);
                 segment(xi+dimPoint,yi-dimPoint,xi-dimPoint,yi+dimPoint);
             end;
             mCercle : Canvas.ellipse(xi-dimPoint,yi-dimPoint,xi+dimPoint+1,yi+dimPoint+1);
             mCarre : canvas.rectangle(xi-dimPoint,yi-dimPoint,xi+dimPoint,yi+dimPoint);
             mLosange : begin
                  PolyLigne[1] := Point(xi-dimPoint,yi);
                  PolyLigne[2] := Point(xi,yi-dimPoint);
                  PolyLigne[3] := Point(xi+dimPoint,yi);
                  PolyLigne[4] := Point(xi,yi+dimPoint);
                  PolyLigne[5] := Point(xi-dimPoint,yi);
                  canvas.polyLine(PolyLigne);
             end;
      end;{case}
end;

procedure TgrapheGTI.TracePoint(voie : integer);
var xi,yi : integer;
begin with voieOrphy[voie] do begin
      canvas.pen.style := psSolid;
      canvas.pen.color := couleur;
      canvas.brush.color := couleur;
      xi := voieOrphy[voieAbscisse].XWindow(voieOrphy[voieAbscisse].valeurAff);
      yi := XWindow(valeurAff);
      if (xi<>IntSansSignif) and (yi<>IntSansSignif) then
         if dimPoint=0
            then canvas.pixels[xi,yi] := couleur
            else traceMotif(xi,yi,motif)
end end;{ TracePoint }

procedure TgrapheGTI.TraceReticule(voie : integer);
var xi,yi : integer;
begin with voieOrphy[voie] do begin
      xi := voieOrphy[voieAbscisse].XWindow(voieOrphy[voieAbscisse].valeurAff);
      yi := XWindow(valeurAff);
      if (xi<>IntSansSignif) and (yi<>IntSansSignif) then begin
             canvas.pen.style := psSolid;
             canvas.pen.color := couleur;
             canvas.pen.width := 3;
             canvas.pen.mode := pmNotXor;
             canvas.moveTo(xi-scaleCurseur,yi);
             canvas.lineTo(xi+scaleCurseur,yi);
             canvas.moveTo(xi,yi-scaleCurseur);
             canvas.lineTo(xi,yi+scaleCurseur);
             canvas.pen.width := 1;
             canvas.pen.mode := pmCopy;
         end;
end end;{ TraceReticule }

procedure TgrapheGti.SetHauteurFonte(H : integer);
begin
     H := H * 72 div canvas.font.PixelsPerInch;
     H := 2 * (H div 2);
     if H<=8 then H := 8;
     if H>=12 then H := 12;
     canvas.font.size := H;
     HautCarac := canvas.textHeight('A');
     LargCarac := canvas.textWidth('A');
     Marge := largCarac div 2;
end;

procedure TgrapheGTI.Draw;

procedure ChercheMonde;

procedure SetDeltaFreq(grandAxe : boolean);
{ Exposant=puissance de 10 multiple de 3 de manire  avoir entre
NbreGraduations (10) et N/2.5 (4) graduations sur l'axes.
ou NbreGradMin (5) et N/2.5 (2) graduations sur l'axes.
Delta est l'intervalle entre les graduations qui commencent  PremiereGraduation }
const coeff : array[0..5] of double = (0.1,0.2,0.5,1,2,5);
var  largeur : double;
     index : integer;
     expAxe : integer;
begin with voieOrphy[voieT] do begin
      ExpAxe := floor(Log10(MaxiFFT));
      largeur := maxiFFT*dix(-expAxe);
      index := 0;
      if grandAxe
        then while ( (largeur/coeff[index])>=NbreGraduations ) and (index<5) do inc(index)
        else while ( (largeur/coeff[index])>=NbreGradMin ) and (index<5) do inc(index);
      DeltaAxe := coeff[index]*dix(expAxe);
      PointDebut := deltaAxe;
      if deltaAxe<1000
         then Exposant := 1
         else Exposant := Dix(3);
      NbreChiffre := longNombreAxe;
end end;

var voie : indiceVoie;
    N,Nc,hauteurCourbe : integer;
begin { ChercheMonde }
     if AnalyseurLogique then N := NbreCourbe else N := 1;
     with limiteFenetre do begin
         avecAxeY := ((bottom-top) div 5>NbreGradMin*hautCarac*N div 4)
                  and (AnalyseurLogique or AvecUnAxe);
         avecAxeX := (right-left)>NbreGradMin*4*largCarac;
         grandAxeY := (bottom-top) div 5>NbreGraduations*HautCarac*N div 4;
         grandAxeX := (right-left)>NbreGraduations*4*largCarac;
         MaxGr := 2*right;
         MinGr := -right;
     end;
     limiteCourbe := limiteFenetre;
     inc(limiteCourbe.left,Marge);
     dec(limiteCourbe.bottom,Marge);
     inc(limiteCourbe.top,Marge);
     if avecAxeY then
         inc(limiteCourbe.left,LongNombreAxe*largCarac);
     if avecAxeX then
         dec(limiteCourbe.bottom,hautCarac);
     for voie := voieMin to voieMax do with voieOrphy[voie] do begin
         CourbeTop := LimiteCourbe.top;
         CourbeBottom := LimiteCourbe.bottom;
     end;
     if AnalyseurLogique then begin
        hauteurCourbe := (LimiteCourbe.bottom-LimiteCourbe.top) div NbreCourbe-marge;
        Nc := 0;
        for voie := voieMin to voieMax do with voieOrphy[voie] do
            if active and (voie<>voieAbscisse) then begin
               CourbeTop := LimiteCourbe.top+Nc*hauteurCourbe+succ(Nc)*marge;
               CourbeBottom := CourbeTop+hauteurCourbe;
               inc(Nc);
            end;
     end;
     if oTraceFFT
        then with voieOrphy[voieT] do begin
           maxiFFT := vecteurFFT[pred(NbreFFT)];
           A := (limiteCourbe.right-limiteCourbe.left)/MaxiFFT;
           B := limiteCourbe.left;
           setDeltaFreq(grandAxeX);
        end
        else with voieOrphy[voieAbscisse] do begin
           A := (limiteCourbe.right-limiteCourbe.left)/(Maxi-Mini);
           B := limiteCourbe.left-Mini*A;
           setDelta(grandAxeX);
        end;
     for voie := voieMin to voieMax do with voieOrphy[voie] do
         if active and (voie<>voieAbscisse) then if oTraceFFT
            then begin
               A := (CourbeTop-CourbeBottom)/MaxiFFT;
               B := CourbeBottom;
               setDelta(grandAxeY);
            end
            else begin
               A := (CourbeTop-CourbeBottom)/(Maxi-Mini);
               B := CourbeBottom-Mini*A;
               setDelta(grandAxeY);
             end;
end; { ChercheMonde }


procedure DrawAxis;
var yAxeX : integer;
    xNombreMax : integer;
    PointCourant : double;
    couleurAxe : TcolorRef;

Function XcorrectNombre(x : integer) : boolean;
begin
     XcorrectNombre := (x>(limiteCourbe.left+marge)) and
                       (x<xNombreMax) and
                       (abs(x-limiteCourbe.left)>marge )
end;

Function XcorrectGrad(x : integer) : boolean;
begin
     XcorrectGrad := (x>limiteCourbe.left) and (x<limiteCourbe.right)
end;

procedure MyLine(x1,y1,x2,y2 : integer);
begin
     canvas.moveTo(x1,y1);
     canvas.lineTo(x2,y2);
end;

Procedure graduationX(x : integer);
begin
  if quadrillage
       then MyLine(x,limiteCourbe.top,x,limiteCourbe.bottom)
       else MyLine(x,yAxeX,x,yAxeX+marge);
end;

  procedure initAxeX;
  var x1 : integer;
  begin	 with voieOrphy[voieAbscisse] do begin
	   PointCourant := PointDebut;
     x1 := XWindow(0);
     if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then begin
             canvas.pen.style := psDash;
             canvas.pen.color := CouleurAxe;
	           Myline(x1,limiteCourbe.bottom,x1,limiteCourbe.top);
     end;
  	 canvas.pen.style := psSolid;
	   xNombreMax := limiteFenetre.right-largCarac*longNombreAxe div 2;
     with limiteFenetre do begin
               MyLine(left,yAxeX,right,yAxeX);
          { flches }
               MyLine(right-marge*3,yAxeX+marge,right,yAxeX);
               MyLine(right-marge*3,yAxeX-marge,right,yAxeX);
     end;
	   SetTextAlign(canvas.handle,TA_center+TA_top);
  end end;{initAxeX}

  procedure traceAxeX;
  var xs : integer;
      NombreAff : string;
      arret : double;
  begin with voieOrphy[voieAbscisse] do begin
     if Quadrillage then begin
          canvas.pen.style := psDot;
          canvas.pen.color := CouleurAxe;
     end;
     if oTraceFFT then arret := maxiFFT else arret := maxi;
     repeat
          xs := Xwindow(PointCourant);
      	  if XcorrectGrad(xs) then begin
               graduationX(xs);
               if XcorrectNombre(xs) then begin
        	  if abs(PointCourant)< (Maxi-Mini)/100 then pointCourant := 0;
                  if axeDateTime
                     then NombreAff := ChaineDuree(pointCourant)
                     else if oTraceFFT
                         then NombreAff := intToStr(round(pointCourant/exposant))
                         else NombreAff := formatAxe(pointCourant/exposant);
              	  canvas.TextOut(xs,yAxeX+marge,NombreAff);
      	       end;
          end;
      	  PointCourant := PointCourant+deltaAxe;
     until PointCourant>=Arret;
     SetTextAlign(canvas.handle,TA_left+TA_top);
     if oTraceFFT
        then if deltaAxe<1000
             then NombreAff := 'f(Hz)'
             else NombreAff := 'f(kHz)'
        else if axeDateTime
           then NombreAff := nom
           else NombreAff := nomAxe(exposant);
     canvas.TextOut(limiteFenetre.left+marge,yAxeX+marge,nombreAff);
 end end;{traceAxeX}

 procedure traceAxeLogx;
 var i,j : integer;
     xs,xpred,xsucc : integer;
     intermediaire : boolean;
     ecart : integer;
     NombreAff : string;
begin with voieOrphy[voieAbscisse] do begin
   if Quadrillage then begin
      canvas.pen.style := psDot;
      canvas.pen.color := CouleurAxe;
   end;
   Intermediaire := (Maxi-Mini) <= 3;
   Ecart := largCarac*longNombreAxe;
   Xpred := 0;
   Xsucc := 0;
   for i := floor(Mini) to floor(Maxi) do begin
  	xs := round(A*i+B);
	 if XcorrectGrad(xs) then begin
	     graduationX(xs);
      	     if XcorrectNombre(xs) then begin
                 NombreAff := formatUnite(dix(i));
        	 canvas.TextOut(xs,yAxeX+marge,NombreAff);
             end;
	end;
	if intermediaire then begin
	     xpred := xs;
	     xsucc := round(A*succ(i)+B);
	end;
	for j := 2 to 9 do begin
	     xs := round(A*(i+log10(j))+B);
	     if XcorrectGrad(xs) then
	         if intermediaire
		     then begin
	    	     	graduationX(xs);
              if XcorrectNombre(xs) and
		     	   ( xs>(xpred+ecart) ) and
		     	   ( xs<(xsucc-ecart) ) and
		     	   ( xs<(xnombreMax-ecart) ) then begin
                                NombreAff := formatAxe(j);
                 	        canvas.TextOut(xs,yAxeX+marge,NombreAff);
		      		xpred := xs;
		     	end;
		     end
		     else MyLine(xs,yAxeX,xs,yAxeX+marge);
	  end;{for j}
   end; {for i}
end end;{ TraceAxeLogx }

procedure traceAxeY(m : indiceVoie);
var xx,ys : integer;
    nombreAff : string;
    limiteTop : integer;
begin with voieOrphy[m] do begin
      LimiteTop := CourbeTop+marge;
      if AnalyseurLogique then inc(LimiteTop,hautCarac);
      couleurAxe := couleur;
      setTextAlign(canvas.handle,TA_right+TA_top);
      xx := limiteCourbe.left;
      canvas.pen.color := CouleurAxe;
      PointCourant := PointDebut;
      ys := XWindow(0);
      canvas.pen.style := psSolid;
      if (ys>CourbeTop) and (ys<CourbeBottom) then
          Myline(limiteCourbe.left,ys,limiteCourbe.right,ys);
      MyLine(xx,CourbeBottom,xx,CourbeTop);
    { flche }
      MyLine(xx-marge,CourbeTop+3*marge,xx,CourbeTop);
      MyLine(xx+marge,CourbeTop+3*marge,xx,CourbeTop);
      canvas.font.Color := couleurAxe;
      if Quadrillage then canvas.pen.style := psDot;
      xx := xx-marge;
      repeat
           ys := Xwindow(PointCourant);
	   {coordonne cran de marque}
           if (ys>CourbeTop) and (ys<CourbeBottom) then begin
                 if quadrillage
                    then MyLine(limiteCourbe.left,ys,limiteCourbe.right,ys)
                    else MyLine(limiteCourbe.left,ys,limiteCourbe.left+marge,ys);
                 if ( ys>(LimiteTop)) and
                    ( ys<(CourbeBottom-marge)) and
		    ( abs(ys-yAxeX)>marge ) then begin
	   	    if abs(pointCourant) < (Maxi-Mini)/1000 then pointCourant := 0;
                    NombreAff := formatAxe(pointCourant/exposant);
	   	              Canvas.TextOut(xx,ys-marge,NombreAff);
                 end;
	        end;
      	  pointCourant := pointCourant+deltaAxe;
     until ( pointCourant>=Maxi );
     canvas.TextOut(xx,courbeTop-marge,nomAxe(exposant));
 end end;{traceAxeY}

procedure zeroX;
var x1 : integer;
begin with voieOrphy[voieAbscisse] do
   x1 := XWindow(0);
   if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then begin
        canvas.pen.style := psDot;
        canvas.pen.color := couleurAxe;
        Myline(x1,limiteCourbe.bottom,x1,limiteCourbe.top);
   end;
end;{zeroX}

procedure zeroY(m : indiceVoie);
var y1 : integer;
begin with voieOrphy[m] do begin
     y1 := Xwindow(0);
     if (y1>CourbeTop) and (y1<CourbeBottom) then begin
          canvas.pen.style := psSolid;
          canvas.pen.color := couleurAxe;
          Myline(limiteCourbe.left,y1,limiteCourbe.right,y1);
     end
end end;{zeroY}

var voie : indiceVoie;
begin{ DrawAxis }
     couleurAxe := voieOrphy[voieAbscisse].couleur;
     canvas.font.Color := CouleurAxe;
     yAxeX := limiteCourbe.bottom;
     if avecAxeX then begin
          initAxeX;
          if voieOrphy[voieAbscisse].AxeLog
             then traceAxeLogX
             else traceAxeX;
          zeroX;
     end;
     if AnalyseurLogique
        then begin
           for voie := voieMin to voieMax do with voieOrphy[voie] do
            if active and (voie<>voieAbscisse) then
                if avecAxeY
                   then traceAxeY(voie)
                   else zeroY(voie);
         end
         else begin
             voie := succ(voieMin);
             while (voie<voieMax) and
                   (not(voieOrphy[voie].active) or (voie=voieAbscisse)) do
                inc(voie);
             if avecAxeY
                 then traceAxeY(voie)
                 else zeroY(voie);
         end;
     SetTextAlign(canvas.handle,TA_left+TA_top);
end;{ DrawAxis }

var i : integer;
begin
     with limiteFenetre do setHauteurFonte((bottom-top) div 30);
     canvas.pen.width := 1;
     canvas.Pen.style := psDot;
     canvas.pen.color := voieOrphy[voieT].couleur;
     setBkMode(canvas.handle,transparent);
     chercheMonde;
     drawAxis;
     TraceCourbes;
     for i := 0 to pred(ListeRepere.count) do
         TraceRepere(ListeRepere[i]);
     ReticuleTrace := false;         
end;

procedure Tgraphe.Draw(TexteAbscisse : String);
var maxiX,miniX : double;
    i : indiceVecteur;
    xi,yi : integer;
    largeur : integer;
begin
     canvas.pen.width := 1;
     canvas.pen.style := psSolid;
     canvas.pen.color := clBlue;
     miniX := vecteurX[0];
     maxiX := vecteurX[pred(NbrePoints)];
     AX := (limiteFenetre.right-limiteFenetre.left)/(MaxiX-MiniX);
     BX := limiteFenetre.left-MiniX*AX;
     AY := (limiteFenetre.top-limiteFenetre.bottom)/(MaxiY-MiniY);
     BY := limiteFenetre.Bottom-MiniY*AY;
     xi := round(AX*vecteurX[0]+BX);
     yi := round(AY*vecteurY[0]+BY);
     canvas.MoveTo(xi,yi);
     for i := 0 to pred(NbrePoints) do begin
        yi := round(AY*vecteurY[i]+BY);
        canvas.LineTo(xi,yi);
        xi := round(AX*vecteurX[i]+BX);
        canvas.LineTo(xi,yi);
     end;{for i}
     xi := round(AX*vecteurX[0]+BX);
     yi := round(AY*y0+BY);
     canvas.MoveTo(xi,yi);
     xi := round(AX*vecteurX[pred(NbrePoints)]+BX);
     canvas.pen.style := psDot;
     canvas.pen.color := clBlack;
     canvas.LineTo(xi,yi);
     largeur := canvas.textWidth(TexteAbscisse);
     canvas.textOut(xi-largeur-10,yi-10,TexteAbscisse);
end;

procedure TgrapheGTI.TraceCourbes;

procedure TraceUneCourbe(voie : integer);

Procedure TracePoints;
var i : indiceVecteur;
    xi,yi : integer;
    pixel : boolean;
begin with voieOrphy[voie] do begin
   canvas.brush.color := couleur;
   canvas.brush.style := bsSolid;
   pixel := (dimPoint=0);
   for i := 0 to pred(NbreAff) do begin
       xi := voieOrphy[voieAbscisse].XWindow(voieOrphy[voieAbscisse].vecteurAff[i]);
       yi := XWindow(vecteurAff[i]);
       if (xi<>IntSansSignif) and (yi<>IntSansSignif)
           then if pixel
             then canvas.pixels[xi,yi] := couleur
             else TraceMotif(xi,yi,motif)
      end;{i}
end end;{tracePoints}

Procedure traceLignes;
var i : indiceVecteur;
    PointPrecedent : boolean;
    xi,yi : integer;
begin with voieOrphy[voie] do begin
     PointPrecedent := false;
     for i := 0 to pred(NbreAff) do begin
        xi := voieOrphy[voieAbscisse].XWindow(voieOrphy[voieAbscisse].vecteurAff[i]);
        yi := XWindow(vecteurAff[i]);
        if (xi=IntSansSignif) or (yi=IntSansSignif)
          then pointPrecedent := false
          else if PointPrecedent
               then canvas.LineTo(xi,yi)
               else begin
                  canvas.MoveTo(xi,yi);
                  pointPrecedent := true;
               end;
     end;{for i}
end {i} end;{traceLignes}

Procedure traceSpectre;
var i : indiceVecteur;
    PointPrecedent : boolean;
    xi,yi : integer;
begin with voieOrphy[voie] do begin
     PointPrecedent := false;
     for i := 0 to pred(NbreFFT) do begin
        xi := voieOrphy[voieAbscisse].XWindow(voieOrphy[voieAbscisse].vecteurFFT[i]);
        yi := XWindow(vecteurFFT[i]);
        if (xi=IntSansSignif) or (yi=IntSansSignif)
          then pointPrecedent := false
          else if PointPrecedent
               then canvas.LineTo(xi,yi)
               else begin
                  canvas.MoveTo(xi,yi);
                  pointPrecedent := true;
               end;
     end;{for i}
end {i} end;{traceSpectre}

var yi : integer;
begin with voieOrphy[voie] do begin
      canvas.pen.style := psSolid;
      canvas.pen.color := couleur;
      if (modeAcq=AcqTemps) and
         (modeSynchro=s_seuil) and
         (voie=voieSynchro) then begin
           yi := XWindow(valeurReal(seuilSynchro));
           canvas.pen.style := psDash;
           canvas.moveTo(limiteCourbe.left,yi);
           canvas.lineTo(limiteCourbe.right,yi);
           canvas.pen.style := psSolid;
      end;
      if NbreAff=0 then exit;
      if oTraceFFT
         then TraceSpectre
         else begin
               if oTraceLigne then TraceLignes;
               if oTracePoints then TracePoints;
         end;
end end;{ TraceUneCourbe }

var voie : indiceVoie;
begin
     canvas.pen.width := 1;
     for voie := succ(voieMin) to voieMax do
         if voieOrphy[voie].active and (voie<>voieAbscisse) then
            traceUneCourbe(voie);
end;

destructor TgrapheGTI.destroy;
var i : indiceVoie;
begin
     ListeRepere.Free;
     for i := voieMin to VoieMax do voieOrphy[i].free;
     inherited destroy;
end;

constructor TgrapheGTI.Create;

Procedure DefinitMagnum;
var fichier : tMemIniFile;
    NomFichier : string;
begin
    Magnum := Tmagnum.create;
    voieOrphy[voieMagnum] := Magnum;
    NomFichier := appDataDir+'gti.INI';
    fichier := tMemIniFile.create(nomFichier);
    magnum.load('Magnum',fichier);
    fichier.free;
end;

Procedure DefinitNumero;
var i : integer;
begin
    Numero := Tcourbe.create('num','','Numro d''ordre',voieNum);
    voieOrphy[voieNum] := Numero;
    for i := 0 to maxVecteur do begin
        Numero.vecteurAff[i] := i;
        Numero.vecteurCourant[i] := i;
    end;
end;

Procedure DefinitBurette;
var fichier : tMemIniFile;
    NomFichier : string;
begin
    NomFichier := appDataDir+'gti.INI';
    fichier := tMemIniFile.create(nomFichier);
    fichier.free;
end;

Procedure ValeurDefaut;
begin
       voieAbscisse := voieA;
       oTraceLigne := true;
       oTracePoints := false;
       oTraceFFT := false;
       quadrillage := false;
       AnalyseurLogique := false;
       Monocoup := true;
       AvecUnAxe := true;
       Front := 1;
       montant := true;
       modeAcq := AcqPoint;
       seuilSynchro := 0;
       voieSynchro := voieA;
       modeSynchro := s_clavier;
       dimPoint := 5;
       Magnum.active := false;
       NbreFFT := 512;
end;

var voie : indiceVoie;
begin
  inherited create;
  ListeRepere := Tlist.Create;
  DefinitMagnum;
  BaseDeTemps := TbaseDeTemps.create(self);
  voieOrphy[voieT] := BaseDeTemps;
  FrequenceU := Tunite.create;
  FrequenceU.nomUnite := 'Hz';
  Frequence := Tfrequence.create;
  voieOrphy[voieF] := Frequence;
  DefinitNumero;
  SortieAnalogique := TsortieAnalogique.create;
  voieOrphy[voieSA] := SortieAnalogique;
  EntreeBinaire := TentreeBinaire.create;
  voieOrphy[voieEB] := EntreeBinaire;
  SortieBinaire := TsortieBinaire.create;
  voieOrphy[voieSB] := SortieBinaire;
  EntreeClavier := Tcourbe.create('X','','',voieClavier);
  voieOrphy[voieClavier] := EntreeClavier;
  for voie := voieA to voieAnaMax do begin
      voieEA[voie] := TentreeAna.create(voie);
      voieOrphy[voie] := voieEA[voie];
  end;
  voieOrphy[voieA].active := true;
  voieOrphy[succ(voieA)].active := true;
  for voie := voieMin to voieMax do
      with voieOrphy[voie] do
           if couleur=clWindow then couleur := clActiveCaption;
  ValeurDefaut;
end;

constructor Tcourbe.create(Anom : string;Aunite: string;
    Asignif : string;Anumero :integer);
begin
     inherited create(Anumero);
     active := false;
     NbreMoyenne := 1;
     A := 1;
     B := 0;
     Maxi := 1;
     Mini := 0;
     nom := Anom;
     NomUnite := Aunite;
     signif := Asignif;
     axeLog := false;
     indexDernier := 0;
end;

constructor TsortieAnalogique.create;
var i : integer;
begin
     inherited create('Vsa','V',trTensionSA,voieSA);
     DebutSortie[1] := 0;
     FinSortie[1] := maxiHardSA;
     for i := 2 to NbreRampeMax do begin
         DebutSortie[i] := 0;
         FinSortie[i] := 0;
     end;
     PasSortie := 1;
     NbrePulse := 1;
     NbreRampes := 1;
     LargeurPulse := 10;
     SAi := '0';
     NbreInterSA := 256;
     Modif := true;
     tension := Positive;
     ModeSA := saRampe;
     numeroOrphy := 0;
end;

constructor TsortieBinaire.create;
begin
     inherited create('SB','','',voieSB);
     FinEchelon := 200;
     DebutEchelon := 10;
     FnbreSB := 8;
     NbreInterSB := 256;
     Fmasque := 255;
     Modif := true;
     modeSb := sbEchelon;
     Mini := 0;
     Maxi := 255;
end;

constructor TentreeBinaire.create;
begin
     inherited create('EB','',trEntreeBin,voieEB);
     FnbreEB := 1;
     Masque := 1;
     Maxi := 1;
     Mini := 0;
     tension := Positive;
end;

constructor Tfrequence.create;
begin
     inherited create('f','Hz',trFrequence,voieF);
     Mini := 100;
     MiniF := 100;
     Maxi := 10000;
     MaxiF := 10000;
     EFi := '0';
     modeEF0 := 'F';
     increment := 1;
     numeroOrphy := voieOrphyEF0;
     Decrementer := false;
     DebutCompteur := 0;
end;

constructor Tmagnum.create;
begin
     inherited create('x','m',trMagnum,voieMagnum);
     EFi := '0';
     nomUnite := 'm';
     modeAngulaire := false;
     modeRadian := false;
end;

Function Tmagnum.ValeurReal(V : integer) : double;
begin
    Result := V*PeriodeMagnumE
end;

Procedure Tmagnum.Load(Avoie : string;fichier : tMemIniFile);
begin
   inherited load(Avoie,fichier);
   if nom='Magnum' then nom := 'x';
   with fichier do begin
         periodeMagnumE := ReadFloat(Avoie,'Pas',PeriodeMagnum);
         EFi := ansiChar(readInteger(Avoie,'EF',strToInt(EFi)));
         modeAngulaire := ReadBool(Avoie,'angle',false);
         Attente := ReadInteger(Avoie,'Attente',10);
         modeRadian := ReadBool(Avoie,'radian',false);
         chuteMagnum := ReadBool(Avoie,'chute',false);
         if not modeAngulaire and not ChuteMagnum then
             PeriodeMagnumE := PeriodeMagnum;
         avecPotar := false;
         expression := '';
         etalonnage := eNone;
         indexCapteurAuto := 0;
         Tension := NegAndPos;
         isPhotocolor := false;
   end;
end;

Procedure Tmagnum.Store(Avoie : string;fichier : tMemIniFile);
begin
   inherited store(Avoie,fichier);
   with fichier do begin
         WriteBool(Avoie,'radian',ModeRadian);
         WriteBool(Avoie,'angle',ModeAngulaire);
         WriteBool(Avoie,'chute',chuteMagnum);         
         WriteFloat(Avoie,'Pas',PeriodeMagnumE);
         WriteInteger(Avoie,'EF',ord(EFi));
         WriteInteger(Avoie,'Attente',Attente);
   end
end;

constructor TbaseDeTemps.create(graphe : TgrapheGTI);
begin
     inherited create('t','s',trDuree,voieT);
     Mini := 0;
     numeroOrphy := voieOrphyEF0;
     dureeBalayage := 1;
     Maxi := DureeBalayage;
     FDureeMinMax := 0.001;
     Fgraphe := graphe;
end;

destructor Tcourbe.destroy;
begin
     inherited destroy
end;

procedure Tcourbe.SetDelta(grandAxe : boolean);
{ Exposant=puissance de 10 multiple de 3 de manire  avoir entre
NbreGraduations (10) et N/2.5 (4) graduations sur l'axes.
ou NbreGradMin (5) et N/2.5 (2) graduations sur l'axes.
Delta est l'intervalle entre les graduations qui commencent  PremiereGraduation }
const coeff : array[0..5] of double = (0.1,0.2,0.5,1,2,5);
var  AbsMax,AbsMin,largeur : double;
     ExpAxe,index : integer;
     N : integer;
begin
      try
      AbsMax := abs(maxi);
      AbsMin := abs(mini);
      if AbsMax<AbsMin then AbsMax := AbsMin;
      axeDateTime := (nomUnite='s') and (AbsMax>QuartdHeure);
      if axeDateTime then begin
          NbreChiffre := longNombreAxe;
          DeltaAxe := (Maxi-Mini)/6;
          if DeltaAxe>UnJour
             then DeltaAxe := ceil(DeltaAxe/UnJour)*UnJour
             else if DeltaAxe>UneHeure
                 then begin
                    N := round(DeltaAxe/UneHeure);
                    case N of
                         1,2,3,4 : ;
                         5 : N := 6;
                         6 : ;
                         7 : N := 8;
                         8 : ;
                         9,10,11 : N := 12;
                         12 : ;
                         13,14,15,16,17 : N := 12;
                         18,19,20,21,22,23,24 : N := 24;
                    end;
                    DeltaAxe := N*UneHeure;
                 end
                 else if DeltaAxe>QuartdHeure
                      then DeltaAxe := ceil(DeltaAxe/QuartdHeure)*QuartdHeure
                      else DeltaAxe := ceil(DeltaAxe/UneMinute)*UneMinute;
          PointDebut := 0;
          Exposant := 1;
          exit;
      end;
      ExpAxe := floor(Log10(Maxi-Mini));
      largeur := (maxi-mini)*dix(-expAxe);
      index := 0;
      if grandAxe
        then while ( (largeur/coeff[index])>=NbreGraduations ) and (index<5) do inc(index)
        else while ( (largeur/coeff[index])>=NbreGradMin ) and (index<5) do inc(index);
      DeltaAxe := coeff[index]*dix(expAxe);
      NbreChiffre := ceil(Log10(AbsMax))-floor(Log10(DeltaAxe));
      PointDebut := ceil(mini/deltaAxe)*deltaAxe;
      Index := ExpAxe div 3;
      if ( (ExpAxe mod 3) < 0) then dec(index);
  { la division euclidienne des informaticiens <> div des maths ! }
      Exposant := Dix(3*Index);
      N := ceil(Log10(AbsMax/Exposant));
      if N>NbreChiffre then NbreChiffre := N;
      if NbreChiffre<3 then NbreChiffre := 3;
      if (NbreChiffre>longNombreAxe) or axeLog then
         NbreChiffre := longNombreAxe;
      except
         Mini := 0;
         Maxi := 1;
         NbreChiffre := 5;
         PointDebut := 0;
         axeDateTime := false;
         DeltaAxe := 0.2;
      end;
end;

Function Tcourbe.FormatAxe(x : double) : string;
begin
     FormatAxe := FloatToStrF(x,ffGeneral,NbreChiffre,0)
end;

Procedure TgrapheGti.Tri;
{ Tri Shell Meyer-Baudoin p 456 }
{ origine vecteur en 0 }
var cle : double;
    i,j : integer;
    v : indiceVoie;
    SauvePoint : array[indiceVoie] of double;
    voieTri : integer;
Begin
    if modeAcq=AcqTemps then exit;
    if voieOrphy[voieF].active
       then begin
          if frequence.modeEF0='M' then exit;
          voieTri := voieF;
       end
       else if (modeAcq in [AcqPoint]) and TrierAbscisse
          then voieTri := voieAbscisse
          else exit;
    i := 1;
    while (i<NbreAff) do begin
        for v := voieT to VoieMax do
            sauvePoint[v] := voieOrphy[v].vecteurAff[i];
        cle := voieOrphy[voieTri].vecteurAff[i];
        j := pred(i);
        while (j>=0) and (voieOrphy[voieTri].vecteurAff[j]>cle) do begin
             for v := voieT to VoieMax do
                 voieOrphy[v].vecteurAff[succ(j)] := voieOrphy[v].vecteurAff[j];
             dec(j);
        end;
        for v := voieT to VoieMax do
            voieOrphy[v].vecteurAff[succ(j)] := sauvePoint[v];
        inc(i);
    end;
end;{tri}

Function TsortieAnalogique.ValeurVolt(V : integer) : double;
begin
    Result := V*5.0/maxiHardSA;
    if SAi='1' then Result := 2*Result-5.0;
    if SAi='2' then Result := 12*Result-30.0;
end;

Function TsortieAnalogique.ValeurYSA(V : double) : word;
begin
    result := 0;
    if SAi='0' then begin
          if V>5 then V := 5;
          if V<0 then V := 0;
          Result := round(maxiHardSA*V/5.0);
          exit
    end;
    if SAi='1' then begin
          if V>5 then V := 5;
          if V<-5 then V := -5;
          Result := round(maxiHardSA*(V+5.0)/10.0);
          exit;
    end;
    if SAi='2' then begin
         if V>30 then V := 30;
         if V<-30 then V := -30;
         Result := round(maxiHardSA*(V+30.0)/60.0)
    end;
end;

Function TsortieAnalogique.ValeurYtele(V : double) : word;
begin
    if SAi='0' then begin
       if V>5 then V := 5;
       if V<0 then V := 0;
    end;
    if SAi='1' then begin
       if V>5 then V := 5;
       if V<-5 then V := -5;
    end;
    if SAi='2' then begin
       if V>30 then V := 30;
       if V<-30 then V := -30;
       V := (V+30)/12; { GP30-5 par SA0 : -30V=OV +30V=+5V }
    end;
    if V<0
       then Result := round(65535+V/5.0*Hard5V)
       else Result := round(V/5.0*Hard5V);
end;

Function TsortieAnalogique.ValeurReal(V : integer) : double;
begin
    Result := ValeurVolt(V);
    if etalonnage=eNonLin then
      if parser<>nil
             then begin
                VoltParser^ := valeurVolt(V);
                result := Parser.Value;
             end
             else result := sansSignif;
end;

Function TentreeBinaire.ValeurReal(V : integer) : double;
begin
    Result := V and masque
end;

Function TsortieBinaire.ValeurReal(V : integer) : double;
begin
    Result := V
end;

procedure TgrapheGTI.CourantVersAff;
var voie : indiceVoie;
    CompteurVoieAna : integer;

Procedure Decale(voie : indiceVoie);
var j : integer;
    alphaLoc : double;
begin with voieOrphy[voie] do begin
     AlphaLoc := CoeffInterp*CompteurVoieAna;
     vecteurAff[0] := valeurReal(vecteurCourant[0])*(1+alphaLoc)-
                      valeurReal(vecteurCourant[1])*alphaLoc;
     for j := 1 to pred(nbreCourant) do
         vecteurAff[j] := valeurReal(vecteurCourant[pred(j)])*alphaLoc+
                          valeurReal(vecteurCourant[j])*(1-alphaLoc);
     inc(CompteurVoieAna);
end end;

Procedure Recopie(voie : indiceVoie);
var j : integer;
begin with voieOrphy[voie] do
     if active then
     for j := 0 to pred(nbreCourant) do
         vecteurAff[j] := valeurReal(vecteurCourant[j])
end;

var maxW,minW,vW : double;
begin
    with voieOrphy[voieMagnum] do
     if active then begin
         if ChuteMagnum
            then CorrigeChute(vecteurAff,vecteurCourant,NbreCourant)
            else CorrigeMagnum(voieOrphy[voieT].vecteurAff,
                     vecteurAff,vecteurCourant,NbreCourant);
         GetMinMax(vecteurAff,NbreCourant,minW,maxW);
         vW := (maxW-minW)/20;
         if vW=0 then vW := 0.10;
         maxi := (maxW + vW);
         mini := (minW - vW);
     end;
    Recopie(voieEB);
    compteurVoieAna := 0;
    for voie := voieA to VoieAnaMax do
        if voieOrphy[voie].active then decale(voie);
    NbreAff := NbreCourant;
end;{CourantVersAff}

Function TsortieAnalogique.NomVoieOrphy : string;
begin
     if SAi='2' then result:='GP 30-5' else result := 'SA'+SAi
end;

Function TsortieAnalogique.codeSortie(i : integer) : shortString;
begin
     if SAi='2'
        then result := 'YSA 0'
        else result := 'YSA '+SAi;
     result := result+' '+IntToStr(vecteurYSA[i]);
     valeurCourante := valeurReal(vecteurYSA[i]);
end;

Function Tfrequence.NomVoieOrphy : string;
var maxmax : double;
begin
     result := 'EF'+EFi+' ';
     if modeEF0='M'
        then begin
            result := result + 'N ';
            MaxMax := abs(maxi);
            if MaxMax<abs(mini) then MaxMax := abs(mini);
            Exponent := floor(Log10(MaxMax));
            if (Exponent mod 3) < 0
                then Exponent := (Exponent div 3)-1
                else Exponent := Exponent div 3;
  { la division euclidienne des informaticiens <> div des maths ! }
            Exponent := 3*Exponent;
            ExposantAff := Dix(Exponent);
            NbreAvantVirgule := floor(Log10(MaxMax/ExposantAff))+2;
        end
        else result := result + 'f '
end;

Procedure TsortieAnalogique.CalcVecteur;
var i,idebut,j,k,offset,pas,N : integer;
    marge : double;
begin
        case ModeSA of
             saRampe : begin
                NbreInterSA := 0;
                if NbreRampes=0 then begin
                   NbreRampes := 1;
                   finSortie[1] := 128;
                   debutSortie[1] := 0;
                end;
                for j := 1 to NbreRampes do begin
                    if finSortie[j]>debutSortie[j]
                         then pas := pasSortie
                         else pas := -pasSortie;
                    N := abs(finSortie[j]-debutSortie[j]) div pasSortie;
                    if (N<1) or (pasSortie>1) then inc(N); 
                    if (j=1) or (debutSortie[j]<>finSortie[j-1])
                       then idebut := 0
                       else idebut := 1;
                    for i := idebut to N do begin
                        k := debutSortie[j]+i*pas;
                        vecteurAff[NbreInterSA] := valeurReal(k);
                        vecteurYSA[NbreInterSA] := k;
                        vecteurCourant[NbreInterSA] := valeurYtele(valeurVolt(k));
                        inc(NbreInterSA);
                    end; // for i
                end; // for j
             end; // saRampe
             saImpulsion : begin
                 NbreInterSA := NbreMaxSA;
                 for i := 0 to pred(NbreInterSA) do begin
                     vecteurAff[i] := valeurVolt(debutSortie[1]);
                     vecteurYSA[i] := debutSortie[1];
                 end;
                 for j := 0 to pred(NbrePulse) do begin
                     offset := debutPulse+j*DeltaPulse;
                     if offset>=nbreInterSA then break;
                     for i := 0 to pred(LargeurPulse) do begin
                         if offset+i>=NbreInterSA then break;
                         vecteurAff[offset+i] := valeurVolt(finSortie[1]);
                         vecteurYSA[offset+i] := finSortie[1];
                     end;
                 end;
                 for i := 0 to pred(NbreInterSA) do
                     vecteurCourant[i] := valeurYtele(vecteurAff[i]);
             end;
             saUtilisateur : for i := 0 to pred(NbreInterSA) do begin
                  vecteurAff[i] := vecteurUtilisateur[i];
                  vecteurYSA[i] := valeurYsa(vecteurUtilisateur[i]);
                  vecteurCourant[i] := valeurYtele(vecteurAff[i]);
             end;
         end;
         if (SAi='0') and ((modeSA<>saRampe) or (expression='')) then
            for i := 0 to pred(NbreInterSA)do
                if vecteurAff[i]<0 then vecteurAff[i] := 0;
         for i := pred(NbreInterSA) downto 1 do
             vecteurAff[i] := vecteurAff[pred(i)];
      maxi := vecteurAff[0];
      mini := maxi;
      for i := 1 to pred(NbreInterSA) do begin
          if vecteurAff[i]>maxi
            then maxi := vecteurAff[i]
            else if vecteurAff[i]<mini
                then mini := vecteurAff[i]
      end;
      marge := (maxi-mini)/16;
      if mini>=0 then
         if mini<marge
            then mini := 0
            else mini := mini-marge;
      maxi := maxi+marge;
end;

Procedure TsortieBinaire.CalcVecteur;
var i : integer;
begin
        case ModeSB of
             sbRampe : begin
                 NbreInterSB := Masque+1;
                 for i := 0 to pred(nbreInterSB) do
                     vecteurCourant[i] := i;
             end;
             sbEchelon : begin
                 for i := 0 to pred(NbreInterSB) do
                     vecteurCourant[i] := 0;
                 for i := DebutEchelon to FinEchelon do
                     vecteurCourant[i] := Masque;
             end;
             sbUtilisateur : for i := 0 to pred(NbreInterSB) do
                  vecteurCourant[i] := vecteurUtilisateur[i];
        end;
        for i := 0 to pred(NbreInterSB) do
            vecteurAff[i] := vecteurCourant[i];
end;

Procedure TsortieAnalogique.Load(Avoie : string;fichier : tMemIniFile);
var i : integer;
begin
   inherited load(Avoie,fichier);
   with fichier do begin
        debutSortie[1] := ReadInteger(Avoie,'Debut',50);
        PasSortie := ReadInteger(Avoie,'Pas',1);
        finSortie[1] := ReadInteger(Avoie,'Fin',250);
        NbreRampes := ReadInteger(Avoie,'Nrampes',1);        
        for i := 1 to NbreRampeMax do begin
            debutSortie[i] := ReadInteger(Avoie,'Debut'+intToStr(i),debutSortie[i]);
            finSortie[i] := ReadInteger(Avoie,'Fin'+intToStr(i),finSortie[i]);
        end;
        SAi := AnsiChar(ReadInteger(Avoie,'Code',strToint(SAi)));
        NbreInterSA := ReadInteger(Avoie,'Nombre',255);
        if NbreInterSA>NbreMaxSA then NbreInterSA := NbreMaxSA;
        ModeSA := TmodeSA(ReadInteger(Avoie,'Mode',0));
        NbrePulse := ReadInteger('Impulsion','Nombre',1);
        LargeurPulse := ReadInteger('Impulsion','Largeur',1);
        DeltaPulse := ReadInteger('Impulsion','Delta',10);
        DebutPulse := ReadInteger('Impulsion','Debut',10);
        if modeSA=saUtilisateur then
           for i := 0 to pred(NbreInterSA) do
               vecteurUtilisateur[i] := ReadFloat('SA',IntToStr(i),valeurVolt(i));
     end;
     CalcVecteur;
end;

Procedure TsortieBinaire.Load(Avoie : string;fichier : tMemIniFile);
var i : integer;
begin
   inherited load(Avoie,fichier);
   with fichier do begin
        ModeSB := TmodeSB(ReadInteger(Avoie,'Mode',1));
        FinEchelon := ReadInteger('Echelon','Fin',200);
        NbreInterSB := ReadInteger(Avoie,'NombreInter',256);
        DebutEchelon := ReadInteger('Echelon','Debut',50);
        NbreSB := ReadInteger(Avoie,'Nbre',8);
        if modeSB=sbUtilisateur then
           for i := 0 to pred(NbreInterSB) do
               vecteurUtilisateur[i] := ReadInteger('SB',IntToStr(i),i);
     end;
     CalcVecteur;
end;

Procedure TsortieAnalogique.Store(Avoie : string;fichier : tMemIniFile);
var i : integer;
begin
   inherited store(Avoie,fichier);
   with fichier do begin
        for i := 1 to NbreRampeMax do begin
            WriteInteger(Avoie,'Debut'+intToStr(i),debutSortie[i]);
            WriteInteger(Avoie,'Fin'+intToStr(i),finSortie[i]);
        end;
        WriteInteger(Avoie,'Debut',debutSortie[1]);
        WriteInteger(Avoie,'Nrampes',NbreRampes);
        WriteInteger(Avoie,'Fin',finSortie[1]);
        WriteInteger(Avoie,'Pas',PasSortie);
        WriteInteger(Avoie,'Code',ord(SAi));
        WriteInteger(Avoie,'Nombre',NbreInterSA);
        WriteInteger(Avoie,'Mode',ord(modeSA));
        WriteInteger('Impulsion','Nombre',NbrePulse);
        WriteInteger('Impulsion','Largeur',LargeurPulse);
        WriteInteger('Impulsion','Delta',DeltaPulse);
        WriteInteger('Impulsion','Debut',DebutPulse);
        if modeSA=saUtilisateur then
           for i := 0 to pred(NbreInterSA) do
               WriteFloat('SA',IntToStr(i),vecteurUtilisateur[i]);
   end
end;

Procedure TsortieBinaire.Store(Avoie : string;fichier : tMemIniFile);
var i : integer;
begin
   inherited store(Avoie,fichier);
   with fichier do begin
        WriteInteger(Avoie,'Mode',ord(modeSB));
        WriteInteger('Echelon','Fin',FinEchelon);
        WriteInteger(Avoie,'Nbre',FNbreSB);
        WriteInteger(Avoie,'NombreInter',NbreInterSB);
        WriteInteger('Echelon','Debut',DebutEchelon);
        if modeSB=sbUtilisateur then
           for i := 0 to pred(NbreInterSB) do
               WriteInteger('SB',IntToStr(i),vecteurUtilisateur[i]);
   end
end;

Procedure TentreeBinaire.Load(Avoie : string;fichier : tMemIniFile);
begin
   inherited load(Avoie,fichier);
   with fichier do begin
        NbreEB := ReadInteger(Avoie,'Nbre',8);
   end;
   Mini := 0;
end;

Procedure TentreeBinaire.setNbreEB(value : integer);
var i : integer;
    j : word;
begin
   FnbreEB := value;
   Masque := 0;
   j := 1;
   for i := 1 to FnbreEB do begin
       Masque := Masque+j;
       j := j*2;
   end;
   Maxi := Masque+1;
end;

Procedure TsortieBinaire.setNbreSB(value : integer);
var i : integer;
    j : word;
begin
   FnbreSB := value;
   FMasque := 0;
   j := 1;
   for i := 1 to FnbreSB do begin
       FMasque := FMasque+j;
       j := j*2;
   end;
   Maxi := FMasque+1;
end;

Procedure TentreeBinaire.Store(Avoie : string;fichier : tMemIniFile);
begin
   inherited store(Avoie,fichier);
   with fichier do begin
        WriteInteger(Avoie,'Nbre',FnbreEB);
   end
end;

Procedure TbaseDeTemps.Load(Avoie : string;fichier : tMemIniFile);
begin
   inherited load(Avoie,fichier);
   with fichier do begin
        DureeBalayage := ReadFloat(Avoie,'Dure',1.0);
        PreAcq10 := ReadInteger(Avoie,'PreAcq',0);
        DureeMinMax := ReadFloat(Avoie,'DureeMinMax',0.001);        
   end
end;

Procedure TbaseDeTemps.Store(Avoie : string;fichier : tMemIniFile);
begin
   inherited store(Avoie,fichier);
   with fichier do begin
        WriteFloat(Avoie,'Dure',DureeBalayage);
        WriteInteger(Avoie,'PreAcq',PreAcq10);
        WriteFloat(Avoie,'DureMinMax',DureeMinMax);
   end
end;

Procedure Tfrequence.Load(Avoie : string;fichier : tMemIniFile);
begin
   inherited load(Avoie,fichier);
   EFi := AnsiChar(fichier.ReadInteger(Avoie,'Code',strToInt(EFi)));
   AxeLog := fichier.readBool(Avoie,'Log',false);
   MiniF := fichier.ReadFloat(Avoie,'miniF',100);
   MaxiF := fichier.ReadFloat(Avoie,'maxiF',10000);
   DebutCompteur := fichier.ReadFloat(Avoie,'debut',0);
   modeEF0 := AnsiChar(fichier.ReadInteger(Avoie,'mode',ord(modeEF0)));
   increment := fichier.ReadFloat(Avoie,'increment',1);
   decrementer := fichier.ReadBool(Avoie,'moins',false);
end;

Procedure Tfrequence.Store(Avoie : string;fichier : tMemIniFile);
begin
   inherited store(Avoie,fichier);
   fichier.WriteInteger(Avoie,'Code',ord(EFi));
   fichier.WriteBool(Avoie,'Log',AxeLog);
   fichier.WriteFloat(Avoie,'miniF',miniF);
   fichier.WriteFloat(Avoie,'maxiF',maxiF);
   fichier.WriteFloat(Avoie,'debut',debutCompteur);   
   fichier.WriteInteger(Avoie,'mode',ord(modeEF0));
   fichier.WriteFloat(Avoie,'increment',increment);
   fichier.WriteBool(Avoie,'moins',decrementer);
end;

Function Tfrequence.CalibreVoie : string;
begin
    if ModeEF0='M'
       then result := 'x'+formatUnite(increment)
       else result := formatUnite(maxiF)
end;

Function TsortieAnalogique.CalibreVoie : string;
begin
    if SAi='0' then result := '0-5 V';
    if SAi='1' then result := '5V';
    if SAi='2' then result := '30V';
end;

Function TentreeBinaire.CalibreVoie : string;
begin
    result := IntToStr(masque)
end;

Function TsortieBinaire.CalibreVoie : string;
begin
    result := ''
end;

Function TentreeBinaire.NomValeurUnite(Nombre : double) : string;
var entier : word;
    hexa : string;
begin
    entier := round(nombre);
    hexa := HexW(entier);
    Delete(Hexa,1,2);
    NomValeurUnite := IntToStr(entier)+'='+
                      Hexa+'h='+
                      copy(BinaryW(entier),17-FnbreEB,FnbreEB)+'b'
end;

procedure Tmagnum.setModeAngulaire(value : boolean);
begin
     if FmodeAngulaire<>value then begin
        FmodeAngulaire := value;
        if value then begin
            if modeRadian
               then nomUnite := 'rad'
               else nomUnite := ''
        end
        else begin
             PeriodeMagnumE := PeriodeMagnum;
             nomUnite := 'm';
        end
     end;
end;

procedure Tmagnum.setModeRadian(value : boolean);
begin
     if (FmodeRadian<>value) and FmodeAngulaire then begin
        FmodeRadian := value;
        if value
             then nomUnite := 'rad'
             else nomUnite := ''
     end;
end;

Function Tfrequence.AffVoltmetre : string;
var imax,i : integer;
    posVirgule : integer;
begin
    if modeEF0='M'
       then begin { compteur }
          result := FloatToStrF(valeurAff/ExposantAff,ffFixed,3,5-NbreAvantVirgule);
          posVirgule := pos('.',result);
          for i := 0 to (NbreAvantVirgule-posVirgule) do
              result := ' '+result;
       end
       else begin  { frquence }
          result := IntToStr(round(valeurAff));
          imax := 5-length(result);
          for i := 1 to imax do result := ' '+result;
       end
end;

constructor TentreeAna.create(voie : indiceVoie);
begin
     inherited  create('V'+intToStr(voie-voieA+1),'V','',voie);
     modeEA := eaDirect;
end;

Procedure TentreeAna.Load(Avoie : string;fichier : tMemIniFile);
begin
   inherited load(Avoie,fichier);
   with fichier do begin
        modeEA := TmodeEA(ReadInteger(Avoie,'ModeEA',0));
   end;
end;

Procedure TentreeAna.Store(Avoie : string;fichier : tMemIniFile);
begin
   inherited store(Avoie,fichier);
   with fichier do begin
        WriteInteger(Avoie,'ModeEA',ord(modeEA));
   end
end;

Procedure Tcourbe.Assign(source : Tpersistent);
begin
         inherited assign(source);
         NbreChiffre := Tcourbe(source).NbreChiffre;
end;

Procedure TentreeAna.Assign(source : Tpersistent);
begin
         inherited assign(source);
         modeEA := TentreeAna(source).modeEA;
end;

procedure TgrapheGTI.ajusteOrigineTemps;
var i,j : integer;
    valeurLoc,valeurRef,valeurMax,valeurMin,ecart : double;
begin
     with voieOrphy[voieSynchro] do begin
          valeurMin := vecteurAff[0];
          valeurMax := valeurMin;
          for i := 1 to pred(NbreAff) do begin
              valeurLoc := vecteurAff[i];
              if valeurLoc>valeurMax
                 then valeurMax := valeurLoc
                 else if valeurLoc<valeurMin
                      then valeurMin := valeurLoc
          end;
          ecart := (valeurMax-valeurMin)/100;
          if (abs(vecteurAff[0])<ecart) and
             (abs(vecteurAff[0]-vecteurAff[1])>ecart) then
             vecteurAff[0] := vecteurAff[1];
          valeurRef := vecteurAff[0];
          i := 0;
          repeat inc(i)
          until (i=NbreAff) or
                (abs(vecteurAff[i]-valeurRef)>ecart);
          dec(i);
     end;
     with baseDeTemps do begin
         if (i*100>NbreAff) and
            (i*10<NbreAff*PreAcq10) then
              for j := 0 to pred(NbreAff) do
                  voieOrphy[voieT].vecteurAff[j] := (j-i)*deltat;
         Mini := -i*deltat;
         Maxi := deltat*(NbreAff-i);
    end;
end;

procedure TbaseDeTemps.setDureeMinMax(Avalue : double);
const dureeMaxOrphy = 6; { secondes }
      dureeMinOrphy = 1000*deltatOrphy;
begin
     FdureeMinMax := Avalue;
     if (Fgraphe.modeAcq=AcqTemps) and
        (Fgraphe.NbreVoieAna*2*FdureeMinMax > Deltat)
          then FDureeMinMax := Deltat/Fgraphe.NbreVoieAna/2;
     if FdureeMinMax>dureeMaxOrphy then FdureeMinMax := dureeMaxOrphy;
     if FdureeMinMax<dureeMinOrphy then FdureeMinMax := dureeMinOrphy;
end;

procedure TbaseDeTemps.setDureeBalayage(Avalue : double);
begin
     modifDuree := FdureeBalayage<>Avalue;
     FdureeBalayage := Avalue;
end;

Function TbaseDeTemps.getOrdreMinMax : shortString;
const mmax = 65535;
      emax = 4;
      tmax = 655;
      tmin = 1;
var m,t,e : longInt;
    voie : indiceVoie;
begin { duree = (m*dix(e)+nombreVoie)*t*10s*1000 points }
     m := 0;
     e := 0;
     t := trunc(FdureeMinMax*100);
     if t<tmin then t := tmin;
     if t>tmax then begin
         t := 500; { 5 ms }
         m := round((FdureeMinMax/t-Fgraphe.NbreVoieAna));
         if m<0 then m := 0;
    { m de 0  mmax=65535 et e de 0  emax=4 }
         e := 0;
         while (m>mmax) and (e<emax) do begin
            inc(e);
            m := m div 10;
         end;
         if m>mmax then m := mmax;
     end;
     result := 'YPE 1000 '+intToStr(m)+' '+intToStr(e)+' '+IntToStr(t*10);
     for voie := voieA to voieAnaMax do
         with TentreeAna(Fgraphe.voieOrphy[voie]) do
              if active and (modeEA<>eaDirect) then
                 result := result+' A'+codeVoie;
end;

procedure TSortieAnalogique.LitFichier(nomFichier : string);
var fichier : textFile;
    s : string;

Procedure ExtraitValeur;
var ligneWin : String;
    posV,i,j,longueur : integer;
begin with SortieAnalogique do begin
    NbreInterSA := 0;
    try
    while not eof(fichier) and (NbreInterSA<NbreMaxSA) do begin
       readln(fichier,LigneWin);
       i := 1;
       Longueur := length(LigneWin);
       While (i<longueur) and not charinset(LigneWin[i],[crTab,' ']) do inc(i);
// i=sparateur aprs le premier nombre : t
       While (i<longueur) and
             not charinset(LigneWin[i],ChiffreWin) do inc(i);
// i=dbut du deuxime nombre : SA
       j := succ(i);
       While (j<=longueur) and
             charinset(LigneWin[j],ChiffreWin) do inc(j);
//  j=succ(fin du deuxime nombre) : SA 
       ligneWin := copy(ligneWin,i,j-i);
       posV := pos(',',ligneWin);
       if posV>0 then ligneWin[posV] := '.';
       vecteurUtilisateur[NbreInterSA] := GetFloat(ligneWin);
       if vecteurUtilisateur[NbreInterSA]<>sansSignif then
          inc(NbreInterSA);
    end;
    calcVecteur;
    except
        afficheErreur(erValeur,0);
    end;
end end; // extraitValeur

Function LigneDeChiffres : boolean;
var j : integer;
    AvecChiffres : boolean;
begin
    Result := false;
    AvecChiffres := false;
    for j := 1 to length(s) do
        if charinset(s[j],chiffreWin)
           then avecChiffres := true
           else if (s[j]<>crTab) and (s[j]<>' ') then exit;
    result := avecChiffres;
end;

var i,k : integer;
begin
        assignFile(fichier,nomFichier);
        Reset(fichier);
        k := 0;
        repeat
          Readln(fichier,s);
          inc(k);
        until LigneDeChiffres;
        Reset(fichier);
        for i := 1 to pred(k) do readln(fichier);
        extraitValeur;
        closeFile(fichier);
end; // LitFichier

end.

