unit GtiCfg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Grids, math,
  gtiUtil, gtiDef, graphe, gtimain, maths, uniteker,
  listecap, etalon, constgti, ImgList, tradFormU, ComCtrls;

type
  TOrphyGtiDlg = class(TtradForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Bevel1: TBevel;
    EntreeCB: TComboBox;
    CalibreCB: TComboBox;
    SigneTensionRG: TRadioGroup;
    CapteursBtn: TBitBtn;
    DesactiveBtn: TBitBtn;
    Timer: TTimer;
    EtalonnageGB: TGroupBox;
    Bevel2: TBevel;
    CancelBtn: TBitBtn;
    EtalonneInterBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    EditSignif: TEdit;
    Label3: TLabel;
    ModeEARG: TRadioGroup;
    ExpressionEdit: TEdit;
    ExpressionLabel: TLabel;
    ManuelGrid: TStringGrid;
    EtalonRG: TRadioGroup;
    CouleurCombo: TColorBox;
    InverseLabel: TLabel;
    Gauge: TProgressBar;
    LabelAide: TLabel;
    EtalonBtn: TBitBtn;
    EtalonAutoLabel: TLabel;
    PointCombo: TComboBoxEx;
    ValeurLabel: TLabel;
    DureeMinMaxPanel: TPanel;
    DureeEdit: TEdit;
    DureeSpin: TSpinButton;
    MoyennePanel: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    MoyenneSE: TSpinEdit;
    AideBtn: TSpeedButton;
    AffichageGB: TGroupBox;
    EditMini: TLabeledEdit;
    EditMaxi: TLabeledEdit;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CalibreCBChange(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure CapteursBtnClick(Sender: TObject);
    procedure EtalonneInterBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure ModeEARGClick(Sender: TObject);
    procedure DureeSpinDownClick(Sender: TObject);
    procedure DureeSpinUpClick(Sender: TObject);
    procedure LinearCBClick(Sender: TObject);
    procedure ManuelGridExit(Sender: TObject);
    procedure ExpressionEditExit(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EtalonBtnClick(Sender: TObject);
    procedure AideBtnClick(Sender: TObject);
  private
    oldActive : boolean;
    procedure SetEtalonnage;
    procedure SetDureeMinMax(coeff : double);
    procedure MiseAjour;
  public
    voie : indiceVoie;
    modif : boolean;
  end;

var
  OrphyGtiDlg: TOrphyGtiDlg;

implementation

uses ETALONAuto, gbf_syntaxe;

{$R *.DFM}

const
    MaxCalibreGTI : array[TcalibreGTI] of string = ('10','5','2','1','0.5','0.2','0.1','5');
    TitreMaxiGTI : array[TcalibreGTI] of string = ('+10 V','+5 V','+2 V','+1 V','+ 500 mV','+ 200 mV','+ 100 mV','+5 V');

procedure TOrphyGtiDlg.FormActivate(Sender: TObject);
begin
    timer.interval := gtiMainForm.majTimer;
    ModeEARG.visible := (grapheGTI.modeAcq in [AcqPoint,AcqClavier]) or
            ((grapheGTI.modeAcq=AcqTemps) and
             (baseDeTemps.DureeBalayage>=1) and
             (baseDeTemps.Deltat>=DeltatLent));
    SetDureeMinMax(1);
    etalonRG.visible := voieEA[voie].indexCapteurAuto=0;
    signeTensionRG.enabled := voieEA[voie].indexCapteurAuto=0;
    Timer.enabled := true;
    oldActive := voieEA[voie].active;
    MiseAjour;
    modif := false;
    Timer.enabled := true;
    MoyenneSE.value := voieEA[voie].NbreMoyenne;
    capteursBtn.visible := voieEA[voie].indexCapteurAuto=0;
    desactiveBtn.Visible := capteursBtn.visible;
    if voieEA[voie].indexCapteurAuto>0 then begin
       EditUnite.enabled := false;
       EntreeCB.enabled := false;
    end;
    etalonBtn.Visible := (voieEA[voie].indexCapteurAuto>0) and
               ListeCapteursAuto[voieEA[voie].indexCapteurAuto].avecEtalonnage;
    CapteursBtn.Visible := voieEA[voie].indexCapteurAuto=0;
    if voieEA[voie].indexCapteurAuto=0
       then OKBtn.Caption := '&Activer'
       else OKBtn.Caption := '&OK';
    EtalonAutoLabel.Visible := (voieEA[voie].indexCapteurAuto>0) and
            not listeCapteursAuto[voieEA[voie].indexCapteurAuto].EtalonnageFait;
    gtiMainForm.setYasc(false);
    EditMini.text := FormatGTI(voieEA[voie].miniAffNL);
    EditMaxi.text := FormatGTI(voieEA[voie].maxiAffNL);
end;

procedure TOrphyGtiDlg.MiseAjour;
begin
    with voieEA[voie] do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := Signif;
          EntreeCB.ItemIndex := numeroOrphy;
          SigneTensionRG.itemIndex := ord(tension);
          if etalonRG.Visible then
             etalonRG.itemIndex := ord(etalonnage);
          CalibreCB.ItemIndex := ord(calibre);
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          ExpressionEdit.text := expression;
          ModeEARG.itemIndex := ord(modeEA);
          LabelAide.caption := Aide;
          with manuelGrid do begin
              cells[1,1] := '0';
              cells[2,1] := FormatGti(valeur0V);
              cells[1,2] := MaxCalibreGTI[Calibre];
              cells[2,2] := FormatGti(valeurReal(Hard5V));
          end;
          InverseLabel.visible := inverse;
    end;
    SetEtalonnage;
    DureeMinMaxPanel.visible := ModeEARG.visible and (ModeEARG.itemIndex>0);
    MoyennePanel.visible := ModeEARG.visible and (ModeEARG.itemIndex=0);    
    CalibreCBChange(nil);
end;

procedure TOrphyGtiDlg.SetEtalonnage;
begin
     if EtalonRG.visible
        then begin
             EtalonnageGB.visible := EtalonRG.itemIndex>0;
             ManuelGrid.visible := EtalonRG.itemIndex=1;
             voieEA[voie].etalonnage := Tetalonnage(EtalonRG.itemIndex);
             EtalonneInterBtn.visible := EtalonRG.itemIndex=1;
             AffichageGB.visible := EtalonRG.itemIndex=2;
        end
        else begin
             AffichageGB.visible := false;
             EtalonnageGB.visible := false;
             ManuelGrid.visible := false;
             EtalonneInterBtn.visible := false;
        end;
end;

procedure TOrphyGtiDlg.OKBtnClick(Sender: TObject);

function CalculEtalonManuel : boolean;
var valeurL : array[1..2,1..2] of double;
    i,j : integer;
    penteLoc : double;
begin with voieEA[voie] do begin
      result := true;
      try
         for i := 1 to 2 do
             for j := 1 to 2 do
                 valeurL[i,j] := GetFloat(manuelGrid.cells[i,j]);
      if (abs(valeurL[1,1]-valeurL[1,2]) < 0.01 ) or   // 10 mV
         (abs(valeurL[2,1]-valeurL[2,2]) <
         (abs(valeurL[2,1])+abs(valeurL[2,2]))/256 )
            then begin
               afficheErreur(erEtalon3,0);
               result := false;
            end
            else begin
               penteLoc := (valeurL[2,1]-valeurL[2,2])/(valeurL[1,1]-valeurL[1,2]);
               valeur0V := valeurL[2,1]-penteLoc*valeurL[1,1];
               valeur5V := penteLoc*5+valeur0V;
               calculPente;
            end;
     except
         afficheErreur(erNombre,0);
         result := false;
     end;
end end;
                                                      
var i : integer;
begin    
     timer.enabled := false;
     modif := modif or not oldActive;
     if modif and
        GtiMainForm.ModeDeconnecte and
        not OKReg(trFinReveil) then begin
        modif := false;
        exit
     end;
     with voieEA[voie] do begin
          Nom := EditNom.text;
          NomUnite := EditUnite.text;
          Signif := EditSignif.text;
          NbreMoyenne := MoyenneSE.value;
          Calibre := TcalibreGTI(CalibreCB.itemIndex);
          numeroOrphy := EntreeCB.ItemIndex;
          if nom='' then nom := 'V'+intToStr(numeroOrphy);          
          active := true;
          tension := Ttension(SigneTensionRG.itemIndex);
          couleur := CouleurCombo.selected;
          motif := Tmotif(PointCombo.itemIndex);
          if EtalonRG.visible then
             etalonnage := Tetalonnage(EtalonRG.itemIndex);
          if ModeEARG.visible
             then modeEA := TmodeEA(ModeEARG.itemIndex)
             else modeEA := eaDirect; 
          case etalonnage of
               eNonLin : begin
                   expression := expressionEdit.text;
                   try
                   miniAffNL := StrToFloatWin(EditMini.text);
				   except
				   end;
                   try
                   maxiAffNL := StrToFloatWin(EditMaxi.text);
				   except
				   end;
               end;
               eLin : begin
                  if not CalculEtalonManuel then begin
                     ManuelGrid.setFocus;
                     modalResult := mrNone;
                  end;
                  if (nomUnite='T') and (numeroOrphy<12) then begin
                      afficheErreur(erTesla,0);
                      modalResult := mrNone;
                  end;
               end;
               eAuto : ;
               eNone : begin
                   valeur0V := 0;
                   valeur5V := 5;
               end;
          end;
          if modif then
              for i := 0 to maxMoyenne do
                  oldValeurs[i] := sansSignif;
     end;
end;

procedure TOrphyGtiDlg.CalibreCBChange(Sender: TObject);
begin with voieEA[voie] do begin
     Calibre := TcalibreGTI(CalibreCB.itemIndex);
     CalculPente;
     NumeroOrphy := EntreeCB.ItemIndex;
     GtiMainForm.ecritOrphy(commandeCalibre);
     Modif := true;
     if etalonnage=eLin then with ManuelGrid do begin
          cells[1,2] := MaxCalibreGTI[TcalibreGTI(CalibreCB.itemIndex)];
          cells[2,2] := FormatGti(valeurReal(Hard5V));
     end;     
end end;

procedure TOrphyGtiDlg.DesactiveBtnClick(Sender: TObject);
begin
      timer.enabled := false;
      modif := modif or oldActive;
      if modif and
        GtiMainForm.ModeDeconnecte and
        not OKReg(trFinReveil)
          then modif := false
          else voieEA[voie].active := false;
end;

procedure TOrphyGtiDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TOrphyGtiDlg.TimerTimer(Sender: TObject);
var valeurW : longInt;
begin with voieEA[voie] do begin
     try
     valeurW := GtiMainForm.getValeurAsc('YEA '+codeVoie);
     Gauge.position := WordToInt(valeurW);
     valeurAff := valeurReal(valeurW);
     valeurLabel.caption := nom+'='+AffVoltmetre+' '+nomAff(exponent);
     except
         Gauge.position := 0;
         valeurLabel.caption := 'Erreur';
     end;
end end;

procedure TOrphyGtiDlg.FormCreate(Sender: TObject);
begin
     inherited;
     ManuelGrid.cells[0,1] := '1';
     ManuelGrid.cells[0,2] := '2';
     ManuelGrid.cells[2,0] := '';
     ManuelGrid.cells[1,0] := trTensionV;
     ManuelGrid.colWidths[0] := 50;
end;

procedure TOrphyGtiDlg.EditNomChange(Sender: TObject);
begin
     ManuelGrid.cells[2,0] := EditNom.text+' ('+EditUnite.text+')'
end;

procedure TOrphyGtiDlg.CapteursBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     ListeCapteursDlg.voie := voie;
     if ListeCapteursDlg.showModal=mrOK then begin
        MiseAjour;
        modif := true;
     end;
     timer.enabled := true;     
end;

procedure TOrphyGtiDlg.EtalonneInterBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     voieEA[voie].Nom := EditNom.text;
     voieEA[voie].NomUnite := EditUnite.text;
     if EtalonneInterDlg=nil then
        EtalonneInterDlg := TEtalonneInterDlg.create(self);
     EtalonneInterDlg.voie := voie;
     if EtalonneInterDlg.showModal=mrOK then with ManuelGrid,voieEA[voie] do begin
         cells[1,1] := '0';
         cells[2,1] := FormatGti(valeur0V);
         cells[1,2] := MaxCalibreGTI[Calibre];
         cells[2,2] := FormatGti(valeurReal(Hard5V));
         etalonRG.itemIndex := 1;
         modif := true;
         setEtalonnage;
     end;
     timer.enabled := true;
end;

procedure TOrphyGtiDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     timer.enabled := false
end;

procedure TOrphyGtiDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(7)
end;

procedure TOrphyGtiDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not charinset(key,(majuscule+minuscule+toucheEdition+chiffre)) then key := #0
end;

procedure TOrphyGtiDlg.ModeEARGClick(Sender: TObject);
begin
    DureeMinMaxPanel.visible := ModeEARG.itemIndex>0;
    MoyennePanel.visible := ModeEARG.itemIndex=0;    
    voieEA[Voie].modeEA := TmodeEA(ModeEARG.itemIndex);
end;

procedure TOrphyGtiDlg.DureeSpinDownClick(Sender: TObject);
begin
    setDureeMinMax(1/2.15)
end;

Procedure TOrphyGtiDlg.setDureeMinMax(coeff : double);
begin
     BaseDeTemps.dureeMinMax := duree125(BaseDeTemps.dureeMinMax*coeff);
     DureeEdit.text := chaineDuree(BaseDeTemps.DureeMinMax);
end;

procedure TOrphyGtiDlg.DureeSpinUpClick(Sender: TObject);
begin
     setDureeMinMax(2.15)
end;

procedure TOrphyGtiDlg.LinearCBClick(Sender: TObject);
begin
     if voieEA[voie].indexCapteurAuto>0 then exit;
     if (EtalonRG.itemIndex=3) and
        (voieEA[voie].indexCapteurAuto=0) then EtalonRG.itemIndex := 0;
     if (EtalonRG.itemIndex=0) and
        (voieEA[voie].etalonnage<>eNone) then begin
              EditUnite.text := 'V';
              voieEA[voie].SignifCapteur := EditSignif.text;
              EditSignif.text := voieEA[voie].signifTension;
              voieEA[voie].NomCapteur := EditNom.text;
              EditNom.text := voieEA[voie].NomTension;
     end;
     if (EtalonRG.itemIndex>0) and
        (voieEA[voie].etalonnage=eNone) then begin
              voieEA[voie].SignifTension := EditSignif.text;
              EditSignif.text := voieEA[voie].signifCapteur;
              voieEA[voie].NomTension := EditNom.text;
              EditNom.text := voieEA[voie].NomCapteur;
     end;
     setEtalonnage
end;

procedure TOrphyGtiDlg.ManuelGridExit(Sender: TObject);
var valeurL : array[1..2,1..2] of double;
    i,j : integer;
    penteLoc : double;
begin
if etalonRG.itemIndex=1 then with voieEA[voie] do begin
      try
         for i := 1 to 2 do
             for j := 1 to 2 do
                 valeurL[i,j] := GetFloat(manuelGrid.cells[i,j]);
      if (abs(valeurL[1,1]-valeurL[1,2]) < 0.01 ) or // 10 mV
         (abs(valeurL[2,1]-valeurL[2,2]) <
         (abs(valeurL[2,1])+abs(valeurL[2,2]))/256 )
            then afficheErreur(erEtalon3,0)
            else begin
               penteLoc := (valeurL[2,1]-valeurL[2,2])/(valeurL[1,1]-valeurL[1,2]);
               valeur0V := valeurL[2,1]-penteLoc*valeurL[1,1];
               valeur5V := penteLoc*5+valeur0V;
               calculPente;
            end;
        modif := true
     except
         afficheErreur(erNombre,0);
     end;
end end;

procedure TOrphyGtiDlg.ExpressionEditExit(Sender: TObject);
begin
      voieEA[voie].expression := expressionEdit.text
end;

procedure TOrphyGtiDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
     if EditNom.text='' then begin
        afficheErreur('Donner un nom  la grandeur',0);
        canClose := false;
     end;
end;

procedure TOrphyGtiDlg.EtalonBtnClick(Sender: TObject);
var j : integer;
begin
     timer.enabled := false;
     EtalonneAutoDlg := TEtalonneAutoDlg.create(self);
     EtalonneAutoDlg.voieCourante := voieEA[voie];
     EtalonneAutoDlg.showModal;
     EtalonneAutoDlg.free;
     for j := 0 to maxPotarAuto do
         with ListeCapteursAuto[voieEA[voie].indexCapteurAuto] do begin
              EtalonnageFait := true;
              if potarActif[j] and (valeurPotar[j]=0) then EtalonnageFait := false;
         end;
    EtalonAutoLabel.Visible := not listeCapteursAuto[voieEA[voie].indexCapteurAuto].EtalonnageFait;
    timer.enabled := true;
end;

procedure TOrphyGtiDlg.AideBtnClick(Sender: TObject);
begin
  syntaxeDlg := TsyntaxeDlg.create(self);
  syntaxeDlg.showModal;
  syntaxeDlg.free;
end;

end.

