unit Gtidde;

interface

uses
   SysUtils, Windows, Messages, Classes, Graphics, Controls,
   Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, registry, clipbrd,
   ComCtrls, oomisc, Math, shellApi,
   Maths, Graphe, uniteker, constGTI, gtiutil, gtidef;

type
   Tenvoi = (eAdd,eLoad,ePlus);
   TFormDDE = class(TForm)
      ClientDDE:  TDdeClientConv;
      ClientItem: TDdeClientItem;
      ServeurDDE: TDdeServerConv;
      procedure FormCreate(Sender: TObject);
      procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
   private
      procedure AjouteConst(var donnees: TStringList);
   public
      procedure Execute(Ordre: Tenvoi);
      procedure EnvoieDonnees(DDE, avecAxe: boolean; nomFichier: string);
      procedure SauveDonnees;
      procedure AjouteDonnees(debut, fin: integer);
   end;

var
   FormDDE: TFormDDE;

implementation

uses gtiMain, gticonst;

const
   crTab = #9;

{$R *.DFM}

procedure TFormDDE.AjouteConst(var donnees: TStringList);
var
   NbreConst, i: integer;
   Ligne: string;
   ConstanteOK: array[1..3] of boolean;
begin
   with gtimainForm do
   begin
      NbreConst := 0;
      for i := 1 to 3 do
      begin
         ConstanteOK[i] := (nomConstante[i] <> '') and
            (valeurConstante[i] <> sansSignif);
         if ConstanteOK[i] then
            Inc(NbreConst);
      end;
      if NbreConst = 0 then
         exit;
      donnees.Add('');
      Ligne := '';
      for i := 1 to 3 do
         if ConstanteOK[i] then
            ligne := ligne + nomConstante[i] + crTab;
      donnees.Add(Ligne);
      Ligne := '';
      for i := 1 to 3 do
         if ConstanteOK[i] then
            ligne := ligne + uniteConstante[i] + crTab;
      donnees.Add(Ligne);
      Ligne := '';
      for i := 1 to 3 do
         if ConstanteOK[i] then
            ligne := ligne + FloatToStrPoint(valeurConstante[i]) + crTab;
      donnees.Add(Ligne);
   end;
end;

procedure TFormDDE.Execute(Ordre: Tenvoi);

Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication), nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;

begin
   lanceRegressi;
   ClientDDE.SetLink('Regressi', 'ServeurDDE');
   ClientItem.DDEItem := 'ServeurItem';
   if ClientDDE.OpenLink then
      Lance
   else
   begin
      sleep(1000);
      // OpenLik false efface
      ClientDDE.SetLink('Regressi', 'ServeurDDE');
      ClientItem.DDEItem := 'ServeurItem';
      if ClientDDE.OpenLink then
         Lance
      else
         ShowMessage('Impossible de lancer Regressi');
   end;
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var
   Ini: TRegIniFile;
   taille: int64;
   i: integer;
   nomFichier: string;
begin
   Ini := TRegIniFile.Create('Software\Regressi');
   ClientDDE.ServiceApplication := Ini.ReadString('Regressi', 'Path', '');
   Ini.Free;
   if ClientDDE.ServiceApplication = '' then
   begin
      Ini := TRegIniFile.Create('Software');
      ClientDDE.ServiceApplication := Ini.ReadString('Regressi', 'Path', '');
      Ini.Free;
   end;
   if ClientDDE.ServiceApplication = '' then
   begin
      { disquette A 1 B 2 disque dur C 3 D 4 CDROM D 4 E 5}
      for i := 4 to 5 do
      begin
         taille := DiskSize(i);
         if (taille > 5e6) and (taille < 800e6) then
         begin { CDROM }
            nomFichier := char(Ord('A') + i - 1) + ':\Regressi.exe';
            if fileExists(nomFichier) then
               ClientDDE.ServiceApplication := NomFichier;
            break;
         end;
      end;
   end;
end;

procedure TFormDDE.EnvoieDonnees(DDE, avecAxe: boolean; nomFichier: string);
var
   i: integer;
   v, v1: indiceVoie;
   ligne: string;
   ligneOK: array[indiceVecteur] of boolean;
   donnees: TStringList;

   function AddPoint(v: indiceVoie): string;
   begin
      Result := '';
      with grapheGTI.voieOrphy[v] do
         Result := FloatToStrPoint(vecteurAff[i]) + crTab;
   end;

   procedure Elimination;
   var
      Reference, Coeff: array[indiceVoie] of double;
      j, N: integer;

      function ecart: double;
      var
         z: double;
         voie: indiceVoie;
      begin
         z := 0;
         for voie := voieT to voieMax do
            with grapheGTI.voieOrphy[voie] do
               if active then
                  z := z + abs(Reference[voie] - vecteurAff[j]) * Coeff[voie];
         ecart := z;
      end;

      procedure cocherJ;
      var
         voie: indiceVoie;
      begin
         Inc(N);
         LigneOK[j] := True;
         for voie := voieT to voieMax do
            with grapheGTI.voieOrphy[voie] do
               if active then
                  Reference[voie] := VecteurAff[j];
         Inc(j);
      end;

   var
      max, min: double;
      NbreVoie: integer;
      k: integer;
      voie: indiceVoie;
      Precision, precisionMin: double;
      MinPoint: integer;
   begin
      with grapheGTI do
      begin
         NbreVoie := 0;
         for voie := voieT to voieMax do
            with voieOrphy[voie] do
               if active then
               begin
                  GetMinMax(VecteurAff, NbreAff, min, max);
                  Coeff[voie] := 1 / (max - min);
                  Inc(NbreVoie);
               end;
         PrecisionMin := NbreVoie * 0.01; { 1 % }
         Precision := PrecisionMin;
         MinPoint := 4 * (NbreAff div GtiMainForm.NbreInterMax);
         N := NbreAff;
         while (N > GtiMainForm.NbreInterMax) do
         begin
            N := 0;
            j := 0;
            FillChar(LigneOK, sizeOf(LigneOK), 0);
            while (j < (NbreAff - 1)) do
            begin
               cocherJ;
               k := 0;
               while (j < (NbreAff - 1)) and (ecart <= Precision) do
               begin
                  Inc(k);
                  if k mod MinPoint = 0 then
                     cocherJ
                  else
                     Inc(j);
               end;
            end;
            if not LigneOK[pred(NbreAff)] then
            begin
               Inc(N);
               LigneOK[pred(NbreAff)] := True;
            end;
            precision := precision + precisionMin; { + 1 % }
            MinPoint  := 2 * MinPoint;
         end;
      end;
   end; // Elimination 

   procedure SousEchantillonne;
   var
      pas, i: integer;
   begin
      Pas := ceil(grapheGTI.NbreAff / gtiMainForm.NbreInterMax);
      for i := 0 to pred(grapheGTI.NbreAff) do
         if ((i mod pas) <> 0) then
            ligneOK[i] := False;
   end;

   procedure VerifNom;
   var
      v, voie: indiceVoie;
      modif: boolean;
   begin
      with grapheGti do
         for v := voieT to voieMax do
            if voieOrphy[v].active then
            begin
               modif := False;
               for voie := succ(v) to voieMax do
                  if voieOrphy[voie].nom = voieOrphy[v].nom then
                  begin
                     voieOrphy[voie].nom :=
                        voieOrphy[voie].nom + IntToStr(
                        voieOrphy[voie].numeroOrphy);
                     modif := True;
                  end;
               if modif then
                  voieOrphy[v].nom := voieOrphy[v].nom +
                     IntToStr(voieOrphy[v].numeroOrphy);
            end;
   end;

var
   repere: Trepere;
   AcqLongueDuree: boolean;
   DateDebut: TdateTime;
   sauveVoieTactive: boolean;
begin with grapheGti do begin { EnvoieDonnees }
      if NbreAff < minPoints then
         exit;
      VerifNom;
      Screen.Cursor := crHourGlass;
      AcqLongueDuree := (ModeAcq = AcqTemps) and
         (baseDeTemps.dureeBalayage > UneHeure);
      DateDebut := GtiMainForm.debutAcquisition;
      Tri;
      sauveVoieTactive := voieOrphy[voieT].active;
      v1 := voieT;
      case modeAcq of
         AcqTemps: ;
         AcqGP305: v1 := voieF;
         AcqPoint:
         begin
            if frequence.active then
               if frequence.modeEF0 <> 'M' then
                  v1 := voieF
               else
               begin
                  voieOrphy[voieNum].active := True;
                  v1 := voieNum;
               end
            else
            begin
               if TrierAbscisse then
                  v1 := voieAbscisse
               else
                  v1 := voieNum;
               voieOrphy[voieNum].active := True;
            end;
         end;
         AcqClavier: v1 := voieClavier;
      end;
      voieOrphy[v1].active := True;
      Donnees := TStringList.Create;
      if DDE then
      begin
         donnees.Add(Application.exeName);
         if ConstanteDlg.NewPageCB.ItemIndex = 1 then
            donnees.Add('')
         else
            donnees.Add('Acquisition par Orphy GTI');
         donnees.Add(GtiMainForm.Commentaire);
      end;
      if AcqLongueDuree then
         Ligne := 'Date' + crTab
      else
         Ligne := '';
      Ligne := Ligne + voieOrphy[v1].nom + crTab;
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active and (v <> v1) then
               ligne := ligne + nom + crTab;
      donnees.Add(ligne);
      if AcqLongueDuree then
         Ligne := '' + crTab
      else
         Ligne := '';
      Ligne := Ligne + voieOrphy[v1].nomUnite + crTab;
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active and (v <> v1) then
               ligne := ligne + nomUnite + crTab;
      donnees.Add(ligne);
      if AcqLongueDuree then
         Ligne := '' + crTab
      else
         Ligne := '';
      Ligne := Ligne + voieOrphy[v1].signif + crTab;
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active and (v <> v1) then
               ligne := ligne + signif + crTab;
      donnees.Add(ligne);
      for i := 0 to pred(NbreAff) do begin
         ligneOK[i] := True;
         for v := voieT to voieMax do
            with voieOrphy[v] do
               if active and (vecteurAff[i] = sansSignif) then
                  ligneOK[i] := False;
      end;
      if NbreAff > gtiMainForm.NbreInterMax then
         if GtiMainForm.SousEchantillon then
            SousEchantillonne
         else
            Elimination;
      for i := 0 to pred(NbreAff) do
         if ligneOK[i] then
         begin
            if AcqLongueDuree then
               Ligne :=
                  DateTimeToStr(DateDebut + voieOrphy[voieT].vecteurAff[i] / UnJour) + crTab
            else
               Ligne := '';
            ligne := ligne + AddPoint(v1);
            for v := voieT to voieMax do
               if voieOrphy[v].active and (v <> v1) then
                  ligne := ligne + AddPoint(v);
            donnees.Add(ligne);
         end;
      if DDE and avecAxe then
      begin
         AjouteConst(donnees);
         donnees.Add(symbReg2 + IntToStr(NbreCourbe) + ' NOMX');
         for i := 1 to NbreCourbe do
            donnees.Add(voieOrphy[voieAbscisse].nom);
         donnees.Add(symbReg2 + IntToStr(NbreCourbe) + ' NOMY');
         for v := succ(voieT) to voieMax do
            with voieOrphy[v] do
               if active and (v <> voieAbscisse) then
                  donnees.Add(nom);
         donnees.Add(symbReg2 + IntToStr(NbreCourbe) + ' LIGNE');
         for v := succ(voieT) to voieMax do
            with voieOrphy[v] do
               if active and (v <> voieAbscisse) then
                  // 1 point 2 ligne
                  if oTraceLigne then
                     if oTracePoints then
                        donnees.Add('3') // ligne et point
                     else
                        donnees.Add('2') // ligne
                  else
                     donnees.Add('1'); // point
         if ListeRepere.Count > 0 then
         begin
            donnees.Add(symbReg2 + IntToStr(ListeRepere.Count) + ' REPERE');
            for i := 0 to pred(ListeRepere.Count) do
            begin
               repere := Trepere(listeRepere[i]);
               donnees.Add(FloatToStrPoint(repere.valeur) + crTab + repere.Text);
            end;
         end;
      end;
      if nomFichier <> '' then
         donnees.saveToFile(NomFichier)
      else
      begin
         ClipBoard.AsText := Donnees.Text;
         if DDE then
            if ConstanteDlg.NewPageCB.ItemIndex = 1 then
               Execute(eADD)
            else
               Execute(eLOAD);
      end;
      ConstanteDlg.NewPageCB.ItemIndex := 1;
      voieOrphy[voieT].active := sauveVoieTactive;
      Donnees.Free;
      Screen.Cursor := crDefault;
   end;
end; // EnvoieDonnees

procedure TFormDDE.AjouteDonnees(debut, fin: integer);
// modeAcq=AcqTemps obligatoire 
var
   i: integer;
   v: indiceVoie;
   ligne: string;
   ligneOK: boolean;
   donnees: TStringList;
begin with grapheGti do begin
      if debut = 0 then begin
         envoieDonnees(True, False, '');
         exit;
      end;
      Screen.Cursor := crHourGlass;
      Donnees := TStringList.Create;
      Ligne := '';
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active then
               ligne := ligne + nom + crTab;
      donnees.Add(ligne);
      for i := debut to fin do
      begin
         ligneOK := True;
         ligne := '';
         for v := voieT to voieMax do
            with voieOrphy[v] do
               if active then
                  if vecteurAff[i] = sansSignif then
                     ligneOK := False
                  else
                     ligne := ligne + FloatToStrPoint(vecteurAff[i]) + crTab;
         if ligneOK then
            donnees.Add(ligne);
      end;
      ClipBoard.AsText := Donnees.Text;
      Donnees.Free;
      Execute(ePLUS);
      Screen.Cursor := crDefault;
   end;
end; // AjouteDonnees 

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var
   Fonction, NomFichier: string;
   ArgStart, ArgEnd: integer;
begin
   if (Msg.Count = 1) then
   begin
      try
         ArgStart := Pos('(', Msg[0]);
         ArgEnd := Pos(')', Msg[0]);
         if (ArgStart >= ArgEnd) then
            nomFichier := ''
         else
            nomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
         ArgStart := Pos('(', Msg[0]);
         if ArgStart > 0 then
            Fonction := Copy(Msg[0], 1, Pred(ArgStart))
         else
            Fonction := Msg[0];
         if (CompareText('CONFIG|LOAD', Fonction) = 0) or
            (CompareText('FILE|LOAD', Fonction) = 0) then
         begin
            nomFichier := changeFileExt(nomFichier, '.GTI');
            if FileExists(nomFichier) and
               (nomFichier <> gtiMainForm.FichierConfig) then
            begin
               GtiMainForm.LitConfig(NomFichier, True);
               GtiMainForm.afficheReglage;
            end;
            exit;
         end;
         if (CompareText('CONFIG|SAVE', Fonction) = 0) or
            (CompareText('FILE|SAVE', Fonction) = 0) then
         begin
            GtiMainForm.SauveConfig(NomFichier);
            exit;
         end;
         if CompareText('FOCUS', Fonction) = 0 then
         begin
            GtiMainForm.SetFocus;
            exit;
         end;
         if CompareText('GETDATA', Fonction) = 0 then
         begin
            GtiMainForm.SetFocus;
            exit;
         end;
         MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
      except
         MessageDlg('Erreur syntaxe Macro DDE GTI', mtError, [mbOK], 0);
      end;
   end
   else
      MessageDlg('Un message  la fois SVP', mtError, [mbOK], 0);
end;

procedure TFormDDE.SauveDonnees;
var
   i: integer;
   v: indiceVoie;
   nomFichier: string;
   ligne: string;
   donnees: TStringList;

   function AddPoint(v: indiceVoie): string;
   begin
      Result := '';
      with grapheGTI.voieOrphy[v] do
         Result := FloatToStrPoint(vecteurAff[i]) + ' ';
   end;

   procedure VerifNom;
   var
      v, voie: indiceVoie;
      modif: boolean;
   begin
      with grapheGti do
         for v := voieT to voieMax do
            if voieOrphy[v].active then
            begin
               modif := False;
               for voie := succ(v) to voieMax do
                  if voieOrphy[voie].nom = voieOrphy[v].nom then
                  begin
                     voieOrphy[voie].nom :=
                        voieOrphy[voie].nom + IntToStr(
                        voieOrphy[voie].numeroOrphy);
                     modif := True;
                  end;
               if modif then
                  voieOrphy[v].nom := voieOrphy[v].nom +
                     IntToStr(voieOrphy[v].numeroOrphy);
            end;
   end;

var
   AcqLongueDuree: boolean;
   DateDebut: TdateTime;
   repere:  Trepere;
   NbreVariab: integer;
   dateStr: string;
begin with grapheGti do begin // sauveDonnees
      if NbreAff < minPoints then
         exit;
      VerifNom;
      Screen.Cursor := crHourGlass;
      AcqLongueDuree := (ModeAcq = AcqTemps) and
         (baseDeTemps.dureeBalayage > UneHeure);
      DateDebut := GtiMainForm.debutAcquisition;
      DateTimeToString(DateStr, 'ddd d mmm h"h"n', now);
      NomFichier := 'GTI_' + DateStr + '.rw3';
      Tri;
      Donnees := TStringList.Create;
      donnees.add('EVARISTE REGRESSI WINDOWS 1.0');
      if AcqLongueDuree then
         NbreVariab := 1
      else
         NbreVariab := 0;
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active then
               Inc(NbreVariab);
      donnees.add(symbReg + IntToStr(NbreVariab) + ' NOM VAR');
      if AcqLongueDuree then
         donnees.Add('Date');
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active then
               donnees.Add(nom);
      donnees.add(symbReg + IntToStr(NbreVariab) + ' GENRE VAR');
      for i := 0 to pred(NbreVariab) do
         donnees.add('0');
      donnees.add(symbReg + IntToStr(NbreVariab) + ' UNITE VAR');
      if AcqLongueDuree then
         donnees.add('');
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active then
               donnees.add(nomUnite);
      donnees.Add(symbReg + IntToStr(NbreVariab) + ' SIGNIF VAR');
      if AcqLongueDuree then
         donnees.Add('');
      for v := voieT to voieMax do
         with voieOrphy[v] do
            if active then
               donnees.Add(signif);
      donnees.Add(symbReg + '2 ACQUISITION');
      donnees.Add('EXTERNE');
      donnees.Add(application.ExeName);
      donnees.Add(symbReg + '1 PAGE COMMENT');
      donnees.Add(GtiMainForm.Commentaire);
      donnees.Add(symbReg2 + IntToStr(NbreAff) + ' VALEUR VAR');
      for i := 0 to pred(NbreAff) do
      begin
         if AcqLongueDuree then
            Ligne :=
               DateTimeToStr(DateDebut + voieOrphy[voieT].vecteurAff[i] / UnJour) + ' '
         else
            Ligne := '';
         for v := voieT to voieMax do
            if voieOrphy[v].active then
               ligne := ligne + AddPoint(v);
         donnees.Add(ligne);
      end;
      if ListeRepere.Count > 0 then
      begin
         donnees.Add(symbReg2 + IntToStr(ListeRepere.Count) + ' REPERE');
         for i := 0 to pred(ListeRepere.Count) do
         begin
            repere := Trepere(ListeRepere[i]);
            donnees.Add(FloatToStrF(repere.Valeur, ffGeneral, 5, 2) + crTab + repere.Text);
         end;
      end;
      donnees.saveToFile(NomFichier);
      Donnees.Free;
      Screen.Cursor := crDefault;
   end;
end; // SauveDonnees

end.

