unit GtiUtil;

interface

uses
  SysUtils, Windows, Messages, Classes, Dialogs,
  Graphics, Forms, printers, controls, consts,  oomisc, awUser, lnsWin32,
  Math, Maths, StdCtrls, constgti, registry, inifiles, shlObj;

const
        WM_File_Load = WM_USER + 2;
        RegistreGTI = 'Software\GTI';
        PrecisionGTI = 3;
        PrecisionWin = 4;
        PrecisionTemps = 7;
        PrecisionDateTime = 10;
        SymbReg : char = '';
        SymbReg2 : char = '&';
        UnJour : double = 24*3600.0;
        UneHeure : double = 3600.0;
        QuartdHeure : double = 15*60.0;
        UneMinute : double = 60.0;
        DureeMinDeconnect = 10*60;   // dix minutes
        Fleche: array[boolean] of char = (WideChar($2193),WideChar($2191));

        alphaR =  AnsiChar(128);
        betaR = AnsiChar(129);
        chiR = AnsiChar(130);
        deltaR = AnsiChar(131); deltaMajR = AnsiChar(150);
        epsilonR = AnsiChar(132);
        phiR = AnsiChar(133); phiMajR = AnsiChar(151);
        gammaR = AnsiChar(134); gammaMajR = AnsiChar(152);
        etaR = AnsiChar(135);
        lambdaR = AnsiChar(136); lambdaMajR = AnsiChar(153);
        nuR = AnsiChar(138);
        piR = AnsiChar(139);piMajR = AnsiChar(154);
        thetaR = AnsiChar(140);thetaMajR = AnsiChar(155);
        rhoR = AnsiChar(141);
        sigmaR = AnsiChar(142);sigmaMajR = AnsiChar(156);
        tauR = AnsiChar(143);
        omegaR = AnsiChar(144);omegaMajR = AnsiChar(157);
        xiR = AnsiChar(147);xiMajR = AnsiChar(158);
        psiR = AnsiChar(148);psiMajR = AnsiChar(159);
        zetaR = AnsiChar(149);
        muR = AnsiChar(181);

        alpha=WideChar($03B1);alphaMaj=WideChar($0391);
        beta=WideChar($03B2);betaMaj=WideChar($0392);
        gamma=WideChar($03B3);gammaMaj=WideChar($0393);
        delta=WideChar($03B4);deltaMaj = WideChar($0394);
        chi=WideChar($03C7);chiMaj=WideChar($03A7);
        epsilon=WideChar($03B5);epsilonMaj=WideChar($0395);
        upsilon=WideChar($03C5);upsilonMaj=WideChar($03A5);
        iota=WideChar($03B9);iotaMaj=WideChar($0399);
        phi=WideChar($03C6);phiMaj=WideChar($03A6);
        eta=WideChar($03B7);etaMaj=WideChar($0397);
        lambdaMaj=WideChar($039B);lambda=WideChar($03BB);
        nu=WideChar($03BD);nuMaj=WideChar($039D);
        xiMaj=WideChar($039E);xi=WideChar($03BE);
        piMin=WideChar($03C0);piMaj=WideChar($03A0);
        thetaMaj=WideChar($0398);theta=WideChar($03B8);
        rho=WideChar($03C1);rhomaj=WideChar($03A1);
        sigma=WideChar($03C3);sigmaMaj=WideChar($03A3);
        tau=WideChar($03C4); tauMaj=WideChar($03A4);
        omega=WideChar($03C9);omegaMaj=WideChar($03A9);
        psi=WideChar($03C8);psiMaj=WideChar($03A8);
        zeta=WideChar($03B6);zetaMaj=WideChar($0396);
        mu=WideChar($03BC);muMaj=WideChar($039C);
        kappa=WideChar($03BA);kappaMaj=WideChar($039A);
        omicron=WideChar($03Bf);omicronMaj=WideChar($039F);
        vide=WideChar(2205);videMaj=WideChar(2205);
        supegal=WideChar(2265);
        infegal=WideChar(2264);

        Grecque = alpha+beta+gamma+gammaMaj+delta+deltaMaj+epsilon+
              chi+zeta+eta+theta+thetaMaj+kappa+
              lambda+lambdaMaj+mu+nu+xi+xiMaj+
              piMin+piMaj+rho+sigma+sigmaMaj+tau+
              phi+phiMaj+phi+phiMaj+psi+psiMaj+omega+omegaMaj;

type
    EGetFloatError = class(Exception);
    TIndexMagnum = (Date1,Date2,Date3,Date4,Pos1,Pos2);
    CoefUnite = (zero,yocto,zepto,atto,femto,pico,nano,micro,milli,
               nulle,kilo,mega,giga,tera,peta,exa,zetta,yotta,infini);
    pseudoWord = record case byte of
             0 : (octets : array[0..5] of ansiChar);
             1 : (mot : word); // 2 octets
             2 : (entier : smallInt); // 2 octets
             3 : (longMot : longWord); // 4 octets
             4 : (octet : byte);
             5 : (indexG,indexH : byte;valeurG,valeurH : word);
             6 : (valeurByte : array[0..5] of byte);
    end;

Const
        Digits : array[0..$F] of Char = '0123456789ABCDEF';
        crSupprArr = char(vk_back);
        crSuppr = char(vk_clear);
        crHaut = char(vk_up);
        crBas = char(vk_down);
        crGauche = char(vk_left);
        crDroite = char(vk_right);
        crHome = char(vk_home);
        crEnd = char(vk_end);
        crCR = #13;
        crLF = #10;
        crESC = #27;
        crTab = char(vk_tab);
        Separateur = [' ',crTab,','];
        Majuscule = ['A'..'Z'];
        Minuscule = ['a'..'z'];
        Chiffre = ['0'..'9'];
        ChiffreEtc = ['0'..'9','+','-','e','E','.'];
        ChiffreWin = ['0'..'9','+','-','e','E','.',','];
        ToucheEdition = [crSupprArr,crGauche,crDroite,crHome,crEnd,crSuppr];

        caracPrefixe : TSyscharSet =
           ['y','z','a','f','p','n','','m','k','M','G','T','P','E'];
        caracUnite : TSysCharSet =
           ['A'..'Z','a'..'z',OmegaMaj,'1'..'3','-','.','/',''];

        prefixeUnite : array[coefUnite] of char =
               ('0','y','z','a','f','p','n','','m',
                ' ','k','M','G','T','P','E','Z','Y','');
        valUnite : array[coefUnite] of double =
               (1E-27,1E-24,1E-21,1E-18,1E-15,1E-12,1E-9,1E-6,1E-3,
                1,1E+3,1E+6,1E+9,1E+12,1E+15,1E+18,1E+21,1E+24,1E+27);
        puissanceUnite : array[coefUnite] of shortInt =
               (-27,-24,-21,-18,-15,-12,-9,-6,-3,
                0,+3,+6,+9,+12,+15,+18,+21,+24,+27);
        expUnite : array[coefUnite] of string =
               ('E-27','E-24','E-21','E-18','E-15','E-12','E-9','E-6','E-3',
                '','E+3','E+6','E+9','E+12','E+15','E+18','E+21','E+24','E+27');

Function OKReg(astr : String) : boolean;
Procedure afficheErreur(aStr : String;indexAide : integer);
Procedure Info(astr : String);
Function ToucheValidation(key : word) : boolean;
Procedure TrimComplet(var S : String);
Function Pad(S : String;Len : integer) : String;
Function ConvertitChaine(nombre : string;var valeur : double) : boolean;
Function FormatGTI(nombre : double) : string;
Function FormatTime(nombre : double) : string;
Function CompareStr(s1,s2 : String) : boolean;
Function FloatToStrPoint(valeur : double) : string;
Function DateTimeToStr(valeur : double) : string;
Function StrToFloatWin(nombre : string) : double;
Function EncodeDuree(duree : LongInt) : TdateTime;
Function DureeEcoulee(InstantDebut : TdateTime) : double;
Function CaracToChiffre(carac : char) : integer;
Function WordToInt(V : word) : integer;
Function IntToWord(V : integer) : word;
Function existeOption(opt : char;defaut : boolean) : boolean;
Procedure ConvertitPrefixe(var nombre : string);
Function GetFloat(Nombre : String) : double;
{-------- Numeric conversion -----------}
function BinaryB(B : Byte) : String;
function BinaryW(W : Word) : string;
function HexB(B : Byte) : String;
function HexW(W : Word) : string;
function StrToHex(W : String) : word;
Function DateTimeToFloat(nombre : string) : double;
function duree125(duree : double) : double;

function IsPortAvailable(ComNum : Cardinal) : Boolean;

var
     winDir,mesDocsDir,appDataDir : string;

implementation

Procedure UpCaseStr(var s : string);
var i : integer;
begin
     for i := 1 to length(s) do s[i] := UpCase(S[i])
end;

function PosN(const C : String;S : String;const K : Integer): Integer;
var
  P : Integer;
begin
  Result := 0;
  if K>0 then Delete(S,1,K);
  P := Pos(C, S);
  if P>0 then result := K+P;
end;

Procedure TrimComplet(var s : String);
var longueur,posCourant : integer;
begin
	longueur := Length(s);
	posCourant := 1;
	while (posCourant<=longueur) do
		if ord(s[posCourant])<=32
			then begin
			   Delete(s,posCourant,1);
			   dec(longueur);
			end
			else inc(posCourant);
end;

Function OKReg(astr : string) : boolean;
begin
     OKreg := MessageDlg(astr,mtConfirmation,[mbYes,mbNo],0)=idYes
end;

Procedure Info(astr : string);
begin
     MessageDlg(astr,mtInformation,[mbOK],0)
end;

Function StrToFloatWin(nombre : string) : double;
var posSeparator : integer;
begin
   ConvertitPrefixe(nombre);
   if decimalSeparator<>',' then begin
      posSeparator := pos(',',nombre);
      if posSeparator>0 then Nombre[posSeparator] := decimalSeparator;
   end
   else if decimalSeparator<>'.' then begin
      posSeparator := pos('.',nombre);
      if posSeparator>0 then Nombre[posSeparator] := decimalSeparator;
   end;
   try
   result :=  strToFloat(nombre);
   except
   result := sansSignif;
   end;
end;

Function FloatToStrPoint(valeur : double) : string;
var nombre : string;
    posSeparator : integer;
begin
   nombre := FloatToStrF(valeur,ffGeneral,precisionWin,2);
   if decimalSeparator<>'.' then begin
      posSeparator := pos(decimalSeparator,nombre);
      if posSeparator>0 then Nombre[posSeparator] := '.';
   end;
   if (upcase(nombre[1])='E')
       then nombre := '1'+nombre
       else if nombre[1]='.'
          then nombre := '0'+nombre;
   result := nombre;
end;

Function DateTimeToStr(valeur : double) : string;
var nombre : string;
    posSeparator : integer;
begin
   nombre := FloatToStrF(valeur,ffGeneral,precisionDateTime,2);
   if decimalSeparator<>'.' then begin
      posSeparator := pos(decimalSeparator,nombre);
      if posSeparator>0 then Nombre[posSeparator] := '.';
   end;
   result := nombre;
end;

Function ConvertitChaine(nombre : string;var valeur : double) : boolean;
begin
   valeur := StrToFloatWin(nombre);
   convertitChaine := valeur<>sansSignif;
end;

Function FormatGeneral(Nombre : double;Nchiffres : integer) : string;
var Nexp : integer;
begin
     if Nombre=sansSignif then begin
        FormatGeneral := ' ';
        exit;
     end;
     if abs(Nombre)<1e-10
         then Nexp := 2
         else if abs(Nombre)<1e+10
              then Nexp := 1
              else Nexp := 2;
      FormatGeneral := FloatToStrF(nombre,ffGeneral,Nchiffres,Nexp)
end;

Function FormatGTI(Nombre : double) : string;
begin
     result := FormatGeneral(Nombre,PrecisionGTI)
end;

Function FormatTime(Nombre : double) : string;
begin
     result := FormatGeneral(Nombre,PrecisionTemps)
end;

procedure afficheErreur(astr : string;indexAide : integer);
var SauveCursor : Tcursor;
begin
     SauveCursor := Screen.cursor;
     Screen.cursor := crDefault;
     MessageDlg(astr,mtError,[mbOK],indexAide);
     Screen.cursor := SauveCursor;
end;

Procedure ConvertitPrefixe(var nombre : string);
var u : coefUnite;
    c : char;
begin
   c := nombre[length(nombre)];
   if charInset(c,caracPrefixe) then begin
   	u := zero;
        repeat inc(u) until (c=prefixeUnite[u]);
        delete(nombre,length(nombre),1);
        nombre := nombre+expUnite[u];
   end;
end;

Function CompareStr(s1,s2 : string) : boolean;
begin
    upCaseStr(s1);
    upCaseStr(s2);
    compareStr := s1=s2;
end;

Function ToucheValidation(key : word) : boolean;
begin
    ToucheValidation := key in [vk_tab,vk_left,vk_right,vk_down,vk_up,vk_return]
end;

function Pad(S: string; Len: integer): string;
   {-Return a string right-padded to length len with ' '}
var
   i,Slen: integer;
begin
   Slen := length(S);
   if SLen >= Len
      then result := copy(S,1,Len)
      else begin
         result := S;
         for i := Slen+1 to (len-Slen) do
             result := result+' ';
      end;
end;

Function EncodeDuree(duree : LongInt) : TdateTime;
var h,m,s,ms : word;
begin
    h := duree div 3600;
    duree := duree-h*3600;
    m := duree div 60;
    duree := duree-m*60;
    s := duree;
    ms := 0;
    EncodeDuree := EncodeTime(h,m,s,ms);
end;

Function DureeEcoulee(InstantDebut : TdateTime) : double;
var h,m,s,ms : word;
begin
      decodeTime(time-instantDebut,h,m,s,ms);
      DureeEcoulee := h*3600.0+m*60.0+s*1.0+ms*0.001;
end;

Function existeOption(opt : char;defaut : boolean) : boolean;
var str : string;
    i : integer;
begin
    result := defaut;
    for i := 1 to ParamCount do begin
       str := ParamStr(i);
       if (length(str)>1) and (str[1]='/') and (upcase(str[2])=opt) then begin
          if length(str)=2
             then result := true
             else result := (str[3]='+');
          exit;
       end;
    end;
end;

Function CaracToChiffre(carac : char) : integer;
begin
      if charInSet(carac,chiffre)
         then result := ord(carac)-ord('0')
         else result := 0;
end;

Function WordToInt(V : word) : integer; { de -8192  +8192 }
begin
     if V=65535
        then result := 0
        else if V<32768
            then result := V div 4  { 0  8192 }
            else result := V div 4 - 16384 { -8192  -1 }
end;

Function IntToWord(V : integer) : word;
begin
   if V<0
       then result := (V+16384)*4 { 32768  65535 }
       else result := V*4 { 0  32768 }
end;

  function HexB(B : Byte) : string;
    {-Return hex string for byte}
  begin
    setLength(result,2);
    HexB[1] := Digits[B shr 4];
    HexB[2] := Digits[B and $F];
  end;

  function HexW(W : Word) : string;
    {-Return hex string for word}
  begin
    setLength(result,4);
    HexW[1] := Digits[hi(W) shr 4];
    HexW[2] := Digits[hi(W) and $F];
    HexW[3] := Digits[lo(W) shr 4];
    HexW[4] := Digits[lo(W) and $F];
  end;

  function StrToHex(W : String) : word;
    {-Return word for hex string}
  var i : integer;
      code : word;
  begin
     result := 0;
     for i := 1 to 4 do begin
         if W[i]<='9'
           then code := ord(W[i])-ord('0')
           else code := ord(W[i])-ord('A')+10;
         result := (result*16) + code
     end;
  end;

  function BinaryB(B : Byte) : String;
    {-Return binary string for byte}
  var
    I, N : Word;
  begin
    N := 1;
    setlength(result,8);
    for I := 7 downto 0 do begin
      BinaryB[N] := Digits[Ord(B and (1 shl I) <> 0)]; {0 or 1}
      Inc(N);
    end;
  end;

  function BinaryW(W : Word) : String;
    {-Return binary string for word}
  var
    I, N : Word;
  begin
    N := 1;
    setlength(result,16);
    for I := 15 downto 0 do begin
      BinaryW[N] := Digits[Ord(W and (1 shl I) <> 0)]; {0 or 1}
      Inc(N);
    end;
  end;

function IsPortAvailable(ComNum : Cardinal) : Boolean;

  function MakeComName(const Dest : PChar; const ComNum : Cardinal) : PChar;
  begin
      StrFmt(Dest,'\\.\COM%d',[ComNum]);
      MakeComName := Dest;
  end;

var
  ComName : array[0..12] of Char;
  Res : Integer;
  DeviceLayer : TApdBaseDispatcher;
begin
  DeviceLayer  := TApdWin32Dispatcher.Create(nil);
  try
    if (ComNum = 0)
       then Result := False
       else begin
          Res := DeviceLayer.OpenCom(MakeComName(ComName,ComNum), 64, 64);
          Result := (Res >= 0) or
                    (GetLastError = DWORD(Abs(ecAccessDenied)));
          if Result then DeviceLayer.CloseCom;
      end;
  finally
    DeviceLayer.Free;
  end;
end;

Function DateTimeToFloat(nombre : string) : double;
var i,Njour : integer;
begin
     result := 0;
     trimComplet(nombre);
     i:=pos(':',nombre);
     if i>0
        then begin
           i:=pos('j',nombre);
           Njour := 0;
           if i>0
               then begin
                 if i>1 then begin
                   try
                   Njour := StrToInt(copy(nombre,1,pred(i)));
                   except
                   end;
                 end; { i>1 }
                 delete(nombre,1,i);
               end { i>0 }
               else begin
                   i := posN(':',nombre,2);
                   if i=0 then nombre := '0:'+nombre;
               end;
           try
           result := (StrToTime(nombre)+Njour)*60*60*24;
           except
           end;
        end {i>0}
        else begin
        i:=pos('j',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := StrToInt(copy(nombre,1,pred(i)))*60*24*60;
              except
              end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('h',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := result+StrToInt(copy(nombre,1,pred(i)))*60*60;
              except
              end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('min',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := result+StrToFloat(copy(nombre,1,pred(i)))*60;
              except
              end;
           end;
           delete(nombre,1,i+2);
        end;
        i:=pos('m',nombre);
        if i>0 then begin
           if i>1 then begin
              try
              result := result+StrToFloat(copy(nombre,1,pred(i)))*1e-3;
              except
              end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('',nombre);
        if i>0 then begin
           if i>1 then begin
               try
               result := result+StrToFloat(copy(nombre,1,pred(i)))*1e-6;
               except
               end;
           end;
           delete(nombre,1,i);
        end;
        i:=pos('s',nombre);
        if i>0 then delete(nombre,i,1);
        if nombre<>'' then begin
            try
            result := result+strToFloat(nombre);
            except
            end;
        end;
        if result = 0 then result := 0.1;
     end;
end;

function duree125(duree : double) : double;
var exposant,mantisse,coeff : double;
begin
     exposant := floor(log10(duree));
     coeff := power(10,exposant);
     mantisse := round(duree/coeff);
     if mantisse>2
        then if mantisse<6
             then mantisse := 5
             else mantisse := 10;
     duree125 := mantisse*coeff;
end;

const
    degreDer = 2;
    ordre = degreDer+1;
    puissMax = 2*degreDer;
type
   matrice = array[1..ordre,1..ordre+1] of extended;
   matriceLigne = array[1..ordre] of extended;
   vectorPuiss = array[0..puissMax] of extended;
   EsystemeLineaireError = class(Exception);

Procedure Resolution(A : matrice;var Result : matriceLigne);
 { Cette procdure rsoud un systme AX = B }
 { crit sous la forme AX = A(n+1) }
 { par la mthode d'limination de Gauss (pivot partiel) }

  Procedure Elimination;

    FUNCTION Pivot(i :integer):integer;
    Var n,temp : integer;
    BEGIN
      temp := i;
      for n := i+1 to ordre do
          if abs(A[n,i]) > abs(A[i,i]) then temp:= n;
      pivot:=temp;
      if abs(A[temp,i]) <= 1e-100 then
         raise EsystemeLineaireError.Create('Erreur rsolution systme linaire')
    END;

    PROCEDURE Permute(i,j:integer);
    Var temp:extended;
        k:integer;
    BEGIN
       if i<>j then For k:=i to ordre+1 do BEGIN
          temp:=A[i,k];
          A[i,k]:=A[j,k];
          A[j,k]:=temp;
       END;
    END;

  var I,J,K : integer;
      M : extended;
  begin
    for k := 1 to ordre do begin
          Permute(k,pivot(k));
          for i:=k+1 to ordre do begin
              M := A[i,k]/A[k,k];
              for j:=k+1 to ordre+1 do A[i,j]:=A[i,j]-M*A[k,j];
              A[i,k]:=0.0;
          end;
       end;
    end; {Elimination}

    Procedure Substitution;
    var I,J : integer;
        S : extended;
    begin
         try
         for I:=ordre downto 1 do begin
             S:=A[I,ordre+1];
             for J:=I+1 to ordre do S:=S-A[I,J]*Result[J];
             Result[I]:=S/A[I,I];
         end;
         except
            on EzeroDivide do raise EsystemeLineaireError.Create('Erreur rsolution systme linaire')
         end;
    end;

begin {Resolution}
  Elimination;
  Substitution;
end; {rsolution}

procedure DeriveeGauss(const X,Y : vecteur;N : integer;
   var Yder : vecteur;NbrePointDer : integer);
var puissX : vectorPuiss;
    A : matrice;
    Coeff : matriceLigne;
    ii : integer;

procedure initXY;
var j : integer;
    loc : extended;
    i : integer;
begin
    for i := 1 to puissMax do puissX[i] := 0;
    puissX[0] := NbrePointDer;
    for i := 1 to ordre do A[i,ordre+1] := 0;
    for j := 0 to pred(NbrePointDer) do begin
        loc := x[j];
        for i := 1 to puissMax do begin
            puissX[i] := puissX[i]+loc;
            loc := loc*x[j];
        end;
        loc := y[j];
        for i := 1 to ordre do begin
            A[i,ordre+1] := A[i,ordre+1]+loc;
            loc := loc*x[j];
        end;
    end;
end;

Procedure CalculXY(i : integer);
var ajoute,retire : extended;
    k : integer;
begin
        ajoute := X[i+ii];
        retire := X[i-ii-1];
        for k := 1 to puissMax do begin
            puissX[k] := puissX[k]+ajoute-retire;
            retire := retire*X[i-ii-1];
            ajoute := ajoute*X[i+ii];
        end;
        ajoute := Y[i+ii];
        retire := Y[i-ii-1];
        for k := 1 to ordre do begin
            A[k,ordre+1] := A[k,ordre+1]+ajoute-retire;
            retire := retire*X[i-ii-1];
            ajoute := ajoute*X[i+ii];
        end;
end;

procedure AffecteCoeff;
var i,j : integer;
begin
     for i := 1 to ordre do
         for j := 1 to ordre do
             A[i,j] := PuissX[i+j-2];
     try
     Resolution(A,Coeff);
     except
         coeff[2] := sansSignif;
         coeff[3] := 0;
     end;
end;

Procedure AffecteDerivee(i : integer);
begin
   if (x[i]<>sansSignif) and (y[i]<>sansSignif) then
   case degreDer of
        1 : yder[i] := coeff[2];
        2 : yder[i] := coeff[2]+2*coeff[3]*x[i];
   end;
end;

var i : integer;
begin { DeriveeGauss }
    ii := NbrePointDer div 2;
    for i := 0 to pred(N) do yder[i] := sansSignif;
    if N<NbrePointDer then exit;
    initXY;
    affecteCoeff;
    for i := 0 to ii do affecteDerivee(i);
    for i := ii+1 to N-ii-1 do begin
        calculXY(i);
        affecteCoeff;
        affecteDerivee(i);
    end;
    for i := N-ii to pred(N) do affecteDerivee(i);
end; { DeriveeGauss }

Function GetFloat(Nombre : String) : double;
Const
    MaxPile = 10;
    CaracCte : TSyscharSet = [piMin,piMaj,'P','I','p','i'];
type
    IndicePile  = 1..MaxPile;
Var
    Pile : Array[IndicePile] of double;
    IndicePileCourant : 0..MaxPile;
    CaracCourant   : char;
    PointeurExp : integer;

Procedure suivant;
{Lit le prochain caractre et l'assigne  caracCourant}
{Le caracCourant est toujours extrait avant appel d'un analyseur}
begin
    inc(pointeurExp);
    if pointeurExp<=length(Nombre)
       then caracCourant := Nombre[pointeurExp]
       else caracCourant := #0;
end;

Procedure InitFonctor;
Begin
  pointeurExp := 0;
  indicePileCourant := 0;
  suivant;
end;{ InitFonctor }

{Les procdures LireXXX extraient un XXX de la chaine Nombre  partir du
 pointeur courant }

Function LireNombre : double;
    Var PointeurChiffre : integer;
        Valeur : double;
        NombreLoc : String;

    Procedure lireEntier;
    begin
       While charinset(caracCourant,chiffre ) do suivant
    end;

    Begin
        PointeurChiffre := PointeurExp;{pointe le premier chiffre du nombre}
        lireEntier;
        If charinset(caracCourant,['.',','] ) {C'est un nombre dcimal}
           Then begin
              suivant;{on saute le .}
              lireEntier
           end;
        If ( upcase(caracCourant) = 'E' ) {puissance de 10}
           then begin
              suivant;{on saute le E}
              if (caracCourant='+') or (caracCourant='-')  then suivant;
              lireEntier
           end
           else if charinset(caracCourant,caracPrefixe) then suivant {coeff unit};
        NombreLoc := copy(nombre,pointeurChiffre,pointeurExp-PointeurChiffre);
        if not ConvertitChaine(nombreLoc,valeur)
           then raise EGetFloatError.Create('Erreur nombre');
        LireNombre := valeur;
   end; { lireNombre }

Function LireIdEnt : String;
Var PointeurIdent : integer;
Begin
  PointeurIdent := pointeurExp;
  While charinset(caracCourant,CaracCte) do suivant;
  if (pointeurExp-pointeurIdent)>12 then raise EGetFloatError.Create('Identificateur trop long (>8)');
  LireIdent := copy(nombre,pointeurIdent,pointeurExp-pointeurIdent)
End;{LireIdEnt}

Procedure Depile(Var P : double);
Begin
  if indicePileCourant=0
    then raise EGetFloatError.Create('Erreur interne')
    else begin
      P := Pile[indicePileCourant];
      dec(indicePileCourant);
   end;
End;

Procedure Empile(P : double);
Begin
  if indicePileCourant=MaxPile
    then raise EGetFloatError.Create('Trop complexe')
    else begin
      inc(indicePileCourant);
      Pile[indicePileCourant] := P;
   end;
End;

Function CalcOperateur(C : char;PG,PD : double) : double;
begin
   case C of
         '+'  : calcOperateur := PG+PD;
         '-'  : calcOperateur := PG-PD;
         '/'  : calcOperateur := PG/PD;
         '*'  : calcOperateur := PG*PD;
         else CalcOperateur := 0;
   end;
end;

Procedure AnalyseExpression;Forward;

Procedure E;
{E=(.Expression.)}
Begin
  If caracCourant='('
    Then Begin
        suivant;
        AnalyseExpression;
        case caracCourant of
             ')'  : suivant;
             #0 : ; { fin => on ajoute ) manquante }
             else raise EGetFloatError.Create('Erreur )');
        end;{case}
    End
    Else raise EGetFloatError.Create('Erreur (')
End;{E}

Procedure AnalyseElement;
{Element = E/nombre}
Var
  U : String;
Begin
  If charinset(caracCourant,[piMin,piMaj,'P','p'])
    Then Begin
        U := LireIdent;
        U := AnsiUpperCase(U);
        if (U=piMin) or (U='PI')or (U=piMaj)
           then Empile(pi)
           else raise EGetFloatError.Create('Erreur nombre')
    End {Then}
    Else If charinset(caracCourant,Chiffre+['-','+','.'])
        Then Empile(LireNombre)
        Else E
End;{analyseElement}

Procedure AnalyseTerme;
{terme = facteur.[* ou /].element}
Var
  C        : Char;
  T1,T2    : double;
Begin
  AnalyseElement;
  While (caracCourant='*') or (caracCourant='/') do Begin
       C:=caracCourant;
       suivant;
       AnalyseElement;
       depile(T2);
       depile(T1);
       Empile(CalcOperateur(C,T1,T2));
    End {while}
End; { AnalyseTerme }

Procedure AnalyseExpression;
{Expression = [+ ou - ou rien].Terme.[+ ou -].terme}
Var
  C      : Char;
  T1,T2  : double;
Begin
  If (caracCourant='+') or (caracCourant='-')
     Then Begin
        C:=caracCourant;
        suivant
     end
     Else C:='+';
  AnalyseTerme;
  If C='-' Then begin
         depile(T1);
         Empile(-T1)
  end;
  While (caracCourant='+') or (caracCourant='-') do Begin
      C:=caracCourant;
      suivant;
      AnalyseTerme;
      depile(T2);
      depile(T1);
      Empile(CalcOperateur(C,T1,T2));
  End {while}
End;{AnalyseExpression}

var posVirgule : integer;
Begin {getFloat}
  trimComplet(Nombre);
  if nombre='' then begin
     result := sansSignif;
     exit;
  end;
  posVirgule := pos(',',nombre);
  while posVirgule>0 do begin
      Nombre[posVirgule] := '.';
      posVirgule := pos(',',nombre);      
  end;
  InitFonctor;
  AnalyseExpression;
  if pred(pointeurExp)<>length(nombre) then
     raise EGetFloatError.Create('Erreur nombre');
  result := Pile[1];
end;{getFloat}

Function AddBackSlash(aPath : String):String;
Begin
  Result := EmptyStr;
  If (aPath <> '') and (aPath[Length(aPath)] <> '\') Then
    Result := aPath + '\';
End;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
Function GetFolder(CSIDLValue: integer): String;
Var
  IdList            : PITEMIDLIST;
  Folder            : Array[0..MAX_PATH] Of Char;
Begin
  if Not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
    End;
End;

Initialization
     winDir := GetFolder(CSIDL_Windows);
     mesDocsDir := GetFolder(CSIDL_Personal);
     mesDocsDir := MesDocsDir+'Regressi';
     if not DirectoryExists(MesDocsDir) then
       createDir(MesDocsDir);
     mesDocsDir := AddBackSlash(mesDocsDir);
     appDataDir := GetFolder(CSIDL_AppData);
     appDataDir := appDataDir+'Regressi';
     if not DirectoryExists(appDataDir) then
        createDir(appDataDir);
     appDataDir := AddBackSlash(appDataDir);
end.


