Unit Maths;

Interface

uses Windows,SysUtils,math;

const
     MaxVecteur = 32768;

type
     IndiceVecteur = 0..MaxVecteur;
     Vecteur = array[IndiceVecteur] of double;
     VecteurInt = array[IndiceVecteur] of integer;

const
     NbreMaxPossible : array[0..5] of integer =
        (1024,2048,4096,8192,16384,32768);
     MaxReal : double = 1e+35;
     MinReal : double = 1e-35;
     ProcheReal : double = 1e-6;
     SansSignif : double = 1e-26;

Function Dix(x : integer) : extended;
Procedure GetMinMax(const V : vecteur;N : indiceVecteur;var mini,maxi : double);
Procedure VerifMinMaxInt(var mini,maxi : integer);
Procedure VerifMinMaxReal(var mini,maxi : double);

Implementation

function Dix(x : integer) : extended;
Begin
    Dix := Power(10,X)
end;

Procedure VerifMinMaxInt(var mini,maxi : integer);
var z : integer;
begin
   if Maxi<Mini then begin
	  z := Maxi;
	  Maxi := Mini;
	  Mini := z;
   end;
end;

Procedure VerifMinMaxReal(var mini,maxi : double);
var z : double;
begin
   if Maxi<Mini then begin
	  z := Maxi;
	  Maxi := Mini;
	  Mini := z;
   end;
end;

Procedure GetMinMax(const V : vecteur;N : indiceVecteur;var mini,maxi : double);
var i : indiceVecteur;
begin
     Mini := V[0];
     Maxi := V[0];
     for i := 1 to pred(N) do
         if V[i]>Maxi
            then Maxi := V[i]
            else if V[i]<Mini
               then Mini := V[i]
end;

end.

