unit Modedlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls, sysutils,
  gtidef, graphe, gtimain, tradFormU, constgti, gtiUtil;

type
  TmodeAcqDlg = class(TtradForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    ModeRG: TRadioGroup;
    AbscisseRG: TRadioGroup;
    GrilleCB: TCheckBox;
    AxeCB: TCheckBox;
    TraceGB: TGroupBox;
    TraceLigneCB: TCheckBox;
    TracePointsCB: TCheckBox;
    Label3: TLabel;
    DimPointSE: TSpinEdit;
    TrierAbscisseCB: TCheckBox;
    AnalyseurRG: TRadioGroup;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    NumVoieAbs : array[0..voieMax] of indiceVoie;
    Procedure setAbscisseRG;
  public
    modif : boolean;
  end;

var
  modeAcqDlg: TmodeAcqDlg;

implementation

uses clavier;

{$R *.DFM}

procedure TmodeAcqDlg.OKBtnClick(Sender: TObject);
begin with grapheGti do begin
     Modif := modeAcq<>TmodeAcq(modeRG.itemIndex);
     ModeAcq := TmodeAcq(modeRG.itemIndex);
     if (modeAcq=AcqMagnum) and not MagnumPermis then begin
        afficheErreur(erVersionGTI,0);
        modeAcq := AcqTemps;
     end;
     case modeAcq of
        AcqMagnum : VoieAbscisse := VoieT;
        AcqGP305 : VoieAbscisse := VoieF;
        else VoieAbscisse := NumVoieAbs[AbscisseRG.itemIndex];
     end;
     modif := modif or (voieOrphy[VoieAbscisse].active=false);
     oTraceLigne := TraceLigneCB.checked;
     oTracePoints := TracePointsCB.checked;
     grapheGTI.Quadrillage := GrilleCB.checked;
     grapheGTI.avecUnAxe := AxeCB.checked;
     grapheGTI.analyseurLogique := AnalyseurRG.itemIndex=1;
     dimPoint := dimPointSE.value;
     TrierAbscisse := TrierAbscisseCB.checked and
                      (modeAcq in [AcqPoint]);
     if modif and (modeAcq=AcqClavier) then begin
        if ClavierDlg=nil then
             Application.CreateForm(TClavierDlg, ClavierDlg);
        ClavierDlg.showModal;
     end;
end end;

procedure TmodeAcqDlg.FormActivate(Sender: TObject);
begin with grapheGti do begin
     modeRG.itemIndex := ord(modeAcq);
     TraceLigneCB.checked := oTraceLigne;
     TracePointsCB.checked := oTracePoints;
     GrilleCB.checked := grapheGTI.Quadrillage;
     AnalyseurRG.itemIndex := ord(grapheGTI.analyseurLogique);
     Modif := false;
     SetAbscisseRG;
     AxeCB.checked := avecUnAxe;
     DimPointSE.value := dimPoint;
     TrierAbscisseCB.checked := TrierAbscisse;
end end;

Procedure TmodeAcqDlg.setAbscisseRG;

Procedure setNum(voie : indiceVoie;force : boolean);
begin
     numVoieAbs[pred(abscisseRG.items.count)] := voie;
     if (modeRG.itemIndex=ord(grapheGti.modeAcq)) and
        (voie=grapheGTI.voieAbscisse) then
        AbscisseRG.itemIndex := pred(abscisseRG.items.count);
     if force then
        AbscisseRG.itemIndex := pred(abscisseRG.items.count);       
end;

var texte : string;
    voie : indiceVoie;
begin
     AbscisseRG.items.clear;
     if ModeRG.itemIndex = ord(acqMagnum) then exit;
     if TmodeAcq(ModeRG.itemIndex) in [AcqTemps,AcqPoint] then begin
          AbscisseRG.items.Add(trTemps);
          if modeRG.itemIndex<>ord(grapheGti.modeAcq) then
               AbscisseRG.itemIndex := pred(abscisseRG.items.count);
          setNum(voieT,false);
     end;
     if ModeRG.itemIndex=ord(AcqPoint) then begin
           AbscisseRG.items.Add(trNumero);
           if modeRG.itemIndex<>ord(grapheGti.modeAcq) then
                AbscisseRG.itemIndex := pred(abscisseRG.items.count);
           setNum(voieNum,false);
     end;
     if SortieAnalogique.active and
        (ModeRG.itemIndex=ord(grapheGTI.modeAcq)) then begin
              AbscisseRG.items.Add(trSortieAna);
              setNum(voieSA,false);
     end;
     if ModeRG.itemIndex=ord(AcqClavier) then begin
             AbscisseRG.items.Add(trClavier);
             setNum(voieClavier,true);
    end;
    if (ModeRG.itemIndex=ord(AcqClavier)) or
       (ModeRG.itemIndex=ord(AcqPoint)) or
       (ModeRG.itemIndex=ord(AcqGP305))  then begin
             AbscisseRG.items.Add(trFrequence);
             setNum(voieF,true);
     end;
     if (ModeRG.itemIndex=ord(AcqSA)) then begin
            AbscisseRG.items.Add(trSortieAna);
            setNum(voieSA,true);
     end;
     if EntreeBinaire.active then begin
           AbscisseRG.items.Add(trEntreeBin);
           setNum(voieEB,false)
     end;
     for voie := voieA to voieAnaMax do
         with grapheGTI.voieOrphy[voie] do if active then begin
            if length(signif)<length(nom)
               then texte := nom
               else if (length(nom)+length(signif))<15
                   then texte := nom+' : '+signif
                   else texte := nom+' : '+copy(signif,1,12-length(nom))+'...';
            AbscisseRG.items.Add(texte);
            if (modeRG.itemIndex<>ord(grapheGti.modeAcq)) and
               (ModeRG.itemIndex=ord(AcqPoint)) and
               (AbscisseRG.itemIndex=-1) then
                  AbscisseRG.itemIndex := pred(abscisseRG.items.count);
            setNum(voie,false);
      end;
      TrierAbscisseCB.visible := grapheGTI.modeAcq in [AcqPoint];
      if AbscisseRG.itemIndex<0 then ModeRG.itemIndex := 0;
end;

procedure TmodeAcqDlg.ModeRGClick(Sender: TObject);
begin
   setAbscisseRG
end;

procedure TmodeAcqDlg.CancelBtnClick(Sender: TObject);
begin
    modif := false;
end;

end.



