unit MagnumDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, gtiUtil, Spin, TradFormU, magnumU, ImgList, ooMisc;

type
  TMagnumCfg = class(TTradForm)
    OKBtn: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    NomMagnumEdit: TEdit;
    ModeRG: TRadioGroup;
    UniteRG: TRadioGroup;
    HelpBtn: TBitBtn;
    PasMagnumEdit: TEdit;
    Label2: TLabel;
    Timer: TTimer;
    GroupBox1: TGroupBox;
    Compteur: TLabel;
    ChuteCB: TCheckBox;
    NegatifCB: TCheckBox;
    ErreurUpBtn: TSpeedButton;
    ErreurDnBtn: TSpeedButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Memo1: TMemo;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimerTimer(Sender: TObject);
    procedure NomMagnumEditChange(Sender: TObject);
  private
  public
  end;

var
  MagnumCfg: TMagnumCfg;

implementation

uses graphe, Gtimain;

{$R *.DFM}

procedure TMagnumCfg.OKBtnClick(Sender: TObject);
begin with magnum do begin
    modeAngulaire := boolean(ModeRG.itemIndex);
    if modeAngulaire or chuteCB.Checked
       then PeriodeMagnumE := StrToFloatWin(PasMagnumEdit.text)
       else PeriodeMagnumE := PeriodeMagnum;
    modeRadian := boolean(UniteRG.itemIndex);
    nom := NomMagnumEdit.text;
    ChuteNegatif := negatifCB.checked;
    chuteMagnum := not modeAngulaire and chuteCB.Checked;
    if nom='' then nom := 'z';
end end;

procedure TMagnumCfg.FormActivate(Sender: TObject);
begin with magnum do begin
    chuteCB.Checked := chuteMagnum;
    erreurUpBtn.Down := false;
    erreurDnBtn.Down := false;
    gtiMainForm.setYasc(false);
    ModeRG.itemIndex := ord(modeAngulaire);
    UniteRG.itemIndex := ord(modeRadian);
    NomMagnumEdit.text := Nom;
    GtiMainForm.ecritOrphy('YCONFEF 0 D');
    timer.enabled := true;
    negatifCB.checked := ChuteNegatif;
    GtiMainForm.setYasc(false);
    ModeRGClick(nil);
    TimerTimer(nil);
end end;

procedure TMagnumCfg.ModeRGClick(Sender: TObject);
begin
     UniteRG.visible := ModeRG.itemIndex=1;
     PasMagnumEdit.enabled := (ModeRG.itemIndex=1) or (ChuteCB.checked);
     if PasMagnumEdit.enabled
        then PasMagnumEdit.text := formatGti(PeriodeMagnumE)
        else PasMagnumEdit.text := formatGti(PeriodeMagnum);
     NegatifCB.visible := ChuteCB.Visible and ChuteCB.checked;
     NegatifCB.caption := NomMagnumEdit.text+' ngatif';
end;

procedure TMagnumCfg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(20)
end;

procedure TMagnumCfg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     timer.enabled := false
end;

procedure TMagnumCfg.TimerTimer(Sender: TObject);
var eb : word;
begin
    timer.enabled := false;
    eb := GtiMainForm.getValeurDump;
    GtiMainForm.EcritOrphy('YPOSITION 0');
    ErreurUpBtn.down := ErreurUpBtn.down or (eb>2047);
    ErreurDnBtn.down := ErreurUpBtn.down or (eb<2047);
    Label3.caption := intToStr(integer(eb)-2047)+'trait';
    timer.enabled := true;
end;

procedure TMagnumCfg.NomMagnumEditChange(Sender: TObject);
begin
     NegatifCB.caption := NomMagnumEdit.text+' ngatif';
end;

end.


