unit Sadlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, spin, ExtCtrls, sysutils, Grids, Dialogs, ComCtrls,
  maths, gtiutil, uniteker, gtidef, graphe, gtimain,
  tradFormU, constgti;

type
  TSortieAnaDlg = class(TtradForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    SortieRG: TRadioGroup;
    DebutGB: TGroupBox;
    DebutSAScroll: TScrollBar;
    EditDebutSA: TEdit;
    FinGB: TGroupBox;
    FinSAScroll: TScrollBar;
    EditFinSA: TEdit;
    ModeSANB: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    NbreSE: TSpinEdit;
    Label6: TLabel;
    LargeurSE: TSpinEdit;
    Label7: TLabel;
    DeltaSE: TSpinEdit;
    DebutSE: TSpinEdit;
    Label4: TLabel;
    GroupBox1: TGroupBox;
    EditNomSA: TEdit;
    ModeSARG: TRadioGroup;
    DesactiveBtn: TBitBtn;
    Oscillo: TPaintBox;
    FichierBtn: TBitBtn;
    OpenDialog: TOpenDialog;
    HelpBtn: TBitBtn;
    LargeurEdit: TEdit;
    DeltaEdit: TEdit;
    DebutEdit: TEdit;
    EtalonCB: TCheckBox;
    ExpressionEdit: TEdit;
    ExpressionLabel: TLabel;
    PasGB: TGroupBox;
    PasSAScroll: TScrollBar;
    EditPasSA: TEdit;
    RampeGB: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    NrampeSE: TSpinEdit;
    rampeSE: TSpinEdit;
    ContinuCB: TCheckBox;
    procedure DebutSAScrollChange(Sender: TObject);
    procedure FinSAScrollChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModeSARGClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PulseChange(Sender: TObject);
    procedure FichierBtnClick(Sender: TObject);
    procedure SortieRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure EtalonCBClick(Sender: TObject);
    procedure PasSAScrollChange(Sender: TObject);
    procedure NrampeSEChange(Sender: TObject);
    procedure rampeSEChange(Sender: TObject);
    procedure ContinuCBClick(Sender: TObject);
  private
    grapheImpulsion : Tgraphe;
    paintActif,activation : boolean;
  public
  end;

var
  SortieAnaDlg: TSortieAnaDlg;

implementation

{$R *.DFM}

procedure TSortieAnaDlg.DebutSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     DebutSortie[rampeSE.value] := DebutSAScroll.position;
     EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
     if (modeSARG.itemIndex=0) and
        (rampeSE.value>1) and
        continuCB.Checked then
            FinSortie[rampeSE.value-1] := DebutSortie[rampeSE.value];
     GtiMainForm.EcritOrphy('YSA '+SAi+' '+IntToStr(DebutSAScroll.position));
     oscillo.refresh;
end end;

procedure TSortieAnaDlg.FinSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     FinSortie[rampeSE.value] := FinSAScroll.position;
     EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
     if (modeSARG.itemIndex=0) and
        (rampeSE.value<rampeSE.MaxValue) and
         continuCB.Checked then
           DebutSortie[rampeSE.value+1] := FinSortie[rampeSE.value];
     GtiMainForm.EcritOrphy('YSA '+SAi+' '+IntToStr(DebutSAScroll.position));
     oscillo.refresh;
end end;

procedure TSortieAnaDlg.OKBtnClick(Sender: TObject);
begin
     with sortieAnalogique do begin
        Active := true;
        NbreRampes := NrampeSE.value;
        if EtalonCB.checked and (expressionEdit.text<>'')
            then expression := expressionEdit.text
            else expression := '';
        Mini := ValeurVolt(0);
        Maxi := ValeurVolt(MaxiHardSA);
        Nom := EditNomSA.text;
        Sai := ansiChar(ord('0')+sortieRG.itemIndex);
        if nom='' then nom := 'SA'+SAi;
        if SAi='0' then tension := positive else tension := NegAndPos;
        PasSortie := PasSAScroll.position;
        ModeSA := TmodeSA(ModeSARG.itemIndex);
        Modif := true;
        if ModeSA=saImpulsion then begin
             NbrePulse := NbreSE.value;
             LargeurPulse := LargeurSE.value;
             DeltaPulse := DeltaSE.value;
             if DeltaPulse<=LargeurPulse then
                 DeltaPulse := LargeurPulse+2;
             DebutPulse := DebutSE.value;
             NbreInterSA := NbreMaxSA;
        end;
        if expression=''
           then etalonnage := eNone
           else etalonnage := eNonLin;
        calcVecteur;
     end;
end;

procedure TSortieAnaDlg.FormActivate(Sender: TObject);
begin
     activation := true;
     with sortieAnalogique do begin
        FinSAScroll.position := FinSortie[1];
        EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
        DebutSAScroll.position := DebutSortie[1];
        EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
        EditPasSA.text := FormatUnite(ValeurReal(PasSAScroll.position));
        PasSAScroll.position := PasSortie;
        
        NrampeSE.value := NbreRampes;
        rampeSE.value := 1;
        EditNomSA.text := nom;
        GtiMainForm.EcritOrphy('YSA '+SAi+' '+IntToStr(DebutSortie[1]));
        SortieRG.itemIndex := ord(SAi)-ord('0');
        ModeSaRg.itemIndex := ord(modeSA);
        NbreSE.value := NbrePulse;
        LargeurSE.value := LargeurPulse;
        DeltaSE.value := DeltaPulse;
        DebutSE.value := DebutPulse;
        EtalonCB.checked := expression<>'';
        ExpressionEdit.text := expression;
        ExpressionEdit.Visible := EtalonCB.checked;
        ExpressionLabel.Visible := EtalonCB.checked;
     end;
     activation := false;
     oscillo.refresh;
end;

procedure TSortieAnaDlg.ModeSARGClick(Sender: TObject);
begin
      ModeSANB.ActivePageIndex := ModeSARG.itemIndex;
      RampeGB.Visible := ModeSANB.ActivePageIndex=0;
      FinGB.visible := (ModeSANB.ActivePageIndex<>2);
      PasGB.visible := (ModeSANB.ActivePageIndex<>2);      
      case ModeSANB.ActivePageIndex of
           0 : begin
               DebutGB.caption := 'Dbut';
               FinGB.caption := 'Fin';
           end;
           1 : begin
               DebutGB.caption := 'Base';
               FinGB.caption := 'Hauteur de l''chelon';
           end;
           2 : begin
               DebutGB.caption := 'Attente';
           end;
      end;
      SortieAnalogique.ModeSA := TmodeSA(ModeSARG.itemIndex);
      oscillo.refresh;
end;

procedure TSortieAnaDlg.DesactiveBtnClick(Sender: TObject);
begin
     sortieAnalogique.active := false
end;

procedure TSortieAnaDlg.OscilloPaint(Sender: TObject);
var i : integer;
    titre : string;
begin
if activation or paintActif then exit;
with grapheImpulsion do begin
     PaintActif := true;
     case sortieRG.itemIndex of
          0 : y0 := 0;
          1 : y0 := 127;
          2 : y0 := 127;
     end;
     limiteFenetre := rect(0,0,oscillo.width-1,oscillo.height-1);
     if ModeSARG.itemIndex=1 then with sortieAnalogique do begin
          debutSortie[1] := debutSAscroll.position;
          finSortie[1] := finSAscroll.position;
          if DeltaSE.value*(NbreSE.value-1)>NbrePoints then
               DeltaSE.Value := NbrePoints div NbreSE.value;
          if LargeurSE.value*NbreSE.value>NbrePoints then
               LargeurSE.Value := NbrePoints div succ(NbreSE.value);
          largeurEdit.text := Utemps.formatUnite(largeurSE.value*baseDeTemps.deltat);
          debutEdit.text := Utemps.formatUnite(debutSE.value*baseDeTemps.deltat);
          deltaEdit.text := Utemps.formatUnite(deltaSE.value*baseDeTemps.deltat);
          if DeltaSE.value<=LargeurSE.value then
               DeltaSE.Value := LargeurSE.value+1;
          NbrePulse := NbreSE.value;
          LargeurPulse := LargeurSE.value;
          DeltaPulse := DeltaSE.value;
          if DeltaPulse<=LargeurPulse then
                 DeltaPulse := LargeurPulse+2;
          DebutPulse := DebutSE.value;
          NbreInterSA := NbreMaxSA;
     end;
     sortieAnalogique.calcVecteur;
     NbrePoints := sortieAnalogique.NbreInterSA;
     for i := 0 to pred(NbrePoints) do
         vecteurY[i] := sortieAnalogique.vecteurYSA[i];
     if ModeSARG.itemIndex=2
        then titre := 'Dure balayage'
        else titre :=Utemps.formatUnite(NbrePoints*baseDeTemps.deltat);
     draw(titre);
     PaintActif := false;
end end;

procedure TSortieAnaDlg.FormCreate(Sender: TObject);
var i : integer;
begin
     GrapheImpulsion := Tgraphe.create;
     with GrapheImpulsion do begin
         for i := 0 to NbreMaxSA do vecteurX[i] := i;
         NbrePoints := 255;
         MaxiY := maxiHardSA;
         MiniY := 0;
         canvas := oscillo.canvas;
     end;
end;

procedure TSortieAnaDlg.PulseChange(Sender: TObject);
begin
     oscillo.refresh
end;

procedure TSortieAnaDlg.FichierBtnClick(Sender: TObject);
begin
     if openDialog.execute then begin
        screen.cursor := crHourGlass;
        sortieAnalogique.litFichier(openDialog.fileName);
        screen.cursor := crDefault;
        oscillo.refresh;
     end;
end; 

procedure TSortieAnaDlg.SortieRGClick(Sender: TObject);
begin
    if not activation then with sortieAnalogique do begin
       Sai := ansiChar(ord('0')+SortieRG.itemIndex);
       EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
       EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
       EditPasSA.text := FormatUnite(ValeurReal(PasSAScroll.position));       
       oscillo.refresh
    end;
end;

procedure TSortieAnaDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(9)
end;

procedure TSortieAnaDlg.EtalonCBClick(Sender: TObject);
begin
        ExpressionEdit.Visible := EtalonCB.checked;
        ExpressionLabel.Visible := EtalonCB.checked;
end;

procedure TSortieAnaDlg.PasSAScrollChange(Sender: TObject);
begin with sortieAnalogique do
     EditPasSA.text := FormatUnite(ValeurReal(PasSAScroll.position));
end;

procedure TSortieAnaDlg.NrampeSEChange(Sender: TObject);
begin
  rampeSE.Visible := nRampeSE.value>1;
  rampeSE.maxValue := nRampeSE.value;
  if rampeSE.value>rampeSE.maxValue then rampeSE.value := rampeSE.maxValue;
  sortieAnalogique.NbreRampes := NrampeSE.value;
  oscillo.refresh;
end;

procedure TSortieAnaDlg.rampeSEChange(Sender: TObject);
begin with sortieAnalogique do begin
  debutSAscroll.Position := debutSortie[RampeSE.value];
  finSAscroll.Position := finSortie[RampeSE.value];
  oscillo.Refresh;
end end;

procedure TSortieAnaDlg.ContinuCBClick(Sender: TObject);
var i : integer;
begin with sortieAnalogique do begin
     if continuCB.Checked then
        for i := 2 to NrampeSE.value do
            DebutSortie[i] := FinSortie[i-1];
     oscillo.Refresh;            
end end;

end.
