unit Synchro;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, sysutils, ComCtrls,
  maths, gtiutil, gtidef, gtimain, graphe, tradFormU, constgti;

type
  TSynchroDlg = class(TtradForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    SynchroRG: TRadioGroup;
    Notebook: TPageControl;
    FrontTabSheet: TTabSheet;
    SeuilTabSheet: TTabSheet;
    RelaxeTabSheet: TTabSheet;
    KeyboardTabSheet: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    EFRG: TRadioGroup;
    SensFrontRG: TRadioGroup;
    SensSeuilRG: TRadioGroup;
    GroupBox1: TGroupBox;
    LabelSeuil: TLabel;
    PreAcqSGB: TGroupBox;
    GroupBox4: TGroupBox;
    VoieSynchroRG: TRadioGroup;
    MonocoupSCB: TCheckBox;
    MonocoupFCB: TCheckBox;
    PreAcqLabel: TLabel;
    PreAcqFrontLabel: TLabel;
    SeuilScroll: TScrollBar;
    RazSeuilBtn: TSpeedButton;
    PreAcqScroll: TTrackBar;
    PreAcqFrontScroll: TTrackBar;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SynchroRGClick(Sender: TObject);
    procedure SeuilScrollChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure PreAcqScrollChange(Sender: TObject);
    procedure VoieSynchroRGClick(Sender: TObject);
    procedure RazSeuilBtnClick(Sender: TObject);
  private
    NumVoie : array[0..voieMax] of indiceVoie;
    Initialisation : boolean;
    Procedure MajSeuil;
  public
  end;

var
  SynchroDlg: TSynchroDlg;

implementation

{$R *.DFM}

procedure TSynchroDlg.OKBtnClick(Sender: TObject);
begin with grapheGti do begin
     modeSynchro := TmodeSynchro(synchroRG.itemIndex);
     case modeSynchro of
          s_seuil : begin
              montant := boolean(sensSeuilRG.itemIndex);
              voieSynchro := numVoie[VoieSynchroRG.itemIndex];
              if voieSynchro<voieA  then voieSynchro := voieA;
              if voieSynchro>voieAnaMax  then voieSynchro := voieA;
              seuilSynchro := IntToWord(seuilScroll.position);
              modeSynchro := S_seuil;
              BaseDeTemps.preAcq10 := preAcqScroll.position;
              monocoup := MonocoupSCB.checked;
          end;
          s_front : begin
             modeSynchro := S_front;
             front := EFRG.itemIndex;
             montant := boolean(sensFrontRG.itemIndex);
             (*BaseDeTemps.preAcq := preAcqFront.position;*)
             BaseDeTemps.preAcq10 := 0;
             monocoup := MonocoupFCB.checked;
          end;
          else BaseDeTemps.preAcq10 := 0;
     end;
end end;

procedure TSynchroDlg.FormActivate(Sender: TObject);

Procedure setVoieRG;
var voie : indiceVoie;
begin
     VoieSynchroRG.items.clear;
     for voie := voieA to voieAnaMax do
         with grapheGTI.voieOrphy[voie] do if active then begin
            voieSynchroRG.items.Add(nom);
            if voie=grapheGTI.voieSynchro then
                voieSynchroRG.itemIndex := pred(voieSynchroRG.items.count);
            numVoie[pred(voieSynchroRG.items.count)] := voie;
        end;
     if voieSynchroRG.itemIndex=-1
        then voieSynchroRG.itemIndex := pred(voieSynchroRG.items.count);
end;

procedure setValeurs;
begin with grapheGTi,voieOrphy[voieSynchro] do begin
   PreAcqSGB.visible := preAcqOK;
   sensSeuilRG.itemIndex := ord(montant);
   sensFrontRG.itemIndex := ord(montant);
   preAcqScroll.position := BaseDeTemps.preAcq10;
   preAcqLabel.caption := IntToStr(10*PreAcqScroll.position)+'%';
   preAcqFrontScroll.position := BaseDeTemps.preAcq10;
   EFRG.itemIndex := front;
   SeuilScroll.Position := wordToInt(SeuilSynchro);
   MajSeuil;
   case modeSynchro of
        s_seuil : MonocoupSCB.checked := monocoup;
        s_front : MonocoupFCB.checked := monocoup;
   end;
end end;

begin with grapheGti do begin
     Initialisation := true;
     if voieSynchro<voieA  then voieSynchro := voieA;
     if voieSynchro>voieAnaMax  then voieSynchro := voieA;
     setVoieRG;
     setValeurs;
     synchroRG.itemIndex := ord(modeSynchro);
     MajSeuil;
     Initialisation := false;
     Notebook.ActivePageIndex := SynchroRG.itemIndex;
end end; { Activate }

procedure TSynchroDlg.SynchroRGClick(Sender: TObject);
begin
     if (gtiMainForm.modeTemporel=mRapide) and
        (SynchroRG.itemIndex<2) then begin
            AfficheErreur(erModeRapide,0);
            SynchroRG.itemIndex := 0;
            exit;
     end;
     Notebook.ActivePageIndex := SynchroRG.itemIndex;
end;

procedure TSynchroDlg.SeuilScrollChange(Sender: TObject);
begin
     MajSeuil
end;

procedure TSynchroDlg.MajSeuil;
var seuilReal : double;
begin with grapheGti.voieOrphy[grapheGti.voieSynchro] do begin
     seuilReal := valeurReal(IntToWord(SeuilScroll.Position));
     if seuilReal=sansSignif then seuilReal := valeur0V;
     LabelSeuil.caption := formatUnite(seuilReal)
end end;

procedure TSynchroDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(5)
end;

procedure TSynchroDlg.PreAcqScrollChange(Sender: TObject);
begin
     PreAcqLabel.caption := IntToStr(10*PreAcqScroll.position)+'%';
     PreAcqFrontLabel.caption := IntToStr(10*PreAcqFrontScroll.position)+'%'
end;

procedure TSynchroDlg.VoieSynchroRGClick(Sender: TObject);
begin
     if Initialisation then exit;
     grapheGti.voieSynchro := numVoie[VoieSynchroRG.itemIndex];
     MajSeuil
end;

procedure TSynchroDlg.RazSeuilBtnClick(Sender: TObject);
begin
     SeuilScroll.Position := 0
end;

end.
