{ Axes.pas : fichier inclus de graphe pour trac des axes }

procedure DrawAxis;
var yAxeX : integer;
    xNombreMax : integer;
    PointCourant : double;
    couleurAxe : TcolorRef;

Function XcorrectNombre(x : integer) : boolean;
begin
     XcorrectNombre := (x>(limiteCourbe.left+marge)) and
                       (x<xNombreMax) and
                       (abs(x-limiteCourbe.left)>marge )
end;

Function XcorrectGrad(x : integer) : boolean;
begin
     XcorrectGrad := (x>limiteCourbe.left) and (x<limiteCourbe.right)
end;

procedure MyLine(x1,y1,x2,y2 : integer);
begin
     canvas.moveTo(x1,y1);
     canvas.lineTo(x2,y2);
end;

Procedure graduationX(x : integer);
begin
  if quadrillage
       then MyLine(x,limiteCourbe.top,x,limiteCourbe.bottom)
       else MyLine(x,yAxeX,x,yAxeX+marge);
end;

  procedure initAxeX;
  var x1 : integer;
  begin	 with voieOrphy[voieAbscisse] do begin
	   PointCourant := PointDebut;
     x1 := XWindow(0);
     if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then begin
             canvas.pen.style := psDash;
             canvas.pen.color := CouleurAxe;
	           Myline(x1,limiteCourbe.bottom,x1,limiteCourbe.top);
     end;
  	 canvas.pen.style := psSolid;
	   xNombreMax := limiteFenetre.right-largCarac*longNombreAxe div 2;
     with limiteFenetre do begin
               MyLine(left,yAxeX,right,yAxeX);
          { flches }
               MyLine(right-marge*3,yAxeX+marge,right,yAxeX);
               MyLine(right-marge*3,yAxeX-marge,right,yAxeX);
     end;
	   SetTextAlign(canvas.handle,TA_center+TA_top);
  end end;{initAxeX}

  procedure traceAxeX;
  var xs : integer;
      NombreAff : string;
      arret : double;
  begin with voieOrphy[voieAbscisse] do begin
     if Quadrillage then begin
          canvas.pen.style := psDot;
          canvas.pen.color := CouleurAxe;
     end;
     if oTraceFFT then arret := maxiFFT else arret := maxi;
     repeat
          xs := Xwindow(PointCourant);
      	  if XcorrectGrad(xs) then begin
               graduationX(xs);
               if XcorrectNombre(xs) then begin
        	  if abs(PointCourant)< (Maxi-Mini)/100 then pointCourant := 0;
                  if axeDateTime
                     then NombreAff := ChaineDuree(pointCourant)
                     else if oTraceFFT
                         then NombreAff := intToStr(round(pointCourant/exposant))
                         else NombreAff := formatAxe(pointCourant/exposant);
              	  canvas.TextOut(xs,yAxeX+marge,NombreAff);
      	       end;
          end;
      	  PointCourant := PointCourant+deltaAxe;
     until PointCourant>=Arret;
     SetTextAlign(canvas.handle,TA_left+TA_top);
     if oTraceFFT
        then if deltaAxe<1000
             then NombreAff := 'f(Hz)'
             else NombreAff := 'f(kHz)'
        else if axeDateTime
           then NombreAff := nom
           else NombreAff := nomAxe(exposant);
     canvas.TextOut(limiteFenetre.left+marge,yAxeX+marge,nombreAff);
 end end;{traceAxeX}

 procedure traceAxeLogx;
 var i,j : integer;
     xs,xpred,xsucc : integer;
     intermediaire : boolean;
     ecart : integer;
     NombreAff : string;
begin with voieOrphy[voieAbscisse] do begin
   if Quadrillage then begin
      canvas.pen.style := psDot;
      canvas.pen.color := CouleurAxe;
   end;
   Intermediaire := (Maxi-Mini) <= 3;
   Ecart := largCarac*longNombreAxe;
   Xpred := 0;
   Xsucc := 0;
   for i := floor(Mini) to floor(Maxi) do begin
  	xs := round(A*i+B);
	 if XcorrectGrad(xs) then begin
	     graduationX(xs);
      	     if XcorrectNombre(xs) then begin
                 NombreAff := formatUnite(dix(i));
        	 canvas.TextOut(xs,yAxeX+marge,NombreAff);
             end;
	end;
	if intermediaire then begin
	     xpred := xs;
	     xsucc := round(A*succ(i)+B);
	end;
	for j := 2 to 9 do begin
	     xs := round(A*(i+log10(j))+B);
	     if XcorrectGrad(xs) then
	         if intermediaire
		     then begin
	    	     	graduationX(xs);
              if XcorrectNombre(xs) and
		     	   ( xs>(xpred+ecart) ) and
		     	   ( xs<(xsucc-ecart) ) and
		     	   ( xs<(xnombreMax-ecart) ) then begin
                                NombreAff := formatAxe(j);
                 	        canvas.TextOut(xs,yAxeX+marge,NombreAff);
		      		xpred := xs;
		     	end;
		     end
		     else MyLine(xs,yAxeX,xs,yAxeX+marge);
	  end;{for j}
   end; {for i}
end end;{ TraceAxeLogx }

procedure traceAxeY(m : indiceVoie);
var xx,ys : integer;
    nombreAff : string;
    limiteTop : integer;
begin with voieOrphy[m] do begin
      LimiteTop := CourbeTop+marge;
      if AnalyseurLogique then inc(LimiteTop,hautCarac);
      couleurAxe := couleur;
      setTextAlign(canvas.handle,TA_right+TA_top);
      xx := limiteCourbe.left;
      canvas.pen.color := CouleurAxe;
      PointCourant := PointDebut;
      ys := XWindow(0);
      canvas.pen.style := psSolid;
      if (ys>CourbeTop) and (ys<CourbeBottom) then
          Myline(limiteCourbe.left,ys,limiteCourbe.right,ys);
      MyLine(xx,CourbeBottom,xx,CourbeTop);
    { flche }
      MyLine(xx-marge,CourbeTop+3*marge,xx,CourbeTop);
      MyLine(xx+marge,CourbeTop+3*marge,xx,CourbeTop);
      canvas.font.Color := couleurAxe;
      if Quadrillage then canvas.pen.style := psDot;
      xx := xx-marge;
      repeat
           ys := Xwindow(PointCourant);
	   {coordonne cran de marque}
           if (ys>CourbeTop) and (ys<CourbeBottom) then begin
                 if quadrillage
                    then MyLine(limiteCourbe.left,ys,limiteCourbe.right,ys)
                    else MyLine(limiteCourbe.left,ys,limiteCourbe.left+marge,ys);
                 if ( ys>(LimiteTop)) and
                    ( ys<(CourbeBottom-marge)) and
		    ( abs(ys-yAxeX)>marge ) then begin
	   	    if abs(pointCourant) < (Maxi-Mini)/1000 then pointCourant := 0;
                    NombreAff := formatAxe(pointCourant/exposant);
	   	              Canvas.TextOut(xx,ys-marge,NombreAff);
                 end;
	        end;
      	  pointCourant := pointCourant+deltaAxe;
     until ( pointCourant>=Maxi );
     canvas.TextOut(xx,courbeTop-marge,nomAxe(exposant));
 end end;{traceAxeY}

procedure zeroX;
var x1 : integer;
begin with voieOrphy[voieAbscisse] do
   x1 := XWindow(0);
   if (x1>limiteCourbe.left) and (x1<limiteCourbe.right) then begin
        canvas.pen.style := psDot;
        canvas.pen.color := couleurAxe;
        Myline(x1,limiteCourbe.bottom,x1,limiteCourbe.top);
   end;
end;{zeroX}

procedure zeroY(m : indiceVoie);
var y1 : integer;
begin with voieOrphy[m] do begin
     y1 := Xwindow(0);
     if (y1>CourbeTop) and (y1<CourbeBottom) then begin
          canvas.pen.style := psSolid;
          canvas.pen.color := couleurAxe;
          Myline(limiteCourbe.left,y1,limiteCourbe.right,y1);
     end
end end;{zeroY}

var voie : indiceVoie;
begin{ DrawAxis }
     couleurAxe := voieOrphy[voieAbscisse].couleur;
     canvas.font.Color := CouleurAxe;
     yAxeX := limiteCourbe.bottom;
     if avecAxeX then begin
          initAxeX;
          if voieOrphy[voieAbscisse].AxeLog
             then traceAxeLogX
             else traceAxeX;
          zeroX;
     end;
     if AnalyseurLogique
        then begin
           for voie := voieMin to voieMax do with voieOrphy[voie] do
            if active and (voie<>voieAbscisse) then
                if avecAxeY
                   then traceAxeY(voie)
                   else zeroY(voie);
         end
         else begin
             voie := succ(voieMin);
             while (voie<voieMax) and
                   (not(voieOrphy[voie].active) or (voie=voieAbscisse)) do
                inc(voie);
             if avecAxeY
                 then traceAxeY(voie)
                 else zeroY(voie);
         end;
     SetTextAlign(canvas.handle,TA_left+TA_top);
end;{ DrawAxis }

