unit capAutocfg;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, Tabs,
  Buttons, ExtCtrls, TabNotBk, sysUtils,
  gtiDef, gtiUtil, tradformU, ComCtrls, Spin, constGTI;

type
  TCapteurAutoCfgDlg = class(TTradForm)
    ButtonPanel: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Notebook: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GrandeurGB: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditNom: TEdit;
    EditUnite: TEdit;
    EditSignif: TEdit;
    AffichageGB: TGroupBox;
    GroupBox1: TGroupBox;
    PageControl1: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    pot2CB: TCheckBox;
    Pot0CB: TCheckBox;
    Pot1CB: TCheckBox;
    Pot3CB: TCheckBox;
    Aide2: TLabeledEdit;
    Valeur2: TLabeledEdit;
    Aide0: TLabeledEdit;
    Valeur0: TLabeledEdit;
    Aide3: TLabeledEdit;
    Valeur3: TLabeledEdit;
    Aide1: TLabeledEdit;
    Valeur1: TLabeledEdit;
    EditMini: TLabeledEdit;
    val0Edit: TLabeledEdit;
    PenteEdit: TLabeledEdit;
    EditMaxi: TLabeledEdit;
    CalibreCB: TComboBox;
    SigneTensionRG: TRadioGroup;
    TabSheet7: TTabSheet;
    pot4CB: TCheckBox;
    Aide4: TLabeledEdit;
    Valeur4: TLabeledEdit;
    procedure FormActivate(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
  public
    CapteurCourant : TCapteurAuto;
  end;

var
  CapteurAutoCfgDlg: TCapteurAutoCfgDlg;

implementation

{$R *.DFM}

procedure TCapteurAutoCfgDlg.FormActivate(Sender: TObject);
begin with capteurCourant do begin
     EditSignif.text := signifC;
     Aide0.text := aidePotar[0];
     Aide1.text := aidePotar[1];
     Aide2.text := aidePotar[2];
     Aide3.text := aidePotar[3];
     Aide4.text := aidePotar[4];
     Valeur0.text := FormatGTI(valeurAttendue[0]);
     Valeur1.text := FormatGTI(valeurAttendue[1]);
     Valeur2.text := FormatGTI(valeurAttendue[2]);
     Valeur3.text := FormatGTI(valeurAttendue[3]);
     Valeur4.text := FormatGTI(valeurAttendue[4]);
     Pot0CB.checked := PotarActif[0];
     Pot1CB.checked := PotarActif[1];
     Pot2CB.checked := PotarActif[2];
     Pot3CB.checked := PotarActif[3];
     Pot4CB.checked := PotarActif[4];
     calibreCB.itemIndex := ord(calibre);
     EditNom.text := nomC;
     EditUnite.text := nomUniteC;
     val0Edit.text := FormatGTI(offsetC);
     penteEdit.text := FormatGTI(unVoltC);
     penteEdit.EditLabel.caption := DeltaMaj+nomC+'/'+DeltaMaj+'V'+
         ' ('+nomUniteC+'/V)';
     EditMini.text := FormatGTI(miniAff);
     EditMaxi.text := FormatGTI(maxiAff);
     SigneTensionRG.itemIndex := ord(tensionC);
end end;

procedure TCapteurAutoCfgDlg.EditNomChange(Sender: TObject);
begin
     PenteEdit.EditLabel.caption := DeltaMaj+EditNom.text+'/'+DeltaMaj+'V'+
        ' ('+EditUnite.text+'/V)';
     AffichageGB.caption := 'Affichage ('+EditUnite.text+')';
end;

procedure TCapteurAutoCfgDlg.OKBtnClick(Sender: TObject);

Procedure setValeur(aedit : tLabeledEdit;var valeur : double);
begin
     try
     valeur := StrToFloatWin(aEdit.text);
     except
     end;
end;

begin with capteurCourant do begin
     signifC := EditSignif.text;
     aidePotar[0]:= Aide0.text;
     aidePotar[1] := Aide1.text;
     aidePotar[2] := Aide2.text;
     aidePotar[3] := Aide3.text;
     aidePotar[4] := Aide4.text;
     tensionC := Ttension(SigneTensionRG.itemIndex);
     calibre := TcalibreGTI(calibreCB.itemIndex);
     setValeur(valeur0,valeurAttendue[0]);
     setValeur(valeur1,valeurAttendue[1]);
     setValeur(valeur2,valeurAttendue[2]);
     setValeur(valeur3,valeurAttendue[3]);
     setValeur(valeur4,valeurAttendue[4]);
     PotarActif[0] := Pot0CB.checked;
     PotarActif[1] := Pot1CB.checked;
     PotarActif[2] := Pot2CB.checked;
     PotarActif[3] := Pot3CB.checked;
     PotarActif[4] := Pot4CB.checked;
     nomC := EditNom.text;
     nomUniteC := EditUnite.text;
     setValeur(val0Edit,OffsetC);
     setValeur(penteEdit,UnVoltC);
     setValeur(EditMini,miniAff);
     setValeur(EditMaxi,maxiAff);
end end;

procedure TCapteurAutoCfgDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(10)
end;

end.

