unit choixCapAuto;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Dialogs, SysUtils, gtiConst,
  gtiDef, graphe, gtiUtil, constgti, TradFormU;

type
  TCapteurAutoDlg = class(TtradForm)
    ListeCapteursBox: TListBox;
    EnregistreBtn: TBitBtn;
    ModifBtn: TBitBtn;
    ExitBtn: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure ModifBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    Modif : boolean;
    procedure MajListe;
  public
  end;

var
  CapteurAutoDlg: TCapteurAutoDlg;

implementation

uses capAutocfg;

{$R *.DFM}

procedure TCapteurAutoDlg.FormActivate(Sender: TObject);
begin
     capteurAutoCfgDlg := TcapteurAutoCfgDlg.create(self);
     MajListe;
     Modif := false;
end;

procedure TCapteurAutoDlg.EnregistreBtnClick(Sender: TObject);
begin
     SauveListeCapteurs;
     Modif := false;
end;

procedure TCapteurAutoDlg.ModifBtnClick(Sender: TObject);
begin
     capteurAutoCfgDlg.capteurCourant := listeCapteursAuto[listeCapteursBox.itemIndex+1];
     if capteurAutoCfgDlg.showModal=mrOk then begin
        MajListe;
        Modif := true;
     end;
end;

procedure TCapteurAutoDlg.ExitBtnClick(Sender: TObject);
begin
     if Modif and OKreg(trSaveModif) then EnregistreBtnClick(sender);
     Close
end;

Procedure TCapteurAutoDlg.MajListe;
var i : integer;
begin
     ListeCapteursBox.clear;
     for i := 1 to MaxCapteurAuto do
         ListeCapteursBox.items.Add(pad(intToStr(i),3)+
             Pad(ListeCapteursAuto[i].nomC,5)+
             ': '+ListeCapteursAuto[i].signifC);
     ListeCapteursBox.itemIndex := 0;
end;

procedure TCapteurAutoDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     capteurAutoCfgDlg.free
end;

end.
