unit Efront;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils,
  graphe, gtimain, gtiutil, gtidef, tradFormU, FloatEdit, ComCtrls;

type
  TEfrontDlg = class(TtradForm)
    EFrg: TRadioGroup;
    ActiveBtn: TBitBtn;
    DesactiveBtn: TBitBtn;
    Timer: TTimer;
    HelpBtn: TBitBtn;
    Parametres: TPageControl;
    FrequenceTS: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    MiniEdit: TFloatEdit;
    MaxiEdit: TFloatEdit;
    logCB: TCheckBox;
    Fcourante: TEdit;
    CompteurTS: TTabSheet;
    OffsetEdit: TEdit;
    IncrementEdit: TEdit;
    MiniCompteurEdit: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    GrandeurGB: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    EditNom: TEdit;
    EditUnite: TEdit;
    EditSignif: TEdit;
    CompteurCourant: TEdit;
    RazBtn: TBitBtn;
    MaxiCompteurEdit: TEdit;
    Label9: TLabel;
    IncrementBtn: TSpeedButton;
    ModeRG: TRadioGroup;
    procedure ActiveBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure EFrgClick(Sender: TObject);
    procedure MaxiEditChange(Sender: TObject);
    procedure MiniEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure EditUniteChange(Sender: TObject);
    procedure IncrementEditExit(Sender: TObject);
    procedure OffsetEditExit(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure IncrementBtnClick(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
  private
  public
  end;

var
  EfrontDlg: TEfrontDlg;

implementation

{$R *.DFM}

procedure TEfrontDlg.ActiveBtnClick(Sender: TObject);
begin with frequence do begin
    if not active then grapheGTI.voieAbscisse := voieF;
    active := true;
    if ModeRG.itemIndex=0
       then begin
         miniF :=  miniEdit.value;
         maxiF :=  maxiEdit.value;
         frequence.AxeLog := LogCB.checked;
         nom := 'f';
         nomUnite := 'Hz';
         signif := 'frquence';
       end
       else begin
          debutCompteur :=  strToFloatWin(OffsetEdit.text);
          mini :=  strToFloatWin(miniCompteurEdit.text);
          maxi :=  strToFloatWin(maxiCompteurEdit.text);
          increment :=  strToFloatWin(IncrementEdit.text);
          frequence.AxeLog := false;
          nom := EditNom.text;
          if nom='' then nom := 'f';          
          nomUnite := EditUnite.text;
          signif := editSignif.text;
       end;
end end;

procedure TEfrontDlg.DesactiveBtnClick(Sender: TObject);
begin
       frequence.active := false
end;

procedure TEfrontDlg.FormActivate(Sender: TObject);
begin with Frequence do begin
       EFrg.itemIndex := ord(EFi)-ord('0');
       Timer.enabled := true;
       Fcourante.text := '';
       MiniEdit.value := MiniF;
       MiniEdit.maxValue := MaxiF/10;
       MaxiEdit.value := MaxiF;
       MaxiEdit.minValue := MiniF*10;
       LogCB.checked := AxeLog;
       MaxiCompteurEdit.Text := formatGTI(maxi);
       MiniCompteurEdit.Text := formatGTI(mini);
       OffsetEdit.Text := formatGTI(debutCompteur);
       IncrementEdit.Text := formatGTI(increment);
       EditNom.text := Nom;
       EditUnite.text := NomUnite;
       EditSignif.text := Signif;
       incrementBtn.down := decrementer;
       CompteurTS.visible := grapheGTI.modeAcq<>AcqGP305;
       if frequence.modeEF0='M'
          then ModeRG.itemIndex := 1
          else ModeRG.itemIndex := 0;
end end;

procedure TEfrontDlg.FormDeactivate(Sender: TObject);
begin
     timer.enabled := false
end;

procedure TEfrontDlg.TimerTimer(Sender: TObject);
var f : double;
begin with frequence do begin
     f := GtiMainForm.litFrequence;
     if modeEF0='M'
        then begin
             valeurCourante := f;
             compteurCourant.text := NomValeurUnite(f);
        end
        else fcourante.text := NomValeurUnite(f);
end end;

procedure TEfrontDlg.EFrgClick(Sender: TObject);
begin with frequence do begin
      EFi := ansiChar(ord('0')+EFrg.itemIndex);
      NumeroOrphy := VoieOrphyEF0+EFrg.itemIndex;
      gtiMainForm.RegleFrequence;
end end;

procedure TEfrontDlg.MaxiEditChange(Sender: TObject);
begin
     MiniEdit.maxValue := MaxiEdit.value/10
end;

procedure TEfrontDlg.MiniEditChange(Sender: TObject);
begin
     MaxiEdit.minValue := MiniEdit.value*10
end;

procedure TEfrontDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Timer.enabled := false
end;

procedure TEfrontDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(8)
end;

procedure TEfrontDlg.EditUniteChange(Sender: TObject);
begin
    frequence.nomUnite := editUnite.text
end;

procedure TEfrontDlg.IncrementEditExit(Sender: TObject);
begin
    frequence.increment := strToFloatWin(IncrementEdit.text)
end;

procedure TEfrontDlg.OffsetEditExit(Sender: TObject);
begin
    frequence.debutCompteur := strToFloatWin(OffsetEdit.text)
end;

procedure TEfrontDlg.RazBtnClick(Sender: TObject);
begin with frequence do begin
   if ModeRG.itemIndex=0
      then valeurCourante := frequence.mini
      else begin
          valeurCourante := debutCompteur;
          compteurCourant.text := NomValeurUnite(valeurCourante)
      end;
end end;

procedure TEfrontDlg.IncrementBtnClick(Sender: TObject);
begin
     frequence.decrementer := incrementBtn.down
end;

procedure TEfrontDlg.ModeRGClick(Sender: TObject);
begin
   GrandeurGB.visible := ModeRG.itemIndex=1;
   if ModeRG.itemIndex=0
      then begin
         frequence.modeEF0 := 'F';
         Timer.interval := 10*55;
         Parametres.ActivePage := frequenceTS;
      end
      else begin
         frequence.modeEF0 := 'M';
         Timer.interval := 200;
         Parametres.ActivePage := compteurTS;
      end;
   gtiMainForm.RegleFrequence;
end;

end.
