unit optPro;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, TabNotBk, ComCtrls, fileCtrl,
  registry, Dialogs,
  constGTI, tradFormU, gtidef,  Mask, gtiutil, maths, magnumU;

type
  TOptionsDlg = class(TtradForm)
    Panel1: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label4: TLabel;
    FichierCapteurAff: TEdit;
    FiltrageRG: TRadioGroup;
    Label5: TLabel;
    IntervalEdit: TEdit;
    IntervalSE: TSpinEdit;
    VitesseComRG: TRadioGroup;
    HelpBtn: TBitBtn;
    Label6: TLabel;
    RepertGTIAff: TEdit;
    RepertGTIBTN: TSpeedButton;
    FileCapteurBtn: TSpeedButton;
    OpenDialog: TOpenDialog;
    WithDeltatCB: TCheckBox;
    CorrectionRG: TRadioGroup;
    SupprChute0CB: TCheckBox;
    NbreMaxRG: TRadioGroup;
    AvecRecoCB: TCheckBox;
    GrecCB: TCheckBox;
    DerniereConfigCB: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure IntervalSEChange(Sender: TObject);
    procedure RepertGTIBTNClick(Sender: TObject);
    procedure FileCapteurBtnClick(Sender: TObject);
  private
  public
  end;

var
  OptionsDlg: TOptionsDlg;

implementation

uses Gtimain;

{$R *.DFM}

procedure TOptionsDlg.OKBtnClick(Sender: TObject);
begin
    GtiMainForm.CfgGTIPath := repertGTIAff.text;
    GtiMainForm.MajTimer := IntervalSE.value*55;
    GtiMainForm.caractereGrecCtrl := grecCB.checked;
    SupprChute0 := SupprChute0CB.checked;
    if NomFichierCapteurs<>FichierCapteurAff.text then begin
        NomFichierCapteurs := FichierCapteurAff.text;
        ChargeListeCapteurs;
    end;
    gtiMainForm.SousEchantillon := boolean(filtrageRG.itemIndex);
    gtiMainForm.NbreInterMax :=  NbreMaxPossible[NbreMaxRG.itemIndex];
    gtimainForm.vitesseCom := VitesseComRG.itemIndex;
    gtiMainForm.withDeltat := WithDeltatCB.Checked;
    CorrectionMagnum := TcorrectionMagnum(CorrectionRG.ItemIndex);
    gtiMainForm.SauverConfig := DerniereConfigCB.checked;
    gtiMainForm.avecRecoAuto := avecRecoCB.checked;
end;

procedure TOptionsDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(806)
end;

procedure TOptionsDlg.FormActivate(Sender: TObject);
var i : integer;
begin
    DerniereConfigCB.checked := gtiMainForm.SauverConfig;
    CorrectionRG.ItemIndex := ord(CorrectionMagnum);
    avecRecoCB.checked := gtiMainForm.avecRecoAuto;
    FichierCapteurAff.text := NomFichierCapteurs;
    RepertGtiAff.text := gtiMainForm.CfgGtiPath;
    filtrageRG.itemIndex := ord(gtiMainForm.SousEchantillon);
    grecCB.checked := GtiMainForm.caractereGrecCtrl;
    for i := 0 to high(NbreMaxPossible) do
        if gtiMainForm.NbreInterMax=NbreMaxPossible[i] then
            NbreMaxRG.itemIndex := i;
    if NbreMaxRG.itemIndex<0 then NbreMaxRG.itemIndex := 0;
    IntervalEdit.text := intToStr(GtiMainForm.MajTimer);
    IntervalSE.value := GtiMainForm.MajTimer div 55;
    VitesseComRG.itemIndex := gtimainForm.vitesseCom;
    WithDeltatCB.Checked := gtiMainForm.withDeltat;
    SupprChute0CB.checked := SupprChute0;
end;

procedure TOptionsDlg.IntervalSEChange(Sender: TObject);
begin
   IntervalEdit.text := intToStr(round(IntervalSE.value*55))
end;

procedure TOptionsDlg.RepertGTIBTNClick(Sender: TObject);
var repertoire : string;
begin
   repertoire := GtiMainForm.CfgGTIPath;
   if SelectDirectory('Rpertoire *.GTI','',repertoire) then
        RepertGTIAff.text := repertoire
end;

procedure TOptionsDlg.FileCapteurBtnClick(Sender: TObject);
begin
    OpenDialog.filter := 'Fichier capteurs|*.cpt';
    if OpenDialog.Execute then
        FichierCapteurAff.Text := OpenDialog.FileName;
end;

end.
